;--------------------------------
;TP-C5.INC	ho	03-MAR-94
;--------------------------------
;6C30h-717Dh

		IDENT	TP-C5.INC

;Allokate space for data
;E: amount in DE
;V: F, HL
;R: <no return> if not enough space available, else address in HL
AllocDat:	LD	HL,(CDatStart)
		OR	A
		SBC	HL,DE		;new lower limit of data area
		CALL	ErrIfCarry	;< 0000h?
		DEFB	98		;Memory overflow
		LD	(CDatStart),HL
		JR	ChkCOverflow


;patch in PC in output afterwards
;E: PC in IY, address in HL
;V: AF, DE, HL / R:- (IY in DE)
PatchIY:	PUSH	IY
		POP	DE

;patch in word in output afterwards
;E: Wort in DE, address in HL
;V: AF, HL / R:-
PatchDE:	LD	A,(CCmpZiel)
		DEC	A		;destination = file?
		JR	Z,PatchObj
	;in memory: no problem!
		PUSH	IY
		PUSH	HL		;temporarily change PC
		POP	IY
		CALL	CmpOutDE
		POP	IY
		RET

PatchObj: ;patch word in DE at address in HL (in file)
	;for the moment, sort into list
		PUSH	BC
		PUSH	DE		;save word
		PUSH	HL		;save address
		LD	HL,(PatchList)
		LD	A,(PatchLen)	;number of list entries
		LD	B,A
		INC	B
PatchObj1:	DEC	B		;at end of list?
		JR	Z,PatchObj3	;yes, then add
		LD	E,(HL)		;address field
		INC	HL
		LD	D,(HL)
		EX	(SP),HL		;save pointer in liste, get my patch address
		OR	A
		SBC	HL,DE
		ADD	HL,DE		;my patch addr.smaller then this address?
		EX	(SP),HL
		JR	C,PatchObj2	;yes -> have to insert in between
		INC	HL		;no, advance to next entry
		INC	HL
		INC	HL
		JR	PatchObj1

PatchObj2: ;make place at current list position for new entry
		DEC	HL		;pointer to beginning of entry
		EX	DE,HL		;pointer to DE
		LD	L,B		;number of remaining list entries
		LD	H,0
		ADD	HL,HL
		ADD	HL,HL		;= remaining length
		LD	B,H		;that's how much we have to move
		LD	C,L
		ADD	HL,DE		;HL points behind list
		LD	D,H		;duplicate
		LD	E,L
		DEC	HL		;source = last element
		INC	DE		;destination = next element
		INC	DE
		INC	DE
		LDDR			;move forward (copy)
		INC	HL		;to beginning of free entry
PatchObj3: ;insert. HL points to free entry
		POP	DE		;destination address
		LD	(HL),E		;save it
		INC	HL
		LD	(HL),D
		INC	HL
		POP	DE		;word
		LD	(HL),E		;save it
		INC	HL
		LD	(HL),D
		POP	BC		;restore BC
		LD	HL,PatchLen	;increase list size
		INC	(HL)		;=256? (list full?)
		RET	NZ		;no, not yet -> finished
		XOR	A		;means 256, PatchLen is set to 0.
		JR	FlushPatch1

;Work off patch list. ATTENTION: PatchLen is not set to zero!
;E: PatchList, PatchLen
;V: AF, HL / R:-
FlushPatch:	LD	A,(PatchLen)
		OR	A		;list empty?
		RET	Z		;yes -> do nothing

FlushPatch1: ;A= size of list
		PUSH	BC
		PUSH	DE
		PUSH	IY
		LD	B,A
		LD	HL,(PatchList)
FlushPatch2:	PUSH	BC
		LD	E,(HL)		;destination address
		INC	HL
		LD	D,(HL)
		INC	HL
		PUSH	HL		;save pointer in list
		EX	DE,HL		;destination address to HL
		CALL	SeekObj		;seek to position
		POP	HL
		LD	B,(HL)		;write LowByte of word
		INC	HL
		PUSH	HL
		CALL	ObjOut
		POP	HL
		LD	B,(HL)		;write HighByte of word
		INC	HL
		PUSH	HL
		CALL	ObjOut
		POP	HL
		POP	BC
		DJNZ	FlushPatch2
		POP	HL		;was IY, i.e. move file pointer
		POP	DE		;to current end of output again
		POP	BC
;<fall through>

;Seek in ObjFile
;E: HL= address
;V: AF, IY / R: IY= address
SeekObj:	PUSH	HL
		POP	IY
		LD	A,(CCmpZiel)
		DEC	A		;output into file?
		RET	NZ		;no -> do nothing
		PUSH	DE
		PUSH	BC
		LD	DE,(CFilePC)	;convert address into file offset
		OR	A
		SBC	HL,DE
		LD	A,L
		AND	7Fh		;MOD SecSize
		LD	(ObjSecPtr),A
		ADD	HL,HL
		LD	L,H
		RLA
		AND	1
		LD	H,A		;DIV SecSize
		LD	DE,(ObjOffset)	;+ number of sectors offset in ObjDatei
		ADD	HL,DE
		LD	DE,(ObjFCB+33)
		OR	A
		SBC	HL,DE
		ADD	HL,DE		;same sector?
		JR	Z,SeekObj1	;yes -> don't write
		PUSH	HL		;no, flush sector previously worked on
		CALL	WriteObjSec
		POP	HL
		LD	(ObjFCB+33),HL	;let data pointer point to new position
SeekObj1:	POP	BC
		POP	DE
		RET

;read sector into SecBuf (from Obj file)
ReadObjSec:	LD	C,ReadRand
		JR	RWObjSec

;write back sector in SecBuf if modified (to Obj file)
WriteObjSec:	LD	HL,ObjSecFlags
		SET	0,(HL)		;sector has to be read in
		BIT	1,(HL)		;sector must be written?
		RET	Z		;no -> finished
		RES	1,(HL)
		LD	C,WriteRand
RWObjSec:	PUSH	BC
		LD	DE,SecBuf
		LD	C,SetDMA
		CALL	SBDOS
		POP	BC
		LD	DE,ObjFCB
		CALL	SBDOS
		OR	A		;ok
		RET	Z
		DEC	A		;Reading unwritten data
		RET	Z
		CP	3		;Seek to unwritten extent
		RET	Z
		CALL	ErrAlways
		DEFB	0FAh		;Disk or directory full


;L7B64 put 13 byte on stack
L6D24:		EXX
		LD	DE,L7B64
		JR	L6D2E

;L7B57 put 13 byte on stack
L6D2A:		EXX
		LD	DE,L7B57
L6D2E:		POP	HL		;return address
		LD	(L7BD5),HL	;save it
		LD	HL,-13
		ADD	HL,SP
		LD	SP,HL
		EX	DE,HL
		LD	BC,13
		LDIR
L6D3D:		LD	HL,(L7BD5)	;saved
		PUSH	HL		;return address
		EXX
		RET

;get 13 byte from stack to L7B64
L6D43:		EXX
		LD	DE,L7B64
		JR	L6D4D

;get 13 byte from stack to L7B57
L6D49:		EXX
		LD	DE,L7B57
L6D4D:		POP	HL		;save return address
		LD	(L7BD5),HL
		LD	HL,0
		ADD	HL,SP
		LD	BC,13
		LDIR
		LD	SP,HL
		JR	L6D3D

;duplicate 13 byte from stack to L7B64
L6D5D:		EXX
		LD	DE,L7B64
		JR	L6D67

;duplicate 13 byte from stack to L7B57
L6D63:		EXX
		LD	DE,L7B57
L6D67:		LD	HL,2		;behind return address
		ADD	HL,SP
		LD	BC,13
		LDIR
		EXX
		RET


;store IY in symbol area
WriteSymIY:	PUSH	IY
		POP	DE
;<fall through>

;store DE in symbol area
WriteSymDE:	LD	A,D
		CALL	WriteSymA
		LD	A,E
;<fall through>

;store A in symbol area
WriteSymA:	PUSH	HL
		LD	HL,(TmpSymStart)
		LD	(HL),A
		DEC	HL		;backwards
		LD	(TmpSymStart),HL
		POP	HL
		JP	ChkCOverflow


;scan identifier and store it
;has to begin with letter and mustn't exist before
;(but pre-defined is ok), mustn't be keyword
ScanNewSym:	LD	A,(IX)
		CALL	IsAlpha

;scan identifier and store it
;mustn't exist before (but pre-defined is ok),
;mustn't be keyword
;E: Carry if previous test went wrong
ScanNewSym1:	CALL	ErrIfCarry
		DEFB	58		;Illegal character in identifier
		CALL	NeedNoSym	;mustn't exist before

;scan identifier and store it
ScanSym:	CALL	NeedNoKeyW
		LD	A,(IX)
ScanSym1:	CP	'a'		;ToUpper
		JR	C,ScanSym2
		CP	'z'+1
		JR	NC,ScanSym2
		SUB	20h
ScanSym2:	CALL	WriteSymA	;store character
		INC	IX
		LD	A,(IX)
		CALL	IsAlnum
		JR	NC,ScanSym1
		LD	HL,(TmpSymStart)
		INC	HL
		SET	7,(HL)		;mark end
		JP	ScanSpace

;scan identifier and store it
;has to begin with letter, may already exist, mustn't be keyword
ScanEgalSym:	LD	A,(IX)
		CALL	IsAlpha
		CALL	ErrIfCarry
		DEFB	58		;Illegal character in identifier
		JR	ScanSym

;add new entry in symbol area
;(add length and make permanent)
EnterSymbol:	LD	HL,(SymStart)	;calculate length
		LD	DE,(TmpSymStart)
		OR	A
		SBC	HL,DE
		EX	DE,HL
		CALL	WriteSymDE	;store
		LD	HL,(TmpSymStart) 
		LD	(SymStart),HL	;make permanent
		RET

;E: record-ident in C, desired type of symbol in B
;   SymEnd bzw. DefSymEnd, old record-ident in L7BC0
;   old values of L7BC1, L7BC2, L7BC4
;V: AF, DE, HL
;R: if record-ident =L7BC0:
;   A= L7BC1, HL= L7BC2, DE= L7BC4 (unchanged), Zero iff L7BC1 desired type
;   else: L7BC0= record-ident
;   if name not found: L7BC1 =0 and A=0FFh and NZero
;   else: A= L7BC1 = type, Zero iff desired type, HL= L7BC2 = pointer to
;   additional info in symbol area, DE= L7BC4 = pointer behind name in source
SearchSym:	LD	HL,(SymEnd)	;without predefined ones
		JR	SearchSym1

SearchDefSym:	LD	HL,(DefSymEnd)	;with predefined ones
SearchSym1:	LD	(L7B7D),HL	;end address for search
		LD	A,(L7BC0)
		CP	C
		JR	Z,SearchSym8	;return old values once again
		LD	A,C
		LD	(L7BC0),A
		LD	HL,(SymStart)	;start address of search
SearchSym2:	LD	DE,(L7B7D)
		XOR	A
		SBC	HL,DE
		ADD	HL,DE		;end reached?
		JR	NZ,SearchSym3	;no -> continue searching
		XOR	A
		LD	(L7BC1),A
		DEC	A		;=0FFh, NZero
		RET

SearchSym3:	INC	HL		;get length of entry
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		ADD	HL,DE		;address end
		LD	A,(HL)		;type of entry
		OR	A		;type description?
		JR	Z,SearchSym2	;yes -> ignore
		DEC	HL
		LD	A,(HL)		;record-ident
		INC	HL
		CP	C		;ok?
		JR	NZ,SearchSym2	;no -> continue searching
	;we have a possible match. Compare names
		PUSH	IX
		POP	DE		;pointer to name to DE
		PUSH	BC		;save registers
		PUSH	HL
		DEC	HL
		DEC	HL		;first character of name
SearchSym4:	LD	B,(HL)
		LD	A,(DE)
		DEC	HL
		INC	DE
		LD	C,B		;save end marker
		RES	7,B		;delete end marker
		CP	'a'		;ignore case
		JR	C,SearchSym5
		CP	'z'+1
		JR	NC,SearchSym5
		SUB	20h
SearchSym5:	CP	B		;equal?
		JR	NZ,SearchSym6	;no -> next symbol
		BIT	7,C		;end of name?
		JR	Z,SearchSym4	;no -> continue comparing
		LD	A,(DE)		;next char not alphanumeric,
		CALL	IsAlnum		;i.e. name completed?
		JR	C,SearchSym7	;yes -> found it!
SearchSym6:	POP	HL
		POP	BC
		JR	SearchSym2

SearchSym7: ;found
		LD	(L7BC2),HL	;save pointer to additional info in symbol area
		LD	(L7BC4),DE	;save pointer begind name in source
		POP	HL		;restore registers
		POP	BC
		LD	A,(HL)		;type of entry
		LD	(L7BC1),A
SearchSym8:	LD	HL,(L7BC2)
		LD	DE,(L7BC4)
		LD	A,(L7BC1)
		CP	B
		RET

;Look if symbol is following. Must exist, may be predefined
;E: record-ident in C, desired type of symbol in B
;V: AF, DE, HL, IX
;R: Zero if ok
ScanExistSym:	CALL	SearchDefSym
		RET	NZ
		JR	AcceptIt	;advance input pointer

;Look if the following text can be found in given table
;E: field width, pointer to table in (SP)
;V: (SP), AF, BC, DE, HL, IX
;R: NZero if not in table
;   A=0 and Zero if found, HL points behind sample text
;   (to data part of entry that was found)
CompareTbl:	EX	(SP),HL
		LD	C,(HL)		;number of bytes between
		INC	HL		;two sample texts
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		INC	HL
		EX	(SP),HL
		EX	DE,HL
;<fall through>

;Look if the following text can be found in given table
;E: C= field width, HL= pointer to table
;V: (SP), AF, BC, DE, HL, IX
;R: NZero if not in table
;   A=0 and Zero if found, HL points behind sample text
;   (to data part of entry that was found)
CompareTbl1:	CALL	CompareTxt	;compare single text
		RET	Z		;leave if found
		DEC	HL		;restore to last character compared
CompareTbl2: ;advance to next sample text: first to end of
	;previous sample text, then across data part
		BIT	7,(HL)		;end?
		INC	HL
		JR	Z,CompareTbl2
		LD	B,0		;extend field width to word
		ADD	HL,BC
		LD	A,(HL)		;first char of next
		OR	A		;sample text. =0?
		JR	NZ,CompareTbl1	;no -> continue searching
	;End of table. Sorry, you loose.
		DEC	A		;=0FFh NZero
		RET

;Look if certain text follows
;E: pointer to sample text in (SP)
;V: (SP), AF, DE, HL, IX
;R: A=0 and Zero if not found
;   HL points behind last character compared of sample text
CompareNam:	EX	(SP),HL
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		INC	HL
		EX	(SP),HL
		EX	DE,HL
;<fall through>

;Look if certain text follows (if identifier, pay attention that they match
;completely, i.e. that we don't have only a prefix)
;Sample texts may be
;a) strings of alphanumeric characters, beginning with a letter
;   (e.g. keywords, identifier) or
;b) strings of special characters (e.g. operators)
;Mixes of special characters and letters don't occur and are not allowed
;here because this routine discernes case a) from case b) by inspecting
;the first char of the sample text!
;In the case b) there may be any char following is (e.g. 'a:=i*5+(17-3)',
;':=i' is ok), but in case a) not! The following char must be a non-
;alphanumeric char, else the identifier is not complete (e.g. when reading
;'PROCEDUREa(x,y)' finding 'PROCEDURE' is not ok).
;E: pointer to sample text in HL
;V: AF, DE, HL, IX
;R: A=0 and Zero if found
;   HL points behind the last compared character of the sample text
CompareTxt:	PUSH	IX
		POP	DE
		LD	A,(HL)
		CALL	IsAlpha		;does the sample text begin with a letter?
		JR	C,CompareTxt1	;no -> don't care about what follows
		CALL	CompareTx
		RET	NZ		;didn't match
		LD	A,(DE)
		CALL	IsAlnum		;is something remaining?
		JR	C,AcceptIt	;no -> well that's ok
		OR	A		;set NZero
		RET

CompareTxt1: ;ignore what's following
		CALL	CompareTx
		RET	NZ

AcceptIt: ;advance input pointer
		PUSH	DE
		POP	IX
		JP	ScanSpace

;Look if certain text follows
;(ignoring what follows that)
;E: DE= pointer in source text, HL= pointer to sample text
;V: AF, DE, HL
;R: DE points behind the last compared character of the source,
;   HL  "			"		 of the sample text
;   A=0 and Zero if we have a match (ignoring case),
;   else A=offending char and NZero
CompareTx:	PUSH	BC
CompareTx1:	LD	B,(HL)
		LD	A,(DE)
		INC	HL
		INC	DE
		LD	C,B		;save end mark
		RES	7,B		;clear end mark
		CP	'a'		;source char -> upper case
		JR	C,CompareTx2
		CP	'z'+1
		JR	NC,CompareTx2
		SUB	20h
CompareTx2:	CP	B		;equal?
		JR	NZ,CompareTx3	;no -> exit with NZero
		BIT	7,C		;finished?
		JR	Z,CompareTx1	;no -> compare next char
		XOR	A		;set Zero
CompareTx3:	POP	BC
		RET

;Look for no keyword
;<no return> if keyword
NeedNoKeyW:	LD	HL,MasterTbl	;Lord of the tables: 'One to bind them all'
NeedNoKey1:	LD	C,(HL)
		INC	C		;=0FFh? (end?)
		RET	Z		;is ok
		DEC	C
		INC	HL
		LD	E,(HL)		;get address of next table
		INC	HL
		LD	D,(HL)
		INC	HL
		PUSH	HL
		EX	DE,HL
		CALL	CompareTbl1	;search table
		POP	HL
		JR	NZ,NeedNoKey1	;not found, that's ok
		CALL	ErrAlways
		DEFB	53		;Reserved word

;Look for symbol that is yet undefined (or predefined)
;E: type in B, record-ident in L7B91
;V: AF, C, DE, HL
;R: <no return> if symbol already exists
NeedNoSym:	LD	A,(L7B91)
		LD	C,A
		CALL	SearchSym
		LD	A,(L7BC1)
		OR	A		;found?
		RET	Z		;no -> that's ok
		CALL	ErrAlways
		DEFB	43		;Duplicate identifier or label

;Scan '[' or '(.' (NZero if not found)
ScanEckAuf:	LD	A,'['
		CALL	ScanA
		RET	Z
	;not found, maybe (. instead of [
		LD	A,(IX)
		CP	'('
		RET	NZ
		LD	A,(IX+1)
		CP	'.'
		RET	NZ
ScanEck1:	INC	IX
		JP	InpScanSpace

;Scan ']' or '.)' (NZero if not found)
ScanEckZu:	LD	A,']'
		CALL	ScanA
		RET	Z
		LD	A,(IX)
		CP	'.'
		RET	NZ
		LD	A,(IX+1)
		CP	')'
		RET	NZ
		JR	ScanEck1

;Scanne ':' (NZero if not found)
ScanColon:	LD	A,':'
		JR	ScanA

;Scanne ';' (NZero if not found)
ScanSemi:	LD	A,';'
		JR	ScanA

;Scanne ',' (NZero if not found)
ScanComma:	LD	A,','
		JR	ScanA

;Scanne '.' (NZero if not found)
ScanDot:	LD	A,'.'
		JR	ScanA

;Scanne '(' (NZero if not found)
ScanRundAuf:	LD	A,'('
		JR	ScanA

;Scanne ')' (NZero if not found)
ScanRundZu:	LD	A,')'
		JR	ScanA

;Scanne '=' (NZero if not found)
ScanEqual:	LD	A,'='
		JR	ScanA

;Scanne '^' (NZero if not found)
ScanCaret:	LD	A,'^'
;<fall through>

;E: character in A
;V: AF, IX
;R: Zero if character found and IX advanced, else NZero
ScanA:		CP	(IX)
		RET	NZ
		JP	InpScanSpace

;Error if next character is not '[' or '(.'
NeedEckAuf:	CALL	ScanEckAuf
		RET	Z
		CALL	ErrAlways
		DEFB	8		;'[' expected

;Error if next character is not ']' or '.)'
NeedEckZu:	CALL	ScanEckZu
		RET	Z
		CALL	ErrAlways
		DEFB	9		;']' expected

;Error if next character is not ':'
NeedColon:	CALL	ScanColon
		RET	Z
		CALL	ErrAlways
		DEFB	2		;':' expected

;Error if next character is not ';'
NeedSemi:	CALL	ScanSemi
		RET	Z
NeedSemi1:	CALL	ErrAlways
		DEFB	1		;';' expected

;Error if next character is not ';'
;(controlled by L7B98)
L6F50:		CALL	ScanSemi
		RET	Z
		LD	A,(L7B98)
		OR	A
		JR	Z,NeedSemi1
		CALL	ErrAlways
		DEFB	41		;Unknown identifier or syntax error

;Error if next character is not ','
NeedComma:	CALL	ScanComma
		RET	Z
		CALL	ErrAlways
		DEFB	3		;',' expected

;Error if next character is not '('
NeedRundAuf:	CALL	ScanRundAuf
		RET	Z
		CALL	ErrAlways
		DEFB	4		;'(' expected

;Error if next character is not ')'
NeedRundZu:	CALL	ScanRundZu
		RET	Z
		CALL	ErrAlways
		DEFB	5		;')' expected

;Error if next character is not '='
NeedEqual:	CALL	ScanEqual
		RET	Z
		CALL	ErrAlways
		DEFB	6		;'=' expected

;Error if next token is not ':='
NeedAssign:	CALL	CompareNam
		DEFW	ASSIGNnam
		RET	Z
		CALL	ErrAlways
		DEFB	7		;':=' expected

;Error if next token is not 'OF'
NeedOF:		CALL	CompareNam
		DEFW	OFnam
		RET	Z
		CALL	ErrAlways
		DEFB	15		;OF expected

;Advance one char and then over spaces/comments.
;Come here if we have already examined the char in (IX) and found it valid
;and want the next one.
InpScanSpace:	CALL	BufInput
;<fall through>

;Advance over spaces/comments.
;E:-
;V: AF, IX
;R: IX points to char, A=0 and Zero
;Special service for evaluation routines:
;If they have scanned a token successfully they only have to jump here.
;This routine returns Zero to indicate 'ok'.
;There are far too much variables references/modified to list them all here.
ScanSpace:	XOR	A
		LD	(L7B98),A
		DEC	A		;=0FFh
		LD	(L7BC0),A
		LD	A,(IX)		;next char
	;skip end of line, space and tab
		OR	A
		JR	Z,InpScanSpace
		CP	' '
		JR	Z,InpScanSpace
		CP	TAB
		JR	Z,InpScanSpace
	;look if comment starts
		CP	'('
		JR	Z,ScanSpc2
		CP	'{'
		JR	Z,ScanSpc3
ScanSpc1:	XOR	A
		RET

ScanSpc2: ;found '('. Does '*' follow?
		LD	A,(IX+1)
		CP	'*'
		JR	NZ,ScanSpc1	;no, no comment
		CALL	BufInput
ScanSpc3: ;comment. Is it a compiler directive?
		PUSH	BC
		LD	B,(IX)		;remember if we had '{' or '(*'
		LD	A,(IX+1)
		CP	'$'
		JR	Z,ScanSpc8
ScanSpc4: ;normal comment. Skip it (i.e. search for '}' or '*)')
		CALL	BufInput
ScanSpc5:	LD	A,B
		CP	'*'		;was it '*)'?
		LD	A,(IX)
		JR	NZ,ScanSpc6	;no -> then search for '}'
	;search for '*)'
		CP	B
		JR	NZ,ScanSpc4
		LD	A,(IX+1)
		CP	')'
		JR	NZ,ScanSpc4
		CALL	BufInput
		JR	ScanSpc7

ScanSpc6: ;search for '}'
		CP	'}'
		JR	NZ,ScanSpc4
ScanSpc7: ;found end of comment, continue normally
		POP	BC
		JR	InpScanSpace

ScanSpc8: ;compiler directives.
		PUSH	BC
		PUSH	DE
		PUSH	HL
		CALL	BufInput
ScanSpc9: ;a single directive
		CALL	BufInput
		LD	A,(IX)
		CALL	ToUpper
	;evaluate 'IRAUXVBC' (these all fit into one byte)
		CP	'I'
		LD	B,01h		;bit 0 = I
		JR	Z,ScanSpc11
		CP	'R'
		LD	B,02h		;bit 1 = R
		JR	Z,ScanSpc11
		CP	'A'
		LD	B,04h		;bit 2 = A
		JR	Z,ScanSpc11
		CP	'U'
		LD	B,08h		;bit 3 = U
		JR	Z,ScanSpc11
		CP	'X'
		LD	B,10h		;bit 4 = X
		JR	Z,ScanSpc11
		CP	'V'
		LD	B,20h		;bit 5 = V
		JR	Z,ScanSpc11
		CP	'B'
		LD	B,40h		;bit 6 = B
		JR	Z,ScanSpc11
		CP	'C'
		LD	B,80h		;bit 7 = C
		JR	Z,ScanSpc11
	;'W' separately
		CP	'W'
		JR	Z,ScanSpc15
	;ignore 'K' and 'D'
		LD	B,0		;don't change a bit
		CP	'K'		;just look for +/-
		JR	Z,ScanSpc11
		CP	'D'
		JR	Z,ScanSpc11
	;ignore 'F', 'G' and 'P'
		CP	'F'		;just look for number
		JR	Z,ScanSpc16
		CP	'G'
		JR	Z,ScanSpc16
		CP	'P'
		JR	Z,ScanSpc16
		CALL	ErrAlways
		DEFB	93		;Illegal compiler option

ScanSpc10: ;leave evaluation of directives
		POP	HL
		POP	DE
		POP	BC
		JR	ScanSpc5	;treat remaining chars as normal comment

ScanSpc11: ;evaluate directive
		CALL	BufInput
		LD	A,(IX)
		LD	C,0		;'+' = add bit mask in B
		CP	'+'
		JR	Z,ScanSpc12
		DEC	C		;'-' = subtract bit mask in B
		CP	'-'
		JR	Z,ScanSpc12
	;neither '+' nor '-', this is only allowed with $I
		DEC	B
		CALL	ErrIfNZero
		DEFB	93		;Illegal compiler option
		JR	ScanSpc17

ScanSpc12: ;set flag
		LD	HL,CDirektiv
		LD	A,(HL)
		XOR	C
		OR	B		;add/subtract bit mask
		XOR	C
		LD	(HL),A
ScanSpc13:	CALL	BufInput
ScanSpc14: ;finished with single directive. Does another follow?
		LD	A,(IX)
		CP	','
		JP	Z,ScanSpc9	;yes -> once again
		JR	ScanSpc10

ScanSpc15: ;directive 'W'
		CALL	BufInput
		LD	A,(IX)
		CALL	IsNumber
		CALL	ErrIfCarry
		DEFB	93		;Illegal compiler option
		SUB	'0'
		LD	(CDirektW),A
		JR	ScanSpc13

ScanSpc16: ;ignore directives 'F', 'G' and 'P'
		CALL	BufInput
		LD	A,(IX)
		CALL	IsNumber
		JR	NC,ScanSpc16
		JR	ScanSpc14

ScanSpc17: ;$I without +/- following: Include
	;skip spaces
		CP	' '
		JR	NZ,ScanSpc18
		CALL	BufInput
		LD	A,(IX)
		JR	ScanSpc17

ScanSpc18:	LD	A,(CInclude)
		OR	A		;are we already in an include file?
		CALL	ErrIfNZero	;yes -> error
		DEFB	96		;Nested include
		PUSH	IX		;current source address, begin
		POP	DE		;parsing file name here
		CALL	ParsePAS
		PUSH	DE		;points behind parsed file name,
		POP	IX		;that's where we continue reading
		LD	DE,DefaultFCB
		PUSH	DE
		LD	C,OpenFile
		CALL	SBDOS
		POP	HL
		INC	A
		CALL	ErrIfZero
		DEFB	90		;File not found
		LD	DE,InclFCB
		LD	BC,FCBSize
		LDIR
		LD	A,(CCmpZiel)
		DEC	A		;destination = file?
		JR	Z,ScanSpc19
	;no, then this is the only open file and we don't have to buffer
	;much, the sector buffer is enough
		LD	HL,SecBuf
		LD	(InclBufStart),HL
		LD	HL,SecBuf+SecSize ;end address
		LD	A,1		;1 sector
		JR	ScanSpc20

ScanSpc19:	LD	HL,(TmpSymStart)
		LD	DE,(L7BE1)
		LD	(InclBufStart),DE
		OR	A
		SBC	HL,DE
		SRL	H		;half of the free space
		RR	L
		LD	A,H		;less than 2 sectors?
		OR	A
		CALL	ErrIfZero
		DEFB	99		;Compiler overflow
		LD	A,L		;round down to multiple of sector size
		AND	80h
		LD	L,A
		PUSH	HL
		ADD	HL,HL		;determine number of sectors
		LD	A,H
		POP	HL
		ADD	HL,DE		;end address := start address + size
ScanSpc20: ;HL= end address, A= size in sectors
		LD	(InclBufEnd),HL
		LD	(InclBufPtr),HL	;nothing read in yet
		LD	(InclBufSize),A
		LD	(CInclude),A	;<>0
		LD	HL,0		;set char counter to zero
		LD	(InclChars),HL
		LD	A,(CDirektiv)	;freeze compiler directives of the MainFile
		LD	(OldDirektiv),A
		LD	A,(CDirektW)
		LD	(OldDirektW),A
		JP	ScanSpc10


;Get one character from source (line buffered, with activity output)
;E: IX points in line buffer
;V: AF, IX
;R: <no return> if break or unexpected end of file
;   A= character read, Zero if CR or EOF
;   IX points to next character (0 if end of line)
;There are far too much variables references/modified to list them all here.
BufInput:	LD	A,(IX)		;get next character
		INC	IX
		OR	A		;end of line?
		RET	NZ		;no -> return character
	;read in new line
		PUSH	BC
		PUSH	DE
		PUSH	HL
		LD	A,(CEofReached)
		OR	A		;end of file reached?
		CALL	ErrIfNZero
		DEFB	91		;Unexpected end of source
		LD	HL,(MainPtr)	;save beginning of line (MainFile)
		LD	(MainLnStart),HL
		LD	HL,(InclChars)	;dito (IncludeFile)
		LD	(InclLnStart),HL
		LD	HL,LineBuffer
		PUSH	HL
		POP	IX
		LD	B,7Fh		;max. length of line
BufInput1:	PUSH	HL
		PUSH	BC
		CALL	RawInput
		POP	BC
		POP	HL
		CP	CR		;end of line?
		JR	Z,BufInput5
		CP	EOF		;end of source?
		JR	Z,BufInput4
		CP	TAB
		JR	Z,BufInput2	;tab is ok
		CP	' '
		JR	C,BufInput1	;ignore other control characters
BufInput2:	DJNZ	BufInput3
	;line too long, ignore tail
		INC	B		;=1
		JR	BufInput1

BufInput3: ;put character in line buffer
		LD	(HL),A
		INC	HL
		JR	BufInput1

BufInput4: ;end of source
		LD	(CEofReached),A	;=EOF
		CALL	Alive		;increment for the last time
		CALL	Alive1		;output
		JR	BufInput6

BufInput5: ;end of line
		CALL	Alive		;increment line
BufInput6: ;we still have Zero, A is still CR or EOF!
		LD	(HL),0		;terminate line
		POP	HL
		POP	DE
		POP	BC
		RET

;END OF TP-C5.INC
;----------------
