;--------------------------------
;TP-C6.INC	ho	04-MAR-94
;--------------------------------
;717Eh-78FFh

		IDENT	TP-C6.INC

;Increment line counter, sign of life every 16 lines
;E: CInclude, CLines
;V:- / R: <no return> if break
Alive:		PUSH	AF
		PUSH	HL
		LD	HL,(CLines)
		INC	HL
		LD	(CLines),HL
		LD	A,L
		AND	0Fh		;multiple of 16?
		JR	Z,Alive2	;yes -> sign
		POP	HL
		POP	AF
		RET

;Sign of life (I xx lines)
;E: CInclude, CLines
;V:- / R: <no return> if break
Alive1:		PUSH	AF
		PUSH	HL
Alive2:		PUSH	BC
		PUSH	DE
		PUSH	IX
		PUSH	IY
		LD	A,CR		;to beginning of line
		CALL	SConOut
		LD	A,(CInclude)
		OR	A		;in include file?
		JR	Z,Alive3	;no -> no 'I'
		LD	A,'I'
		JR	Alive4

Alive3:		LD	A,' '
Alive4:		CALL	SConOut
		LD	A,' '
		CALL	SConOut
		LD	HL,(CLines)
		CALL	PrintInt1
		CALL	ConSta		;keystroke?
		OR	A
		JR	Z,Alive6	;no -> don't ask
		CALL	Print
		DEFB	'   *** Abort compilation',0
		CALL	YesNo
		CALL	ErrIfNZero
		DEFB	0CAh		;Compilation aborted
		LD	B,32
Alive5:		CALL	Print
		DEFB	BS,' ',BS,0
		DJNZ	Alive5
Alive6:		POP	IY
		POP	IX
		POP	DE
		POP	BC
		POP	HL
		POP	AF
		RET


;Get source character (raw)
;E:-
;V: AF, B, DE, HL
;R: character in A, Zero if EOF
;There are far too much variables referenced/modified to list them all.
RawInput:	LD	A,(CInclude)
		OR	A		;in include file?
		JR	NZ,RawInput2	;yes -> read from file

RawInput1: ;read from MainFile (in memory)
		LD	HL,(MainPtr)
		LD	A,(HL)
		CP	EOF
		RET	Z
		INC	HL
		LD	(MainPtr),HL
		RET

RawInput2: ;read from include file. Still something in buffer?
		LD	HL,(InclBufPtr)
		LD	DE,(InclBufEnd)
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		JR	C,RawInput6	;yes -> get it
	;buffer is empty. Fill buffer with next chunk of include file
		LD	DE,(InclBufStart)
		LD	A,(InclBufSize)
		LD	B,A
RawInput3:	PUSH	BC
		PUSH	DE
		LD	C,SetDMA
		CALL	SBDOS
		LD	DE,InclFCB
		LD	C,ReadSeq
		CALL	SBDOS
		POP	DE
		POP	BC
		OR	A		;end of file?
		JR	NZ,RawInput4	;yes -> stop reading
		LD	HL,SecSize
		ADD	HL,DE
		EX	DE,HL
		DJNZ	RawInput3
		JR	RawInput5

RawInput4: ;end of file reached, mark end in buffer
		LD	A,EOF
		LD	(DE),A
		INC	DE
		LD	(InclBufEnd),DE
RawInput5:	LD	HL,(InclBufStart)
RawInput6: ;buffer contains something. Get character from buffer
		LD	A,(HL)
		INC	HL
		LD	(InclBufPtr),HL
		CP	EOF		;end of file?
		JR	NZ,RawInput7	;no -> increment
	;end of include file
		XOR	A
		LD	(CInclude),A
		LD	A,(OldDirektiv)	;restore frozen compiler
		LD	(CDirektiv),A	;directives of MainFile
		LD	A,(OldDirektW)
		LD	(CDirektW),A
		JR	RawInput1	;continue reading from MainFile

RawInput7: ;increment character counter (in case of error)
		LD	HL,(InclChars)
		INC	HL
		LD	(InclChars),HL
		RET


;call BDOS preserving IX and IY
SBDOS:		PUSH	IX
		PUSH	IY
		CALL	BDOS
		POP	IY
		POP	IX
		RET


;alpha = A-Z,_,a-z
;E: char in A / V: F
;R: NCarry if alpha, else Carry
IsAlpha:	CP	'A'
		RET	C
		CP	'Z'+1
		CCF
		RET	NC
		CP	'_'
		RET	Z
		CP	'a'
		RET	C
		CP	'z'+1
		CCF
		RET


;alphanum = 0-9,A-Z,_,a-z
;E: char in A / V: F
;R: NCarry if alphanum, else Carry
IsAlnum:	CALL	IsAlpha
		RET	NC
;<fall through>


;number = 0-9
;E: char in A / V: F
;R: NCarry if number, else Carry
IsNumber:	CP	'0'
		RET	C
		CP	'9'+1
		CCF
		RET


;compare 2 integers
;E: HL, DE / V: AF
;R:  Carry	  if HL < DE
;   NCarry,  Zero if HL = DE
;   NCarry, NZero if HL > DE
CCompInts:	LD	A,H
		XOR	D		;minus if HL and DE have
		LD	A,H		;different sign
		JP	M,CCompInts1
		CP	D		;when signs equal compare
		RET	NZ		;HighBytes first
		LD	A,L		;if that isn't enough, then
		CP	E		;compare LowBytes too
		RET

;Sign of HL and DE different. Whether HL or DE is the bigger integer
;depends only on the sign of HL (or DE).
CCompInts1:	RLA			;move sign of HL -> Carry
		RET


;multiplication X * Y (16 x 16 -> 16 bit, unsigned)
;E: X in HL, Y in DE
;V: AF, BC, DE, HL
;R: Carry if overflow, else X * Y in HL
CMultInt:	LD	B,H		;Y to BC
		LD	C,L
		LD	HL,0		;initialise 16 bit accu
		LD	A,16		;loops
CMultInt1:	ADD	HL,HL		;shift left accu
		RET	C		;catch overflow
		EX	DE,HL
		ADD	HL,HL		;shift left Y
		EX	DE,HL
		JR	NC,CMultInt2	;if bit fell out then
		ADD	HL,BC		;add X to accu
		RET	C		;catch overflow
CMultInt2:	DEC	A
		JR	NZ,CMultInt1
		RET


;division X / Y (unsigned)
;E: X in HL, Y in DE
;V: AF, BC, DE, HL
;R: X div Y in HL, X mod Y in DE
;CDivInt:	?? unused ??
		LD	B,D		;Y to BC
		LD	C,E
		EX	DE,HL		;X to DE
		XOR	A		;clears Carry
		LD	H,A
		LD	L,A
		LD	A,17
	;HL and DE form a 32 bit shift register. Every cycle
	;HL gets a bit from X and a bit of the result is shifted
	;into DE
CDivInt1:	ADC	HL,HL
		SBC	HL,BC		;everytime Y fits in
		JR	NC,CDivInt2	;a 1 is shifted into the result
		ADD	HL,BC		;else a 0.
		SCF
CDivInt2:	CCF
		RL	E
		RL	D
		DEC	A
		JR	NZ,CDivInt1
		EX	DE,HL
		RET


;check for error (Carry)
;E: error code behind subroutine call, N/Carry
;V: (SP)
;R: <no return> if Carry
ErrIfCarry:	EX	(SP),HL
		INC	HL
		EX	(SP),HL
		RET	NC
		JR	XErrAlways

;check for error (NCarry), see above
ErrIfNCarry:	EX	(SP),HL
		INC	HL
		EX	(SP),HL
		RET	C
		JR	XErrAlways

;check for error (Zero), see above
ErrIfZero:	EX	(SP),HL
		INC	HL
		EX	(SP),HL
		RET	NZ
		JR	XErrAlways

;check for error (NZero), see above
ErrIfNZero:	EX	(SP),HL
		INC	HL
		EX	(SP),HL
		RET	Z
XErrAlways:	POP	HL		;point pointer to error code again
		DEC	HL
		PUSH	HL

;error happened, abort compilation
;E: error code in (SP)
;R: <no return>
ErrAlways:	POP	HL
		LD	A,(HL)		;error code

;error happened, abort compilation
;E: error code in A
;R: <no return>
ErrAlwaysA:	CALL	Alive1
		LD	(CResult),A	;store
		OR	A
		JR	Z,ErrAlw2
		PUSH	IX		;pointer in line buffer
		POP	HL
		LD	DE,LineBuffer
		SBC	HL,DE		;= error position in line
		LD	DE,(InclLnStart)
		LD	A,(CInclude)
		OR	A		;NCarry. In include file?
		JR	NZ,ErrAlw1	;yes, DE is already file offset
	;error in MainFile, convert pointer to file offset
		LD	DE,(TextStart)
		SBC	HL,DE
		LD	DE,(MainLnStart)
ErrAlw1:	ADD	HL,DE
		LD	(CErrPos),HL
ErrAlw2:	LD	A,(CCmpZiel)
		DEC	A		;destination = file?
		JR	NZ,ErrAlw3	;no -> don't close
		LD	DE,ObjFCB
		LD	C,CloseFile
		CALL	SBDOS
ErrAlw3:	LD	SP,(CErrSP)	;SP of menue/editor
		RET


;The following macros are for a clearer, shorter definition of elements
;in the symbol table
dshlp1		MACRO	n, val
?rdc&n		DEFL	val
		ENDM

dshlp2		MACRO	n, val
		DEFB	?rdc&n&val
		ENDM

dsym		MACRO	Art, Name, Typ, Wert
		LOCAL	Ende
		DEFW	Ende-$
IF Art EQ 2 ;;constant
 IF Typ EQ 9 ;;real
		DEFB	Wert		;;real value
 ELSE
		DEFW	Wert		;;integer/boolean value
 ENDIF
		DEFB	Typ		;;type
ELSE ;;typ/var
		DEFW	Typ		;;type description
 IF Art EQ 4
		DEFW	Wert		;;address
		DEFB	0
 ENDIF
ENDIF
?cnt		DEFL	0		;;reverse DEFC!!
		IRPC	x, Name
?cnt		DEFL	?cnt+1		;;from 1 to n
		dshlp1	%?cnt, '&x'
		ENDM
		dshlp2	%?cnt,+80h
		REPT	?cnt-1
?cnt		DEFL	?cnt-1
		dshlp2	%?cnt
		ENDM
Ende:		DEFB	0,Art
		ENDM


DefSymBeg: ;item 3 (type): name, type description
		dsym	3,INTEGER, IntTyp
		dsym	3,   CHAR,CharTyp
		dsym	3,   REAL,RealTyp
		dsym	3,BOOLEAN,BoolTyp
		dsym	3,   TEXT,TextTyp
		dsym	3,   BYTE,ByteTyp
	;item 2 (constant): name, type, value
		dsym	2,  TRUE,11,1
		dsym	2, FALSE,11,0
		dsym	2,MAXINT,10,7FFFh	;=32767
		dsym	2,    PI, 9,<82h,21h,0A2h,0DAh,0Fh,49h> ;= 3.1415926536E+00
	;item 4 (variable): name, type description, address
		dsym	4,   OUTPUT,TextTyp,OutputFIB
		dsym	4,    INPUT,TextTyp, InputFIB
		dsym	4,      CON,TextTyp,   ConFIB
		dsym	4,      TRM,TextTyp,   TrmFIB
		dsym	4,      KBD,TextTyp,   KbdFIB
		dsym	4,      LST,TextTyp,   LstFIB
		dsym	4,      AUX,TextTyp,   AuxFIB
		dsym	4,      USR,TextTyp,   UsrFIB
		dsym	4,   BUFLEN,ByteTyp,   BufLen
		dsym	4,  HEAPPTR, IntTyp,  HeapPtr
		dsym	4, RECURPTR, IntTyp, RecurPtr
		dsym	4, CONSTPTR, IntTyp, ConStPtr
		dsym	4, CONINPTR, IntTyp, ConInPtr
		dsym	4,CONOUTPTR, IntTyp,ConOutPtr
		dsym	4,LSTOUTPTR, IntTyp,LstOutPtr
		dsym	4, AUXINPTR, IntTyp, AuxInPtr
		dsym	4,AUXOUTPTR, IntTyp,AuxOutPtr
		dsym	4, USRINPTR, IntTyp, UsrInPtr
		dsym	4,USROUTPTR, IntTyp,UsrOutPtr
		dsym	4, ERRORPTR, IntTyp, ErrorPtr
		dsym	4,   CBREAK,BoolTyp,   CBreak
DefSymTab:
DefSymLen	EQU	$-DefSymBeg


;type descriptions: type, minimum, maximum, sizeof
rdw		MACRO	Word		;;reverse DEFW
		DEFB	HIGH Word,LOW Word
		ENDM

dtyp		MACRO	Label, Typ, Min, Max, Sizeof
		rdw	Sizeof
		rdw	Max
		rdw	Min
		rdw	Typ
Label&		EQU	$-1
		ENDM

		dtyp	 IntTyp,10,8000h,7FFFh,  2	;integer
		dtyp	CharTyp,12,    0, 0FFh,  1	;char
		dtyp	RealTyp, 9,    0,    0,  6	;real
		dtyp	BoolTyp,11,    0,    1,  1	;boolean
		dtyp	TextTyp, 6,    0,    0,176	;text
		dtyp	ByteTyp,10,    0, 0FFh,  1	;byte

;?? (only L7512 used)
		dtyp	L750A, 8, 0, 0, 9
		dtyp	L7512, 0, 0, 0, 0


;All tables are sorted this way: first the non-letter stuff, then the
;stuff that consists of letters. The following table contains a list
;of pointers to the beginning of the letter-part of the following tables.
;This is for searching keywords. The other component of each entry ist
;the width of the data part of the respective table.
;Man! I hope you all understand this. Difficult to explain in a foreign
;language ...
MasterTbl:	dbw	0, KeyWordTbl
		dbw	1, BlockTbl
		dbw	2, StatemTbl
		dbw	1, ForTbl
		dbw	1, TermTblA
		dbw	1, SimpleTblA
		dbw	1, ExprTblA
		DEFB	-1

;Remaining keywords not contained in other tables go here.
;They are grouped together solely for the purpose of checking
;for keyword. Otherwise they are addressed individually.
KeyWordTbl:
PROGRAMnam:	DEFC	'PROGRAM'
ENDnam:		DEFC	'END'
FORWARDnam:	DEFC	'FORWARD'
EXTERNALnam:	DEFC	'EXTERNAL'
PACKEDnam:	DEFC	'PACKED'
ARRAYnam:	DEFC	'ARRAY'
FILEnam:	DEFC	'FILE'
SETnam:		DEFC	'SET'
RECORDnam:	DEFC	'RECORD'
STRINGnam:	DEFC	'STRING'
OFnam:		DEFC	'OF'
ABSOLUTEnam:	DEFC	'ABSOLUTE'
THENnam:	DEFC	'THEN'
ELSEnam:	DEFC	'ELSE'
DOnam:		DEFC	'DO'
UNTILnam:	DEFC	'UNTIL'
NOTnam:		DEFC	'NOT'
NILnam:		DEFC	'NIL'
		DEFB	0

DOTDOTnam:	DEFC	'..'
ASSIGNnam:	DEFC	':='

dcb		MACRO	c, b	;dc + db
		DEFC	c
		DEFB	b
		ENDM

dcw		MACRO	c, w	;dc + dw
		DEFC	c
		DEFW	w
		ENDM

;for block (beginning of block)
BlockTbl:	dcb	'LABEL',     1
		dcb	'CONST',     2
		dcb	'TYPE',      3
VARnam:		dcb	'VAR',       4
		dcb	'BEGIN',     8
OVERLAYnam:	dcb	'OVERLAY',   7
ProcFuncTbl:	dcb	'PROCEDURE', 5
		dcb	'FUNCTION',  6
		DEFB	0

;for statement
StatemTbl:	dcw	'BEGIN',  BEGINcc
		dcw	'IF',     IFcc
		dcw	'WHILE',  WHILEcc
		dcw	'REPEAT', REPEATcc
		dcw	'FOR',    FORcc
CASEnam:	dcw	'CASE',   CASEcc
		dcw	'GOTO',   GOTOcc
		dcw	'WITH',   WITHcc
		dcw	'INLINE', INLINEcc
		DEFB	0

;for FOR
ForTbl:		dcb	'TO',     23h	;'#'
		dcb	'DOWNTO', 2Bh	;'+'
		DEFB	0

;for term
TermTbl:	dcb	'*',   0
		dcb	'/',   1
TermTblA:	dcb	'AND', 2
		dcb	'DIV', 3
		dcb	'MOD', 4
		dcb	'SHL', 5
		dcb	'SHR', 6
		DEFB	0

;for simple expression
SimpleTbl:	dcb	'+',   0
		dcb	'-',   1
SimpleTblA:	dcb	'OR',  2
		dcb	'XOR', 3
		DEFB	0

;for expression (comparisons)
ExprTbl:	dcb	'=',  00h
		dcb	'<>', 08h
		dcb	'>=', 10h
		dcb	'<=', 18h
		dcb	'>',  20h
		dcb	'<',  28h
ExprTblA:	dcb	'IN', 0FFh
		DEFB	0

;From now on only predefined, not reserved
;procedures
ProcTbl:	dcw	'WRITELN',    WRITELNcc
		dcw	'WRITE',      WRITEcc
		dcw	'READLN',     READLNcc
		dcw	'READ',       READcc
		dcw	'DELETE',     DELETEcc
		dcw	'INSERT',     INSERTcc
		dcw	'ASSIGN',     ASSIGNcc
		dcw	'RESET',      RESETcc
		dcw	'REWRITE',    REWRITEcc
		dcw	'CLOSE',      CLOSEcc
		dcw	'ERASE',      ERASEcc
		dcw	'RENAME',     RENAMEcc
		dcw	'SEEK',       SEEKcc
		dcw	'GETMEM',     GETMEMcc
		dcw	'NEW',        NEWcc
		dcw	'FREEMEM',    FREEMEMcc
		dcw	'DISPOSE',    DISPOSEcc
		dcw	'MARK',       MARKcc
		dcw	'RELEASE',    RELEASEcc
		dcw	'OVRDRIVE',   OVRDRIVEcc
		dcw	'CRTINIT',    CRTINITcc
		dcw	'CRTEXIT',    CRTEXITcc
		dcw	'GOTOXY',     GOTOXYcc
		dcw	'CLRSCR',     CLRSCRcc
		dcw	'CLREOL',     CLREOLcc
		dcw	'NORMVIDEO',  NORMVIDEOcc
		dcw	'HIGHVIDEO',  HIGHVIDEOcc
		dcw	'LOWVIDEO',   LOWVIDEOcc
		dcw	'INSLINE',    INSLINEcc
		dcw	'DELLINE',    DELLINEcc
		dcw	'DELAY',      DELAYcc
		dcw	'BLOCKREAD',  BLOCKREADcc
		dcw	'BLOCKWRITE', BLOCKWRITEcc
		dcw	'RANDOMIZE',  RANDOMIZEcc
		dcw	'MOVE',       MOVEcc
		dcw	'FILLCHAR',   FILLCHARcc
		dcw	'EXIT',       EXITcc
		dcw	'HALT',       HALTcc
		dcw	'PORT',       PORTcc
		dcw	'STACKPTR',   STACKPTRcc
		dcw	'FLUSH',      FLUSHcc
		dcw	'EXECUTE',    EXECUTEcc
		dcw	'CHAIN',      CHAINcc
		dcw	'STR',        STRcc
		dcw	'VAL',        VALcc
		dcw	'BDOS',       BDOSHLcc
		dcw	'BIOS',       BIOSHLcc
		DEFB	0

;functions
FuncTbl:	dcw	'CHR',        CHRcc
		dcw	'ORD',        ORDcc
		dcw	'COPY',       COPYcc
		dcw	'LENGTH',     LENGTHcc
		dcw	'POS',        POScc
		dcw	'CONCAT',     CONCATcc
		dcw	'SUCC',       SUCCcc
		dcw	'PRED',       PREDcc
		dcw	'UPCASE',     UPCASEcc
		dcw	'TRUNC',      TRUNCcc
		dcw	'ROUND',      ROUNDcc
		dcw	'ODD',        ODDcc
		dcw	'ABS',        ABScc
		dcw	'SQR',        SQRcc
		dcw	'SQRT',       SQRTcc
		dcw	'SIN',        SINcc
		dcw	'COS',        COScc
		dcw	'ARCTAN',     ARCTANcc
		dcw	'LN',         LNcc
		dcw	'EXP',        EXPcc
		dcw	'INT',        INTcc
		dcw	'FRAC',       FRACcc
		dcw	'RANDOM',     RANDOMcc
		dcw	'PARAMCOUNT', PARAMCOUNTcc
		dcw	'PARAMSTR',   PARAMSTRcc
		dcw	'LO',         LOcc
		dcw	'HI',         HIcc
		dcw	'SWAP',       SWAPcc
		dcw	'PTR',        PTRcc
		dcw	'IORESULT',   IORESULTcc
		dcw	'EOF',        EOFcc
		dcw	'EOLN',       EOLNcc
		dcw	'SEEKEOF',    SEEKEOFcc
		dcw	'SEEKEOLN',   SEEKEOLNcc
		dcw	'FILESIZE',   FILESIZEcc
		dcw	'FILEPOS',    FILEPOScc
		dcw	'KEYPRESSED', KEYPRESSEDcc
		dcw	'MEMAVAIL',   MEMAVAILcc
		dcw	'MAXAVAIL',   MAXAVAILcc
		dcw	'PORT',       PORTcf
		dcw	'STACKPTR',   STACKPTRcf
		dcw	'ADDR',       ADDRcc
		dcw	'SIZEOF',     SIZEOFcc
		dcw	'BDOSHL',     BDOSHLcc
		dcw	'BDOS',       BDOScc
		dcw	'BIOSHL',     BIOSHLcc
		dcw	'BIOS',       BIOScc
		DEFB	0

MEMnam:		DEFC	'MEM'
		DEFB	0,0,0

;-------------- end of code, from now on only non-initialised data

CCmpZiel	EQU	7900h	;what to do with the produced code
				;0= memory, 1= to file (COM or CHN),
				;2= search error position. 0/1 also StandAlone flag
CResult		EQU	7901h	;error code of compiler: CA= compilation aborted,
				;00= ok, >= FA disk or directory full, C8-FA error
				;position found, 01-C8 error
CFilePC		EQU	7902h	;if output to file: PC of beginning of file
				;(start address if CHN, 0100h if COM)
CCodeStart	EQU	7904h	;start address (0 if searching, behind text when
				;memory, entered start address if COM,CHN)
CCodeEnd	EQU	7906h	;end of code (result)
CDatStart	EQU	7908h	;beginning of data (result)
CDatEnd		EQU	790Ah	;end of data (BDOS-708 if memory, entered
				;end address if COM/CHN)
CErrPos		EQU	790Ch	;pointer in text (error position)
CInclude	EQU	790Eh	;flag "in include file" (0= no, <>0 yes)

InclFCB		EQU	790Fh	;FCB of include file
ObjFCB		EQU	7933h	;FCB of output file (COM or CHN)

SecBuf		EQU	7957h
L7961		EQU	7961h
LineBuffer	EQU	79D7h	;line buffer (max.127 ch.+terminating zero)
L7A57		EQU	7A57h	;buffer for data element (e.g. string..)
InputBuffer	EQU	7AD7h	;buffer
TypeABuf	EQU	7B59h	;20 characters
L7B56		EQU	7B56h
L7B57		EQU	7B57h	;13 characters
L7B58		EQU	7B58h
L7B59		EQU	7B59h
L7B5A		EQU	7B5Ah
L7B5C		EQU	7B5Ch
L7B5D		EQU	7B5Dh
L7B5E		EQU	7B5Eh
L7B60		EQU	7B60h
L7B62		EQU	7B62h
L7B64		EQU	7B64h	;13 characters
L7B65		EQU	7B65h
L7B69		EQU	7B69h
L7B6B		EQU	7B6Bh
L7B6D		EQU	7B6Dh
ReadMax		EQU	7B6Dh	;read in upper limit for file
L7B6F		EQU	7B6Fh	;DSM
L7B71		EQU	7B71h	;block size in K
CErrSP		EQU	7B71h	;SP of menue, saved by compiler for case of error
L7B72		EQU	7B72h	;- for editor. =43DEh table of separators
TmpSymStart	EQU	7B73h	;temporary SymStart. For piecing together new entry.
				;= end of free memory while compiling
L7B73		EQU	7B73h	;- for editor
L7B74		EQU	7B74h	;- for editor
SymStart	EQU	7B75h	;start address of symbol table (logical end)
DefSymEnd	EQU	7B77h	;end address of symbol table, includes predefined
				;symbols. = MaxMem-1
L7B79		EQU	7B79h
SymEnd		EQU	7B7Bh	;end address of symbol table, without predef.symbols
L7B7D		EQU	7B7Dh	;end of search in symbol table (=7B77 or 7B7B)
L7B7F		EQU	7B7Fh
L7B81		EQU	7B81h
L7B83		EQU	7B83h
L7B85		EQU	7B85h
L7B87		EQU	7B87h
L7B88		EQU	7B88h
L7B89		EQU	7B89h
L7B8B		EQU	7B8Bh
L7B8D		EQU	7B8Dh
L7B8F		EQU	7B8Fh
L7B90		EQU	7B90h
L7B91		EQU	7B91h	;record-ident (counter)
L7B92		EQU	7B92h
L7B93		EQU	7B93h
L7B94		EQU	7B94h	;current block (counter)
L7B95		EQU	7B95h
OvlyNumber	EQU	7B96h	;overlay number (0..)
L7B97		EQU	7B97h
L7B98		EQU	7B98h
L7B99		EQU	7B99h
L7B9A		EQU	7B9Ah
L7B9B		EQU	7B9Bh
L7B9C		EQU	7B9Ch
CDirektiv	EQU	7B9Dh	;compiler directives CBVXUARI (bitwise)
WrkDirektiv	EQU	7B9Eh	;copied from CDirektiv at the beginning of every
	;statement (state must'nt change while working on a statement)
OldDirektiv	EQU	7B9Fh	;preserved compiler directives of MainFile
DirUUsed	EQU	7BA0h	;whether directive U appeared somewhere (0FFh = yes)
	;this info has to be handed over to the run time library by the program on start
L7BA1		EQU	7BA1h
CEofReached	EQU	7BA2h	;0= source characters still available, 1Ah= EOF reached
L7BA3		EQU	7BA3h
L7BA4		EQU	7BA4h
L7BA6		EQU	7BA6h	;InLine: number of byte/value (0= still unknown)
L7BA7		EQU	7BA7h
L7BA9		EQU	7BA9h
OvlyDatMax	EQU	7BABh	;min. CDatStart = max. memory usage
;7BAD-AF free
OvlyCodeMax	EQU	7BB0h	;size of biggest overlay function in sectoren
OvlyName	EQU	7BB2h	;name of overlay file (only temporarily used)
L7BBD		EQU	7BBDh
L7BBE		EQU	7BBEh
L7BC0		EQU	7BC0h	;desired record-ident
L7BC1		EQU	7BC1h	;item
L7BC2		EQU	7BC2h	;pointer to info in symbol entry (behind name)
L7BC4		EQU	7BC4h	;pointer behind name in source text
L7BC6		EQU	7BC6h
CDirektW	EQU	7BC7h	;maximum WITH-depth
OldDirektW	EQU	7BC8h	;preserved max. WITH-depth of MainFile
L7BC9		EQU	7BC9h	;current WITH-depth
L7BCA		EQU	7BCAh	;address of WITH-table of current block
L7BCC		EQU	7BCCh	;table with 9 entries, L7B5D for every WITH-depth
L7BD5		EQU	7BD5h	;temporarily
MainPtr		EQU	7BD7h	;pointer in MainFile (in memory)
MainLnStart	EQU	7BD9h	;pointer to beginning of current line
ObjSecFlags	EQU	7BDBh	;bit 0: whether sector has to be read in firt,
				;bit 1: whether sector has to be written back afterwards
ObjSecPtr	EQU	7BDCh	;offset in SecBuf for object file
ObjOffset	EQU	7BDDh	;number of sectors offset in object file
	;for overlay files, for working off the patches: every function begins
	;on a different sector border in spite of the same PC!
PatchList	EQU	7BDFh	;list of values to be changed subsequently
				;in object file. Max. 256 entries = 1K
L7BE1		EQU	7BE1h	;end of patch list = beginning of buffer for include file
PatchLen	EQU	7BE3h	;number of list entries
;Buffer for include file:
InclBufStart	EQU	7BE4h	;start of buffer
InclBufEnd	EQU	7BE6h	;end of buffer
InclBufSize	EQU	7BE8h	;size in sectors
InclBufPtr	EQU	7BE9h	;pointer in buffer
InclChars	EQU	7BEBh	;counts characters in include file
InclLnStart	EQU	7BEDh	;file offset to current line
CLines		EQU	7BEFh	;counts total lines (statistic)
L7BF1		EQU	7BF1h
L7BF2		EQU	7BF2h
L7BF3		EQU	7BF3h	;pointer behind end of text for editor
L7BF5		EQU	7BF5h	;here begins MSG file or text if no MSGs

;END OF TP-C6.INC
;----------------
