;----------------------------------
;TP-EQU.INC	ho	27-MAR-2001
;----------------------------------
;Often used EQUates for RTL, ME, C, OVR
;TPVersion must be set bevor this file is read in!

		.PRINTX	TP-EQU.INC

;to make conditionals easier:
TPVers1		EQU	TPVersion EQ 100
TPVers2		EQU	(TPVersion EQ 200) OR (TPVersion EQ 201)
TPVers3		EQU	(TPVersion EQ 300) OR (TPVersion EQ 301)

IFF (TPVers1 OR TPVers2 OR TPVers3)
	.PRINTX %  You entered an invalid Turbo Pascal version number!	%
	.PRINTX % 		assembly aborted!			%
		END
ENDIF

;mixed stuff
;-----------

FCBSize		EQU	36
SecSize		EQU	80h		;size of a logical sector
TPA		EQU	0100h		;start address of CP/M programs
IF (TPVers1 OR TPVers2)
OverArea	EQU	8000h
ELSE	;TPVers3
OverArea	EQU	9000h		;load address of TURBO.OVR
ENDIF

;ASCII characters
;----------------

BS		EQU	08h
TAB		EQU	09h
LF		EQU	0Ah
CLS		EQU	0Ch
CR		EQU	0Dh
EOF		EQU	1Ah
ESC		EQU	1Bh
DEL		EQU	7Fh

		IRPC	X,ABCDEFGHIKLNPQRSTUVWXYZ
Ctl&X		EQU	'&X' AND 1Fh
		ENDM

;BDOS functions
;--------------

ConIO		EQU	6
ConString	EQU	9
GetVersion	EQU	12
Reset		EQU	13
DriveSelect	EQU	14
OpenFile	EQU	15
CloseFile	EQU	16
SearchFirst	EQU	17
SearchNext	EQU	18
DeleteFile	EQU	19
ReadSeq		EQU	20
WriteSeq	EQU	21
MakeFile	EQU	22
RenameFile	EQU	23
GetDrive	EQU	25
SetDMA		EQU	26
GetALV		EQU	27
GetDPB		EQU	31
GetSetUser	EQU	32
ReadRand	EQU	33
WriteRand	EQU	34
FileSize	EQU	35

;zero page
;----------

WBoot		EQU	000h		;jump to WarmBoot (into BIOS)
CurrDU		EQU	004h		;current drive/user
BDOS		EQU	005h		;jump to BDOS
BreakEntry	EQU	038h		;NMI or RST 38h goes there
DefaultFCB	EQU	05Ch
ConvBuf		EQU	05Dh		;buffer for conversions ascii<->INT/REAL
CmdLine		EQU	080h		;CP/M command line
IF (TPVers1 OR TPVers2)
ChainOvly	EQU	080h		;overlays the following in part
ELSE	;TPVers3
ChainOvly	EQU	0B0h		;overlays the following in part
ENDIF

;Jumptable (Low-Level IO) >>
IOJumps		EQU	0A0h
ConSta		EQU	0A0h		;= keypressed
ConStPtr	EQU	0A1h
ConInp		EQU	0A3h
ConInPtr	EQU	0A4h
ConOut		EQU	0A6h
ConOutPtr	EQU	0A7h
LstOut		EQU	0A9h
LstOutPtr	EQU	0AAh
PunOut		EQU	0ACh
AuxOutPtr	EQU	0ADh
RdrInp		EQU	0AFh
AuxInPtr	EQU	0B0h
ConOutx		EQU	0B2h
UsrOutPtr	EQU	0B3h
ConInpx		EQU	0B5h
UsrInPtr	EQU	0B6h

IF (TPVers1 OR TPVers2)

;file interface blocks (High-Level IO) >>
FIBs		EQU	0B8h
ConFIB		EQU	0B8h
TrmFIB		EQU	0BBh
KbdFIB		EQU	0BEh
LstFIB		EQU	0C1h
AuxFIB		EQU	0C4h
UsrFIB		EQU	0C7h
InputFIB	EQU	0CAh
OutputFIB	EQU	InputFIB

;TurboPascal variables >>
HeapPtr		EQU	0CDh		;pointer to end of heap
RecurPtr	EQU	0CFh		;pointer to end of rekursion stack
Seed		EQU	0D1h		;32 bit number for random number generator
ProgStart	EQU	0D5h		;points in pascal prg. behind InitMem call
RelErrPos	EQU	0D7h		;error position, relative to ProgStart
IORes		EQU	0D9h		;result of I/O operations
BufLen		EQU	0DAh		;length of buffer for e.g. input lines
BufPos		EQU	0DBh		;position of this buffer
BufNext		EQU	0DDh		;pointer to next character in buffer
ContAdr		EQU	0DFh		;continuation address (=0 if stand alone)
CBreak		EQU	0E1h		;directive C (^S/^C) 0=off
FilePointer	EQU	0E2h		;points to current FIB
OvrArea		EQU	0E2h		;points to overlay area + 3
FIOVar		EQU	0E4h		;multi-purpose variable for file-IO
OvrBegin	EQU	0E4h		;starting sector of function to be loaded
FIOPC		EQU	0E4h		;return address for STR/VAL
InsertPtr	EQU	0E6h		;temporary variable for Insert
OvrLength	EQU	0E6h		;length of the function to be loaded in sectors
FIOFlag1	EQU	0E6h		;multi-purpose flag for file-IO
FIOFlag2	EQU	0E7h		;multi-purpose flag for file-IO
StrPointer	EQU	0E6h		;pointer in string for STR function
ValResult	EQU	0E6h		;pointer to result for VAL procedure
StrLength	EQU	0E8h		;max. string length for STR function
ValPointer	EQU	0E8h		;pointer to value for VAL procedure
ValFlag		EQU	0EAh		;flag for VAL procedure
MemVar5		EQU	0EBh		;multi-purpose variable for memory management
FreeRoot	EQU	0EDh		;pointer to linked list of free blocks
CursorBuff	EQU	0F0h		;buffer for cursor-movement-string
					;(reaches to 0FFh)
MemVar1		EQU	0F2h		;multi-purpose variable for memory management
MemVar2		EQU	0F4h		;	"		"
MemVar3		EQU	0F6h		;	"		"
MemVar4		EQU	0F8h		;	"		"

ELSE	;TPVers3

;file interface blocks (High-Level IO) >>
FIBs		EQU	0B8h
ConFIB		EQU	0B8h
TrmFIB		EQU	ConFIB
KbdFIB		EQU	0BAh
LstFIB		EQU	0BCh
AuxFIB		EQU	0BEh
UsrFIB		EQU	0C0h
InputFIB	EQU	0C2h
OutputFIB	EQU	InputFIB

;TurboPascal globale Variablen >>
HeapPtr		EQU	0C4h		;pointer to end of heap
RecurPtr	EQU	0C6h		;pointer to end of rekursion stack
Seed		EQU	0C8h		;32 bit number for random number generator
ProgStart	EQU	0CCh		;points in pascal prg. behind InitMem call
RelErrPos	EQU	0CEh		;error position, relative to ProgStart
IORes		EQU	0D0h		;result of I/O operations
BufLen		EQU	0D1h		;length of buffer for e.g. input lines
BufPos		EQU	0D2h		;position of this buffer
BufNext		EQU	0D4h		;pointer to next character in buffer
BufLast		EQU	0D6h		;pointer behind last char in buffer
StandAlone	EQU	0D8h		;whether stand-alone (=1) or interactive (=0)
ErrEntry	EQU	0D9h		;jump to error handling routine
ErrorPtr	EQU	0DAh		;(address of this routine)
OvrDrv		EQU	0DCh		;drive for overlays
CBreak		EQU	0DDh		;directive C (^S/^C) 0=off
FreeRoot	EQU	0DEh		;pointer to linked list of free blocks
HLightFlag	EQU	0E0h		;0=HL off, 0FFh=on, 7Eh=unknown
;	EQU	0E1h	unused

;TurboPascal temporary variables >>
;ATTENTION: some of them share the same locations!
FilePointer	EQU	0E2h		;points to current FIB
OvrArea		EQU	0E2h		;points to overlay area + 3
FIOPC		EQU	0E4h		;file-IO. PC for case of error
FIOVar		EQU	0E6h		;multi-purpose variable for file-IO
OvrBegin	EQU	0E6h		;starting sector of function to be loaded
FIOFlag1	EQU	0E8h		;multi-purpose flag for file-IO
FIOFlag2	EQU	0E9h		;	"	"
InsertPtr	EQU	0E8h		;temporary variable for Insert
OvrLength	EQU	0E8h		;length of the function to be loaded in sectors
StrPointer	EQU	0E8h		;pointer in string for STR procedure
ValResult	EQU	0E8h		;pointer to result for VAL procedure
StrLength	EQU	0EAh		;max. string length for STR prozedure
ValPointer	EQU	0EAh		;pointer to value for VAL procedure
ValFlag		EQU	0ECh		;flag for VAL procedure
OldFilePtr	EQU	0EDh		;saved FilePointer for VAL/STR
CursorBuff	EQU	0F0h		;buffer for cursor-movement-string
					;(reaches to 0FFh)
MemVar1		EQU	0F0h		;multi-purpose variable for memory management
MemVar2		EQU	0F2h		;	"		"
MemVar3		EQU	0F4h		;	"		"
MemVar4		EQU	0F6h		;	"		"
MemVar5		EQU	0F8h		;	"		"
ENDIF

iIDENT		MACRO	N,A
		.PRINTX N (starts at A)
		ENDM

iENDA		MACRO	A
		.PRINTX	end address: A
		ENDM

IDENT		MACRO	N
		.RADIX	16
		iIDENT	N,%$
		.RADIX	10
		ENDM

ENDADDR		MACRO
		.RADIX	16
		iENDA	%$
		.RADIX	10
		ENDM

;END OF TP-EQU.INC
;-----------------