;--------------------------------
;TP-ME1.INC	ho	11-MAR-94
;--------------------------------
;V2.00: 1FC9h-2AB3h
;ATTENTION: the position marked with // is an absolute address behind
;	    the compiler in V2.00
;V3.00: 20E2h-2B92h	V3.01: 20E3h-2B71h

		IDENT	TP-ME1.INC

;ProgramStart
;------------

EditComp:	JP	OpeningMenue

;put stack below BDOS, MaxMem 1K below,
;initialises character I/O
;E:- / V: AF, BC, DE, HL, SP / R: MaxMem
InitMemIO:
IF TPVers2
		LD	HL,-1
		LD	(RelErrPos),HL
ENDIF
InitMemIO1:	LD	HL,(BDOS+1)
		POP	BC		;save return address
		LD	SP,HL
		PUSH	BC		;ok, now put it back
		LD	DE,-1024
		ADD	HL,DE
		LD	(MaxMem),HL
		LD	HL,InputBuffer
IF TPVers2
		LD	DE,ConFIB
ENDIF
		LD	BC,0		;directive C, U
		CALL	InitCharIO
		CALL	CrtInit
		CALL	LowVideo
IF TPVers3
		JP	NormVideo
ELSE
		CALL	NormVideo
		RET
ENDIF

;for Run/Execute
LoadAll:	CALL	InitMemIO
		LD	A,(CompFlag)
		PUSH	AF
		LD	A,(MSGPresent)
		OR	A
		CALL	NZ,ReadMSG
		CALL	ClearText
		CALL	WorkFGiven
		CALL	NZ,MWorkF2	;read in text
		LD	A,(CmpZiel)
		DEC	A		;Memory?
		JR	Z,LoadAll1	;yes -> nothing compiled, cause nothing saved
		POP	AF		;no, remains compiled
		LD	(CompFlag),A
LoadAll1:	JP	MainMenue

IF TPVersion EQ 301
Balken:		LD	B,39
Balken1:	CALL	Print
		DEFB	'-',0
		DJNZ	Balken1
		JP	NewLine
ELSE
;draw a line (39 dashes)
;E:- / V:- / R:-
Balken:		CALL	Print
		DEFB	'---------------------------------------'
		DEFB	CR,LF,0
		RET
ENDIF

IF TPVers3
;output a series of spaces
;E: number of spaces in B
;V: F, B / R:-
PrSpace:	CALL	Print
		DEFB	' ',0
		DJNZ	PrSpace
		RET
ENDIF

;show signon message, ask for error message file
OpeningMenue:	LD	HL,(BDOS+1)
IF TPVers3
		LD	BC,-708		;where does that number come from?
ELSE
		LD	BC,-710
ENDIF
		ADD	HL,BC
		LD	(EndAddress),HL
		LD	C,GetDrive
		CALL	BDOS
		INC	A
		LD	(LoggedDrive),A
		CALL	InitMemIO
		CALL	ClrScr
		CALL	Balken
.COMMENT %-------------------------------------------------
Skip signon message

V2.00:			V3.00:
2060h	CDh -> C3h	2177h	CDh -> C3h
2061h	19h -> 0Ah	2178h	28h -> 0Dh
2062h	20h -> 21h	2179h	21h -> 22h
-------------------------------------------------% ;COMMENT
		CALL	Print
WhoAmI:		DEFB	'TURBO Pascal system',0
.COMMENT %-------------------------------------------------
The string 'TURBO ' above is used to create the file names
TURBO.MSG and TURBO.OVR. We must patch here if we want to
give these two files a different name. Further, we can insert
a drive designator here (like 'H:TURBO ') if we want to keep
these two files on a different drive than the current one.
V3.00: 217Dh
-------------------------------------------------% ;COMMENT
		CALL	LowVideo
IF TPVers3
		LD	B,7
		CALL	PrSpace
ENDIF
		CALL	Print
IF TPVers2
		DEFB	'       '
ENDIF
		DEFB	'Version '
IF TPVers2
		DEFB	'2.00'
ELSE
 IF TPVersion EQ 300
		DEFB	'3.00'
 ELSE	;V3.01
		DEFB	'3.01'
 ENDIF
ENDIF
		DEFB	'A',CR,LF
IF TPVers3
		DEFB	0
		LD	B,27
		CALL	PrSpace
		CALL	Print
ELSE
		DEFB	'                           '
ENDIF
		DEFB	'CP/M-80, Z80',CR,LF,CR,LF
		DEFB	'Copyright (C) 1983,'
IF TPVers2
		DEFB	'1984 by ',0
ELSE	;TPVers3
		DEFB	'84,85   ',0
ENDIF
		CALL	NormVideo
		CALL	Print
		DEFB	'BORLAND Inc.',CR,LF,0
		CALL	Balken
		CALL	Print
		DEFB	LF
		DEFB	'Terminal: ',0
		LD	HL,TermTypStr
		CALL	OutString
L220D:		CALL	Print
		DEFB	CR,LF,LF,LF,LF
		DEFB	'Include error messages',0
		CALL	YesNoCR
.COMMENT %-------------------------------------------------
Don't read in error message file

V2.00:	V3.00:
2129h	222Ch	CDh -> 3Eh	= LD A,0
212Ah	222Dh	21h -> 00h
212Fh	222Eh	2Dh -> B7h	= OR A
-------------------------------------------------% ;COMMENT
		LD	(MSGPresent),A
		CALL	NZ,ReadMSG
		CALL	ClearText
		CALL	ShowMain

;main menue
MainMenue:	LD	SP,(BDOS+1)
		LD	HL,MainMenue	;put own address on stack so that
		PUSH	HL		;the selected routines can go back
		CALL	PrintH		;to the main menue easily via RET
		DEFB	CR@,LF@,ARR@,0
		CALL	SConInp		;read in key
		CALL	ToUpper
		CALL	NewLine
		LD	HL,MLetters	;and evaluate key
		LD	DE,MJumps
		LD	B,MCount
		CALL	MenuePunkt	;if wrong key, show user what he
		JR	C,ShowMain	;may type, else start
		JP	(HL)		;selected routine

;let user enter a line
;E:-
;R: A=EOF and Zero if line empty,
;   else NZero and DE points to the first non-blank and A contains this char
GetLine:	CALL	Print
		DEFB	': ',0
		CALL	EditInp
		CALL	NewLine
		LD	DE,InputBuffer
GetLine1:	LD	A,(DE)
		CP	EOF
		RET	Z
		CP	' '
		RET	NZ
		INC	DE
		JR	GetLine1

;shows main menue on screen
ShowMain:	CALL	ClrScr
		CALL	PrintH
		DEFB	L@,'ogged drive:',SPC@,0 ;SPC@ so that drive letter
		LD	C,GetDrive		;is highlighted!
		CALL	BDOS
		ADD	A,'A'
		CALL	SConOut
		CALL	PrintH
		DEFB	CR@,LF@,LF@
		DEFB	W@,'ork file:',SPC@,0
		CALL	PrintWorkFN
		CALL	PrintH
		DEFB	CR@,LF@
		DEFB	M@,'ain file:',SPC@,0
		LD	DE,MainFCB
		CALL	PrintFName
		CALL	PrintH
		DEFB	CR@,LF@,LF@
		DEFB	E@,'dit     ',C@,'ompile  '
		DEFB	R@,'un   ',S@,'ave',CR,LF,LF
		DEFB	'e',X@,'ecute  ',D@,'ir      '
		DEFB	Q@,'uit  compiler ',O@,'ptions',CR,LF,LF
		DEFB	'Text: ',0
		LD	DE,(TextStart)
		LD	HL,(TextEnd)
		DEC	HL
		CALL	ShowRange
		LD	DE,(TextEnd)
		LD	HL,(MaxMem)
;<fall through>

;ouput string 'FREE: ' and area on screen (size, from, to)
;E: upper limit in HL, lower limit in DE / R:-
ShFreeRange:	CALL	Print
		DEFB	'Free: ',0
;<fall through>

;output area on screen (size, from, to)
;E: upper limit in HL, lower limit in DE / R:-
ShowRange:	PUSH	HL		;save limits
		PUSH	DE
		OR	A
		SBC	HL,DE		;calculate size
		CALL	PrintInt5
		CALL	Print
		DEFB	' bytes (',0
		POP	HL		;lower limit
		CALL	HexW
		LD	A,'-'
		CALL	SConOut
		POP	HL		;upper limit
		CALL	HexW
		LD	A,')'
		CALL	SConOut
		JP	NewLine

;if A=1 output string 'compile'
;else (A<>1) output a corresponding number of spaces
;E: counter in A
;V: AF / R: counter-1 in A
ShowOption:	DEC	A
		JR	NZ,ShowOpt1
		CALL	PrintH
		DEFB	'compile -> ',0
		RET

ShowOpt1:
IF TPVers2
		CALL	PrintH
		DEFB	'           ',0
		RET
ELSE
		LD	B,11
		JP	PrSpace
ENDIF

;option menue
OptionsMenue:	LD	HL,OptionsMenue	;put own address on stack so that
		PUSH	HL		;the selected routines can go back
		CALL	ClrScr		;to the options menue easily via RET
		LD	A,(CmpZiel)
		CALL	ShowOption
		CALL	PrintH
		DEFB	M@,'emory',CR,LF,0
		CALL	ShowOption
		CALL	PrintH
		DEFB	C@,'om-file',CR,LF,0
		CALL	ShowOption
		CALL	PrintH
		DEFB	'c',H@,'n-file',CR,LF,LF,0
		LD	A,(CmpZiel)
		CP	1		;Memory?
		JR	Z,OptionsMen1	;yes -> then start/end address not applicable
		CALL	PrintH
		DEFB	S@,'tart address:',SPC@,0
		LD	HL,(StrtAddress)
		CALL	HexW
		CALL	PrintH
		DEFB	' (min ',0
		LD	HL,EditComp
		CALL	HexW
		CALL	PrintH
		DEFB	')',CR,LF
		DEFB	E@,'nd   address:',SPC@,0
		LD	HL,(EndAddress)
		CALL	HexW
		CALL	PrintH
		DEFB	' (max ',0
		LD	HL,(BDOS+1)
		CALL	HexW
		CALL	PrintH
		DEFB	')',CR,LF,LF,0
OptionsMen1:	CALL	PrintH
		DEFB	F@,'ind run-time error  ',Q@,'uit',CR,LF,LF
		DEFB	ARR@,0
		CALL	SConInp
		CALL	ToUpper
		CALL	NewLine
		LD	HL,OLetters
		LD	DE,OJumps
		LD	B,OCount
		CALL	MenuePunkt	;if wrong key then show user what
		RET	C		;he may type, else
		JP	(HL)		;start selected routine

;look if key valid and if it is determine address of corresponding routine
;E: key in A, table size in B,
;   pointer to table of legal keys in HL,
;   pointer to table of addresses in DE
;V: F, B, DE, HL
;R: Carry if key illegal
;   else NCarry and address in HL
MenuePunkt:	CP	(HL)		;key ok?
		JR	Z,MenuePkt1	;yes -> get address
		INC	HL		;no, to next entry
		INC	DE
		INC	DE
		DJNZ	MenuePunkt	;until end of table
		SCF			;say 'key is illegal'
		RET

MenuePkt1:	;legal key
		EX	DE,HL		;pointer in table of addresses to HL
		LD	E,(HL)		;get address
		INC	HL
		LD	D,(HL)
		EX	DE,HL		;return it in HL
		RET

MLetters:	DEFB	'LWMECRSXDQO'
MCount		EQU	$-MLetters

OLetters:	DEFB	'MCHSEFQ'
OCount		EQU	$-OLetters

MJumps:		DEFW	MLogged
		DEFW	MWorkF
		DEFW	MMainF
		DEFW	MEdit
		DEFW	MCompile
		DEFW	MRun
		DEFW	MSave
		DEFW	MExecute
		DEFW	MDir
		DEFW	MQuit
		DEFW	OptionsMenue

OJumps:		DEFW	OMemory
		DEFW	OComFile
		DEFW	OChnFile
		DEFW	OStartAdr
		DEFW	OEndAdr
		DEFW	OFindErr
		DEFW	OQuit

OQuit:		POP	HL		;drop address of OptionsMenue
		JP	ShowMain

MMainF:		CALL	Print
		DEFB	CR,LF,'Main file name',0
		CALL	ClearCompFlag	;not compiled anymore
		CALL	GetLine
		LD	A,0
		LD	(MainFCB+1),A	;first set to "no MainFile"
		RET	Z		;exit if no filename entered
		CALL	ParsePAS	;else evaluate
		LD	DE,MainFCB
		LD	HL,DefaultFCB
		LD	BC,FCBSize
		LDIR
		RET

MWorkF:		LD	HL,NewFile	;if open failed: new file
		LD	(NotFoundJp+1),HL ;InTheCode!
		CALL	AutoSaveQ
		CALL	Print
		DEFB	CR,LF,'Work file name',0
		CALL	GetLine
		LD	A,0
		LD	(WorkFCB+1),A	;first set to "no WorkFile"
		JR	NZ,MWorkF1
		CALL	ClearText	;clear text if no filename entered
		JP	MainMenue

MWorkF1:	CALL	ParsePAS	;else evaluate
		LD	DE,WorkFCB
		LD	HL,DefaultFCB
		LD	BC,FCBSize
		LDIR
		JR	MWorkF3		;and read in

;read in text after Run/Execute
MWorkF2:	LD	HL,FNotFoundM	;if open failed: not found, press esc
		LD	(NotFoundJp+1),HL ;InTheCode!

;read in text
MWorkF3:	LD	HL,FTooBigM	;if too big: file too big, press esc
		LD	(TooBigJp+1),HL	;InTheCode!
		CALL	ClearText
		LD	DE,WorkFCB
ReadTextFile:	LD	HL,(TextStart)
		LD	(L4460),HL
		LD	(L4462),HL
		LD	(L4450),HL
		LD	(L4454),HL
		LD	(L4458),HL
		LD	(L446A),HL
		LD	BC,(MaxMem)
		CALL	ReadFile
		LD	(HL),CR		;terminate
		INC	HL
		LD	(TextEnd),HL
		RET

;E: BC= upper limit, DE= pointer to FCB, HL= start (=destination) address
ReadFile:	PUSH	HL
		PUSH	BC
		PUSH	DE
		CALL	Print
		DEFB	CR,LF,'Loading ',0
		CALL	PrintFName
	;I think the following can be optimized, because there is
	;a subroutine ClrDefFCB, and furthermore I believe it is
	;unnecessary to clear the FCB, because the whole FCB is copied
		LD	DE,DefaultFCB
		CALL	ClearFCB
		POP	HL		;pointer to FCB
		LD	BC,FCBSize
		LDIR
		LD	C,OpenFile
		CALL	DefSBDOS
ReadFile1:	PUSH	AF		;keep result
		LD	DE,SecBuf	;sector buffer
		LD	C,SetDMA
		CALL	SBDOS
		POP	AF
		POP	BC
		POP	HL
		INC	A		;error (not found)?
		JR	Z,NotFoundJp
		LD	(ReadMax),BC
ReadFile2:	LD	BC,(ReadMax)
		DEC	B		;current write pointer >Max?
		OR	A
		SBC	HL,BC
		ADD	HL,BC		;yes -> too big
TooBigJp:	JP	NC,1234		;<-- jump address is filled in there
		PUSH	HL
		LD	C,ReadSeq
		CALL	DefSBDOS	;the file is finished iff we reached
		POP	HL		;a) the physical end of file,
		OR	A		;b) 0FFh or
		RET	NZ		;c) 1Ah or 9Ah (EOF character)
		LD	DE,SecBuf
		LD	B,SecSize
ReadFile3:	LD	A,(DE)
		CP	0FFh
		RET	Z
		AND	7Fh
		CP	EOF
		RET	Z
		LD	(HL),A
		INC	HL
		INC	DE
		DJNZ	ReadFile3
		JR	ReadFile2

NotFoundJp:	JP	1234		;<-- jump address is filled in there

;>> error routines for load routine

;not found
FNotFound:	CALL	Print
		DEFB	CR,LF,'File not found',0
XPressEsc:	JP	PressEscape

;not found, no WorkFile, back to menue
FNotFoundM:	CALL	FNotFound
		JR	ClearMain

;new file
NewFile:	CALL	Print
		DEFB	CR,LF,'New File',0
		INC	HL
		PUSH	HL
		LD	HL,1000		;1 sec
		CALL	Delay
		POP	HL
		RET

;file too big
FTooBig:	LD	HL,(TextEnd)
		CALL	Print
		DEFB	CR,LF,'File too big',0
		JR	XPressEsc

;file too big, no WorkFile, back to menue
FTooBigM:	CALL	FTooBig
;set 'no WorkFile', back to menue
ClearMain:	XOR	A
		LD	(WorkFCB+1),A	;set "no WorkFile"
		JP	MainMenue

;set extension in DefaultFCB to "BAK"
;E:- / V: F, HL / R:-
BakExtension:	LD	HL,DefaultFCB+9
		LD	(HL),'B'
		INC	HL
		LD	(HL),'A'
		INC	HL
		LD	(HL),'K'
		RET

;save with question, if WorkFile modified
AutoSaveQ:	DEFB	3Eh		;LD A,0AFh
;save without question, if WorkFile modified
AutoSave:	XOR	A		;0= don't ask, <>0= ask
		EX	AF,AF'
		LD	A,(WorkDirty)	;WorkFile modified?
		OR	A
		RET	Z		;no -> nothing to save
		EX	AF,AF'
		OR	A		;ask?
		JR	Z,MSave		;no -> save
		CALL	Print
		DEFB	'Workfile ',0
		CALL	PrintWorkFN
		CALL	Print
		DEFB	' not saved. Save',0
		XOR	A
		LD	(WorkDirty),A
		CALL	YesNoCR
		RET	Z

MSave:		CALL	L2D50
		LD	HL,WorkFCB
		PUSH	HL
		LD	DE,DefaultFCB
		LD	BC,FCBSize
		LDIR
		CALL	Print
		DEFB	CR,LF,'Saving ',0
		LD	DE,DefaultFCB
		CALL	PrintFName
		LD	HL,(TextEnd)	;replace last CR by EOF
		DEC	HL
		LD	(HL),EOF
		CALL	BakExtension
		CALL	ClrDefFCB
		LD	C,DeleteFile
		CALL	SBDOS
		LD	HL,DefaultFCB+1
		LD	DE,DefaultFCB+16
		XOR	A
		LD	(WorkDirty),A
		LD	(DE),A
		INC	A
		LD	(L44F2),A
		INC	DE
		LD	BC,15
		LDIR
		POP	HL
		LD	DE,DefaultFCB
		LD	BC,16
		LDIR
		LD	C,RenameFile
.COMMENT %-------------------------------------------------
no backup file

V2.00:	V3.00:
2593h	268Bh	17h -> 13h	LD C,DeleteFile
-------------------------------------------------% ;COMMENT
		CALL	DefSBDOS
		LD	HL,(TextStart)
MSave1:		PUSH	HL
		CALL	ClrDefFCB
		LD	C,MakeFile
		CALL	SBDOS
		POP	HL
		INC	A
		JR	Z,DirFull
		PUSH	HL
		LD	DE,SecBuf
		PUSH	DE
		LD	C,SetDMA
		CALL	SBDOS
		POP	DE
		POP	HL
		LD	B,SecSize
MSave2:		LD	A,(HL)
		INC	HL
MSave3:		LD	(DE),A
		INC	DE
		DJNZ	MSave4
		LD	B,A
		PUSH	BC
		PUSH	HL
		LD	C,WriteSeq
		CALL	DefSBDOS
		POP	HL
		POP	BC
		OR	A
		JR	NZ,DiskFull
		LD	DE,SecBuf
		LD	A,B
		LD	B,SecSize
MSave4:		CP	EOF
		JR	NZ,MSave2
		LD	A,B		;fill last sector with EOF
		SUB	SecSize
		LD	A,EOF
		JR	NZ,MSave3
		LD	C,CloseFile
;<fall through>

;BDOS call with preserving registers and DefaultFCB as FCB
;E: function number in C
DefSBDOS:	LD	DE,DefaultFCB
		JP	SBDOS

;clear DefaultFCB starting with extent
;E:- / V: F, BC, DE, HL
;R: DE points to DefaultFCB
ClrDefFCB:	LD	DE,DefaultFCB
;<fall through>

;clear FCB starting with extent
;E: DE points to FCB
;V: F, BC, HL / R:-
ClearFCB:	PUSH	DE
		LD	HL,12		;extent
		ADD	HL,DE
		LD	(HL),0		;clear
		LD	D,H
		LD	E,L
		INC	DE
		LD	BC,23		;and the next 23 bytes
		LDIR			;(until end of FCB)
		POP	DE
		RET

DirFull:	CALL	Print
		DEFB	'  Directory',0
		JR	FullError

DiskFull:	CALL	Print
		DEFB	'  Disk',0
FullError:	CALL	Print
		DEFB	' full',0
		CALL	PressEscape
		CALL	ClrDefFCB
		LD	C,DeleteFile
		CALL	DefSBDOS
		LD	A,(L44F2)
		OR	A
		RET	Z
		LD	(WorkDirty),A	;remains dirty
		LD	HL,DefaultFCB+1
		LD	DE,DefaultFCB+16
		XOR	A
		LD	(L44F2),A
		LD	(DE),A
		INC	DE
		LD	BC,15
		LDIR
		CALL	BakExtension	;undo rename
		LD	C,RenameFile
		CALL	DefSBDOS
		JP	MainMenue

OMemory:	LD	A,1
		JR	OZiel

OComFile:	LD	A,2
		JR	OZiel

OChnFile:	LD	A,3
OZiel:		LD	(CmpZiel),A
		JP	ClearCompFlag

OStartAdr:	CALL	Print
		DEFB	'Start address',0
		CALL	GetLine
		LD	HL,EditComp
		CALL	NZ,HexToInt
		LD	(StrtAddress),HL
		RET

OEndAdr:	CALL	Print
		DEFB	'End address',0
		CALL	GetLine
		LD	HL,(BDOS+1)
IF TPVers2
		LD	BC,-710
ELSE	;TPVers3
		LD	BC,-708
ENDIF
		ADD	HL,BC
		CALL	NZ,HexToInt
		LD	(EndAddress),HL
		RET

;ErrorHandler of TP program jumps here if not stand alone
TPCompiler:	CALL	InitMemIO1
		LD	HL,(RelErrPos)
		LD	A,H
IF TPVers2
		AND	L
		INC	A
ELSE
		OR	L		;error?
ENDIF
		JR	NZ,OFindErr1	;yes -> search the error position
		JP	MainMenue

OFindErr:	CALL	Print
		DEFB	'Enter PC',0
		CALL	GetLine
		RET	Z
		CALL	HexToInt
		LD	(RelErrPos),HL
IF TPVers2
		CALL	ClearCompFlag
ENDIF
OFindErr1:	CALL	NewLine
		CALL	L27D7
		LD	HL,0
		LD	(CCodeStart),HL
		LD	A,2
		LD	(CCmpZiel),A	;flag "search"
		CALL	Print
		DEFB	CR,LF,'Searching',0
IF TPVers3
		CALL	ClearCompFlag
ENDIF
		JP	L28D0

L27D7:		CALL	WorkFGiven
		CALL	Z,L2D50
		CALL	MainFGiven
L27E0:		LD	HL,WorkFCB
		JR	NZ,L27EA
		CALL	L2D50
		JR	L2808

L27EA:		CALL	CmpFiles
		JR	Z,L27E0
		CALL	AutoSave
		LD	HL,FTooBigM
		LD	(TooBigJp+1),HL	;InTheCode!
		LD	HL,FNotFoundM
		LD	(NotFoundJp+1),HL ;InTheCode!
		LD	DE,MainFCB
		PUSH	DE
		CALL	ReadTextFile
		LD	A,1
		POP	HL
L2808:		LD	(L44F1),A
		LD	DE,ObjFCB
		LD	BC,FCBSize
		LDIR
		XOR	A		;destination = memory
		LD	(CCmpZiel),A
		LD	HL,(BDOS+1)
		LD	(CDatEnd),HL
L281D:		LD	HL,(TextEnd)
		LD	(HL),EOF
		INC	HL
		LD	(CCodeStart),HL
		RET

MCompile:	CALL	L27D7
		LD	A,(CmpZiel)
		DEC	A		;in memory?
		JP	Z,L28AA		;yes -> don't open any files
		DEC	A		;Zero= COM, NZero= CHN
		PUSH	AF
		JR	NZ,L283C
		LD	A,'C'
		LD	HL,'MO'
		JR	L2841

L283C:		LD	A,'C'
		LD	HL,'NH'
L2841:		LD	(ObjFCB+9),A	;fill in extension
		LD	(ObjFCB+10),HL
		LD	A,1		;destination = file
		LD	(CCmpZiel),A
		LD	HL,(StrtAddress)
		LD	(CCodeStart),HL
		LD	HL,(EndAddress)
		LD	(CDatEnd),HL
		LD	DE,ObjFCB
		PUSH	DE
		CALL	ClearFCB
		LD	C,DeleteFile
		CALL	SBDOS
		POP	DE
		LD	C,MakeFile
		CALL	SBDOS
		INC	A
		JP	Z,L2A5A
		POP	AF		;Zero= COM, NZero= CHN
		LD	HL,TPA
		JR	Z,L2877
		LD	HL,(CCodeStart)
L2877:		LD	(CFilePC),HL
		EX	DE,HL
L287B:		LD	HL,(CCodeStart)
		SCF
		SBC	HL,DE
		JR	C,L28A9
		LD	HL,(CCodeStart)
		LD	(TPA+1),HL
		PUSH	DE
		LD	C,SetDMA
		CALL	SBDOS
		LD	C,WriteSeq
		LD	DE,ObjFCB
		CALL	SBDOS
		POP	DE
		LD	HL,EditComp
		LD	(TPA+1),HL
		OR	A
		JP	NZ,L2A5A
		LD	HL,SecSize
		ADD	HL,DE
		EX	DE,HL
		JR	L287B

L28A9:		DEFB	3Eh		;LD	A,0AFh
L28AA:		XOR	A
		CALL	Print
		DEFB	CR,LF,'Compiling ',0
		LD	DE,ObjFCB
		OR	A
		JR	Z,L28CD
		CALL	Print
		DEFB	' --> ',0
		CALL	PrintFName
L28CD:		CALL	ClearCompFlag
L28D0:		CALL	NewLine
		CALL	$Compile
		LD	A,(CResult)
		CP	0CAh		;= "Compilation aborted"
		JR	NZ,L28FA
		CALL	Print
		DEFB	CR,LF,LF,'Compilation aborted',0
		JP	MainMenue

L28FA:		CALL	Print
		DEFB	' lines',CR,LF,LF,0
IF TPVers2
		LD	HL,-1
		LD	(RelErrPos),HL
ENDIF
		LD	A,(CResult)
		OR	A		;error?
		JP	NZ,L2970	;yes ->
		LD	A,(CCmpZiel)
		CP	2
		JR	NZ,L292A
		CALL	L2A7A
		CALL	Print
		DEFB	'not found',CR,LF,0
		JP	MainMenue

L292A:		OR	A
		JR	Z,L293A
		LD	HL,(CCodeStart)
		LD	DE,EditComp
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		CALL	NZ,ShFreeRange
L293A:		CALL	Print
		DEFB	'Code: ',0
		LD	DE,(CCodeStart)
		LD	HL,(CCodeEnd)
		PUSH	HL
		DEC	HL
		CALL	ShowRange
		POP	DE
		LD	HL,(CDatStart)
		PUSH	HL
		CALL	ShFreeRange
		POP	DE
		INC	DE
		LD	HL,(CDatEnd)
		CALL	Print
		DEFB	'Data: ',0
		CALL	ShowRange
		LD	A,0FFh
		LD	(CompFlag),A
		RET

L2970:		CP	0FAh		;Disk or directory full
		JP	NC,L2A5A
		CP	0C8h
		JR	NC,L29EC	;error position found
		LD	B,A
		CALL	Print
		DEFB	'Error ',0
		LD	H,0
		LD	L,B
		PUSH	BC
		CALL	PrintInt1
		POP	BC
		LD	A,(MSGPresent)
		OR	A
		JR	Z,L29F8
		LD	HL,(L429E)	;scan MSG file
L2995:		LD	A,(HL)
		CP	EOF		;at end?
		JR	Z,L29F8		;yes -> not found
		CP	' '		;abbreviation?
		JR	C,L29AD		;yes -> ignore this line
		SUB	'0'		;get error number
		LD	C,A		;(2 decimal digits)
		ADD	A,A
		ADD	A,A
		ADD	A,C
		ADD	A,A
		INC	HL
		ADD	A,(HL)
		SUB	'0'
		INC	HL
		CP	B		;is it the one we are searching?
		JR	Z,L29B6		;yes -> output error text
L29AD:	;advance to next line
		LD	A,(HL)
		INC	HL
		CP	CR
		JR	NZ,L29AD
		INC	HL
		JR	L2995

L29B6:	;output error text
		CALL	Print
		DEFB	': ',0
L29BC:		LD	A,(HL)
		CP	CR		;end of line?
		JR	Z,L29F8		;yes -> end of error text
		CP	' '		;abbreviation?
		JR	NC,L29E6	;no -> output character
	;output abbreviation
		LD	DE,(L429E)	;scan MSG file
L29C9:		LD	A,(DE)
		INC	DE
		CP	' '		;abbreviation?
		JR	NC,L29DD	;no -> ignore this line
		CP	(HL)		;is it the one we are searching?
		JR	NZ,L29DD	;no -> ignore this line
L29D2:		LD	A,(DE)
		CP	CR		;end of line?
		JR	Z,L29E9		;yes -> continue outputting error text
		CALL	SConOut
		INC	DE
		JR	L29D2

L29DD:	;advance to next line
		LD	A,(DE)
		INC	DE
		CP	CR		;end of line?
		JR	NZ,L29DD	;no -> continue
		INC	DE
		JR	L29C9		;yes -> continue scanning

L29E6:		CALL	SConOut
L29E9:		INC	HL
		JR	L29BC

L29EC:		CALL	L2A7A
		CALL	Print
		DEFB	'found',0
L29F8:		XOR	A
		LD	(L44F1),A
		LD	A,(CInclude)
		OR	A
		JR	Z,L2A41
		LD	A,'.'
		CALL	SConOut
		CALL	AutoSave
		LD	DE,WorkFCB
		LD	HL,InclFCB
		LD	BC,12
		LDIR
		CALL	MWorkF2
		CALL	Print
		DEFB	CR,LF,'Error found in above include file',0
IF TPVers3
		JR	L2A51
ELSE	;TPVers2
		LD	A,(778Fh)	;<---//
		OR	A
		JR	Z,L2A51
		JP	MainMenue
ENDIF

L2A41:		CALL	MainFGiven
		JR	Z,L2A51		;no -> take WorkFile
		LD	DE,WorkFCB	;yes, take MainFile
		LD	HL,MainFCB
		LD	BC,12
		LDIR
L2A51:		CALL	PressEscape
		LD	HL,(CErrPos)	;error position in text
		JP	L2AFE

L2A5A:		CALL	Print
IF TPVers2
		DEFB	'*** '
ENDIF
		DEFB	'Disk or directory full',0
		CALL	PressEscape
		JP	MainMenue

L2A7A:		CALL	Print
		DEFB	'Run-time error position ',0
		RET

MRun:		LD	A,(CompFlag)
		OR	A		;compiled?
		CALL	Z,MCompile	;no -> then do it now
		LD	A,(CmpZiel)
		DEC	A		;in memory?
		JR	Z,L2ADF		;yes -> go along
		DEC	A		;COM file?
		RET	NZ		;no -> exit, CHN file is not possible
		CALL	L2B33		;load overlay
		RET	Z
		CALL	MainFGiven
		LD	HL,WorkFCB
		JR	Z,L2AB5
		LD	HL,MainFCB
L2AB5:		LD	DE,ObjFCB
		LD	BC,12
		LDIR
		LD	A,'C'
		LD	HL,'MO'
		LD	(ObjFCB+9),A	;insert extension
		LD	(ObjFCB+10),HL
		LD	DE,ObjFCB
		CALL	ClearFCB
		PUSH	DE
		LD	C,OpenFile
		CALL	SBDOS
		POP	HL
		INC	A		;not found?
		JP	Z,LoadAll	;yes -> load everything back in
		LD	DE,EmptyArg	;no parameters given, what a pity!
		JP	L2B7A		;start overlay

L2ADF:		LD	(CmdLine),A	;=0 clear command line
		CALL	L281D		;end of text -> 7904h
		CALL	Print
		DEFB	CR,LF,'Running',CR,LF,0
		LD	HL,(CCodeStart)	;start address of code
		JP	(HL)		;yippie!

MEdit:		CALL	L2D50
		LD	HL,-1		;text position
L2AFE:		PUSH	HL
		LD	HL,(ConOutPtr)	;set up own output routine
		LD	(OldConOut),HL ;InTheCode!
		LD	HL,EdiConOut
		LD	(ConOutPtr),HL
		POP	HL
		JP	L2E91

;End edit
ECmd38:		CALL	L3E40
		LD	HL,(Height)
		DEC	L
		LD	H,0
		CALL	CsrXY
		LD	HL,(OldConOut)	;InTheCode!
		LD	(ConOutPtr),HL
		JP	MainMenue

MQuit:		CALL	AutoSaveQ
		CALL	CrtExit
IF TPVers2
		LD	A,(LoggedDrive)
		DEC	A
		LD	(CurrDU),A
ENDIF
		JP	WBoot

MExecute:	CALL	L2B33		;load overlay
		RET	Z
		JR	L2B5A		;start overlay

;load overlay
L2B33:		CALL	AutoSaveQ
		LD	DE,WhoAmI
		LD	A,'O'
		LD	HL,'RV'
		CALL	L2E20
		RET	Z
		LD	DE,OverArea-SecSize
L2B45:		LD	HL,SecSize
		ADD	HL,DE
		PUSH	HL
		EX	DE,HL
		LD	C,SetDMA
		CALL	BDOS
		LD	C,ReadSeq
		CALL	DefSBDOS
		POP	DE
		OR	A
		JR	Z,L2B45
		RET

;start overlay
L2B5A:		CALL	Print
		DEFB	CR,LF,'Program',0
		CALL	GetLine
		JP	Z,LoadAll	;nothing entered -> go back
		LD	A,'C'
		LD	HL,'MO'
		CALL	L2E20
		JR	Z,L2B5A		;not found, try again
		LD	HL,DefaultFCB
;7 parameters are handed over to the overlay.
L2B7A:		PUSH	DE		;pointer to argument or ^Z
		PUSH	HL		;pointer to FCB
		LD	A,(LoggedDrive)
		PUSH	AF		;number of current drive
		LD	HL,ParseAFN
		PUSH	HL		;address of parse routine
		LD	HL,TextStart-L4450	;0F4h
		PUSH	HL		;number of bytes to be saved
		LD	HL,L4450	;pointer to beginning of
		PUSH	HL		;area to be saved
		LD	HL,LoadAll
		PUSH	HL		;return address
		JP	OverArea	;start overlay

;END OF TP-ME1.INC
;-----------------
