;--------------------------------
;TP-ME4.INC	ho	03-MAR-94
;--------------------------------
;V2.00: 417Fh-442Ch
;V3.00: 429Eh-4549h	V3.01: 4280h-452Bh

		IDENT	TP-ME4.INC

L429E:		DEFW	L7BF5		;beginning of MSG file

EmptyArg:	DEFB	EOF		;for Run/Execute

.COMMENT %----------------------------------------------------------------
Installation area for editor commands

Editor commands are stored as a zero-terminated compact series of strings.
The order in which they appear is exactly the one as TINST presents them.
Internally the editor works with command numbers only instead of the
command strings itself. The numbers are the same that TINST shows.
The only exception from that is command number 0 (return), which can't
be installed.

CURSOR MOVEMENTS:

 1:  Character left			Ctrl-S
 2:    Alternative			Nothing
 3:  Character right			Ctrl-D
 4:  Word left				Ctrl-A
 5:  Word right				Ctrl-F
 6:  Line up				Ctrl-E
 7:  Line down				Ctrl-X
 8:  Scroll down			Ctrl-W
 9:  Scroll up				Ctrl-Z
10:  Page up				Ctrl-R
11:  Page down				Ctrl-C
12:  To left on line			Ctrl-Q Ctrl-S
13:  To right on line			Ctrl-Q Ctrl-D
14:  To top of page			Ctrl-Q Ctrl-E
15:  To bottom of page			Ctrl-Q Ctrl-X
16:  To top of file			Ctrl-Q Ctrl-R
17:  To end of file			Ctrl-Q Ctrl-C
18:  To begining of block		Ctrl-Q Ctrl-B
19:  To end of block			Ctrl-Q Ctrl-K
20:  To last cursor position		Ctrl-Q Ctrl-P

INSERT & DELETE:

21:  Insert mode on/off			Ctrl-V
22:  Insert line			Ctrl-N
23:  Delete line			Ctrl-Y
24:  Delete to end of line		Ctrl-Q Ctrl-Y
25:  Delete right word			Ctrl-T
26:  Delete character under cursor	Ctrl-G
27:  Delete left character		Ctrl-H
28:    Alternative			Nothing

BLOCK COMMANDS:

29:  Mark block begin			Ctrl-K Ctrl-B
30:  Mark block end			Ctrl-K Ctrl-K
31:  Mark single word			Ctrl-K Ctrl-T
32:  Hide/display block			Ctrl-K Ctrl-H
33:  Copy block				Ctrl-K Ctrl-C
34:  Move block				Ctrl-K Ctrl-V
35:  Delete block			Ctrl-K Ctrl-Y
36:  Read block from disk		Ctrl-K Ctrl-R
37:  Write block to disk		Ctrl-K Ctrl-W

MISC. EDITING COMMANDS:

38:  End edit				Ctrl-K Ctrl-X [oder Ctrl-K Ctrl-D]
39:  Tab				Ctrl-I
40:  Auto tab on/off			Ctrl-Q Ctrl-I
41:  Restore line			Ctrl-Q Ctrl-L
42:  Find				Ctrl-Q Ctrl-F
43:  Find & replace			Ctrl-Q Ctrl-A
44:  Repeat last find			Ctrl-L
45:  Control character prefix		Ctrl-^ [oder Ctrl-P]

----------------------------------------------------------------% ;COMMENT

ECmdInst:	DEFB	1,CR,2,ESC,'D',1,0FFh,2,ESC,'C'		;00-03
		DEFB	1,0FFh,1,0FFh,2,ESC,'A',2,ESC,'B'	;04-07
		DEFB	1,0FFh,1,0FFh,1,0FFh,1,0FFh		;08-11
		DEFB	1,0FFh,1,0FFh,1,0FFh,1,0FFh		;12-15
		DEFB	1,0FFh,1,0FFh,1,0FFh,1,0FFh		;16-19
		DEFB	1,0FFh,1,0FFh,1,0FFh,1,0FFh		;20-23
		DEFB	1,0FFh,1,0FFh,1,0FFh,1,0FFh		;24-27
		DEFB	1,0FFh,1,0FFh,1,0FFh,1,0FFh		;28-31
		DEFB	1,0FFh,1,0FFh,1,0FFh,1,0FFh		;32-35
		DEFB	1,0FFh,1,0FFh,1,0FFh,1,0FFh		;36-39
		DEFB	1,0FFh,1,0FFh,1,0FFh,1,0FFh		;40-43
		DEFB	1,0FFh,1,0FFh				;44-45

		DEFS	ECmdInst+200-$,0
;end of installation area

;table of default command strings
ECmdOrg:	DEFB	1,CR,1,CtlS,1,CtlH,1,CtlD		;00-03
		DEFB	1,CtlA,1,CtlF,1,CtlE,1,CtlX		;04-07
		DEFB	1,CtlW,1,CtlZ,1,CtlR,1,CtlC		;08-11
		DEFB	2,CtlQ,CtlS,2,CtlQ,CtlD,2,CtlQ,CtlE	;12-14
		DEFB	2,CtlQ,CtlX,2,CtlQ,CtlR,2,CtlQ,CtlC	;15-17
		DEFB	2,CtlQ,CtlB,2,CtlQ,CtlK,2,CtlQ,CtlP	;18-20
		DEFB	1,CtlV,1,CtlN,1,CtlY,2,CtlQ,CtlY	;21-24
		DEFB	1,CtlT,1,CtlG,1,DEL,1,0FFh		;25-28
		DEFB	2,CtlK,CtlB,2,CtlK,CtlK,2,CtlK,CtlT	;29-31
		DEFB	2,CtlK,CtlH,2,CtlK,CtlC,2,CtlK,CtlV	;32-34
		DEFB	2,CtlK,CtlY,2,CtlK,CtlR,2,CtlK,CtlW	;35-37
		DEFB	2,CtlK,CtlD,1,CtlI,2,CtlQ,CtlI		;38-40
		DEFB	2,CtlQ,CtlL,2,CtlQ,CtlF,2,CtlQ,CtlA	;41-43
		DEFB	1,CtlL,1,CtlP,0				;44-45

L43DE:		DEFB	'<>,[].*+-/$:=(){}^#'''
L43F2:		DEFB	' '
		DEFB	0

;jump table for commands 00-45
EJumps:		DEFW	ECmd00
		DEFW	ECmd01
		DEFW	ECmd02
		DEFW	ECmd03
		DEFW	ECmd04
		DEFW	ECmd05
		DEFW	ECmd06
		DEFW	ECmd07
		DEFW	ECmd08
		DEFW	ECmd09
		DEFW	ECmd10
		DEFW	ECmd11
		DEFW	ECmd12
		DEFW	ECmd13
		DEFW	ECmd14
		DEFW	ECmd15
		DEFW	ECmd16
		DEFW	ECmd17
		DEFW	ECmd18
		DEFW	ECmd19
		DEFW	ECmd20
		DEFW	ECmd21
		DEFW	ECmd22+8000h
		DEFW	ECmd23+8000h
		DEFW	ECmd24+8000h
		DEFW	ECmd25+8000h
		DEFW	ECmd26+8000h
		DEFW	ECmd27+8000h
		DEFW	ECmd28+8000h
		DEFW	ECmd29
		DEFW	ECmd30
		DEFW	ECmd31
		DEFW	ECmd32
		DEFW	ECmd33+8000h
		DEFW	ECmd34+8000h
		DEFW	ECmd35+8000h
		DEFW	ECmd36+8000h
		DEFW	ECmd37
		DEFW	ECmd38
		DEFW	ECmd39+8000h
		DEFW	ECmd40
		DEFW	ECmd41+8000h
		DEFW	ECmd42
		DEFW	ECmd43
		DEFW	ECmd44
		DEFW	ECmd45+8000h

;when doing Run or Execute, the variables from here to excl. 4544h
;are saved
L4450:		DEFW	0	;is initialized witht TextStart  =#1
		;	8 byte are copied from here to 4458h
L4452:		DEFW	L7B74
L4454:		DEFW	0
L4456:		DEFW	L7B74
L4458:		DEFW	0
L445A:		DEFW	L7B74

TypeARead:	DEFW	L7B59		;read pointer for TypeAhead buffer
TypeAWrite:	DEFW	L7B59		;write pointer for   "
L4460:		DEFW	0
L4462:		DEFW	0
L4464:		DEFW	2
L4466:		DEFW	2
L4468:		DEFW	0
L446A:		DEFW	0
L446C:		DEFB	0	;+00 IY
L446D:		DEFB	0	;+01
L446E:		DEFB	1
L446F:		DEFB	1
L4470:		DEFB	0	;+04	some x
L4471:		DEFB	1	;+05	some y
L4472:		DEFB	0	;+06
L4473:		DEFB	1	;+07	bit 0 =0 suppresses output
L4474:		DEFB	0	;+08
L4475:		DEFB	1	;+09
L4476:		DEFW	0
L4478:		DEFB	0
L4479:		DEFB	0	;+13
L447A:		DEFB	1	;+14
L447B:		DEFB	1
L447C:		DEFB	0	;+16
L447D:		DEFB	0	;+17	options for search/replace
				;	bit 0 =W, 1 =N, 2 =U, 3 =G, 4 =B
L447E:		DEFB	0
WorkDirty:	DEFB	0	;+19	WorkFile dirty (0= saved, 1= dirty)
L4480:		DEFB	0	;+20
L4481:		DEFB	0	;+21
L4482:		DEFB	3	;+22
L4483:		DEFB	0	;+23
L4484:		DEFB	0,0
L4486:		DEFW	0
L4488:		DEFW	0	;position where search/replace starts
L448A:		DEFW	0
L448C:		DEFW	0
L448E:		DEFB	0,0

IF TPVers2
		DEFB	CR,LF
ENDIF

L4490:		DEFB	30		;Find text
L4491:		DEFB	0
L4492:		DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0
		DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0
		DEFB	0,0,0,0,0

L44B1:		DEFB	30		;Replace-With text
L44B2:		DEFB	0
L44B3:		DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0
		DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0
		DEFB	0,0,0,0,0

L44D2:		DEFB	10		;Options text
L44D3:		DEFB	0,0,0,0,0,0,0,0,0,0,0,0

L44DF:		DEFB	15,0
L44E1:		DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0
		DEFB	0,0,0

L44F1:		DEFB	0		;1= WorkFile=MainFile, 0= WorkFile<>MainFile
L44F2:		DEFB	0		;=1 after save. Is queried in FullError
CmpZiel:	DEFB	1		;destination (1= memory, 2= COM file, 3= CHN file)
StrtAddress:	DEFW	EditComp	;start address (default is 20E2h)
EndAddress:	DEFW	0		;end address (default is 708 below BDOS)
LoggedDrive:	DEFB	0		;current drive (A=1)

MainFCB:	DEFB	0
;44FAh:	if =0, then no MainFile specified
		DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0
		DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0
		DEFB	0,0,0,0,0,0,0,0,0

WorkFCB:	DEFB	0
;451Eh:	if =0, then no WorkFile specified
		DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0
		DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0
		DEFB	0,0,0,0,0,0,0,0,0

MSGPresent:	DEFB	0		;whether MSG file was read in (0= no, 1= yes)
CompFlag:	DEFB	0		;whether compiled (0= no, 1= yes)
L4543:		DEFB	0		;counts characters output, after 128 chars
					;we look for a keystroke (TypeAhead)
TextStart:	DEFW	L7BF5		;beginning of text WorkFile
TextEnd:	DEFW	L7BF5		;end of text WorkFile
MaxMem:		DEFW	0		;end of free space = beginning of stack
					;(1K below BDOS)

;END OF TP-ME4.INC
;-----------------
