;--------------------------------
;TP-RTL1.INC	ho	01-MAR-94
;--------------------------------
;V1.00: 0100h-04BEh
;V2.00: 0100h-04FBh	V2.01: 0100h-04F5h
;V3.00: 0100h-052Bh	V3.01: 0100h-052Ch

		IDENT	TP-RTL1.INC

;start of program
;----------------

		JP	PascalProgram	;skip runtime library

	;From here to Frequency there are no important informations.
	;Thatswhy this space can be used for additional patches or
	;overlays. Especially if you want to make your TP program a
	;ZCPR3 type 1 program you have to patch here.

IF TPVers1
		DEFW	1234h
ELSE	;TPVers2, TPVers3
		DEFW	0ABCDh
ENDIF
	;Magic. Maybe to write a version-independant installation program.

Copyright:	DEFB	'Copyright (C) 198'
IF TPVers1
		DEFB	'3'
ELSE
 IF TPVers2
		DEFB	'4'
 ELSE	;TPVers3
		DEFB	'5'
 ENDIF
ENDIF
		DEFB	' BORLAND Inc'
IF NOT TPVers1
		DEFB	0

;hardware dependent information
;------------------------------
Frequency:	DEFW	4		;Operating frequency of CPU (1-12 MHz)
;why is this damn thing in the middle of an area thats so well suited
;for patches? You always have to program around it! And why is it a
;word? A byte would have been more than enough.

;some type of internal version number?
;Or is this a tricky coding of the release date?
;'A' corresponds with Copyright 1984, while 'B' does with 1985!
;But as a byte can take on only 256 values whereas a year has 365 days,
;it can't be accurate to a single day ...
IF TPVersion EQ 200
		DEFB	82h,'A'
ELSE
 IF TPVersion EQ 201
		DEFB	23h,'A'
 ELSE
  IF TPVersion EQ 300
		DEFB	0A1h,'B'
  ELSE	;V3.01
		DEFB	83h,'B'
  ENDIF
 ENDIF
ENDIF
		DEFB	0		;why?

PatchArea:	DEFS	42
ENDIF

;screen installation area
;------------------------

	;The path area can be extended up to Width in TP programs if needed,
	;but not in the compiler itself (TURBO.COM), because the TermTypStr
	;is used by the compiler. After patching over this additional space
	;TINST should not be used to prevent hassle.

;Terminal >>
TermTypStr:	DEFB	20,'No Terminal selected'
IF TPVers1
Frequency:	DEFB	4
InitialStr:	DEFS	16
ResetStr:	DEFS	16

;Cursor >>
CursorStr:	DEFS	16		;template for cursor positioning
BinaryAddr:	DEFB	0		;0=ASCII, 1=binary address
XPosition:	DEFB	0		;pos. in template
YPosition:	DEFB	0		;	"
ColumnOff:	DEFB	0
LineOff:	DEFB	0
DelayCursor:	DEFW	0		;delay after cursor address (0-255 ms)

;Line >>
ClearScrStr:	DEFS	6		;clear screen
HomeStr:	DEFS	6		;home cursor (this string is empty,
					;if clear screen already includes home)
DelayLine:	DEFW	0		;delay after clear, delete and
					;insert (0-255 ms)
HLStartStr:	DEFS	6		;start highlighting
HLEndStr:	DEFS	6		;end highlighting
DelayHL:	DEFW	0		;delay after EraToEol and HighLight
EraToEolStr:	DEFS	6		;erase to end of line
InsLineStr:	DEFS	6		;insert line
DelLineStr:	DEFS	6		;delete line
Width:		DEFB	80		;screen width (1-256)
Height:		DEFB	24		;screen heigth  (1-256)
		DEFB	01h,01h,00h,9Ch,3Ch	;???
ELSE	;TPVers2, TPVers3
Width:		DEFB	80		;screen width (1-256)
Height:		DEFB	24		;screen height (1-256)
		DEFB	0		;why?

;from now on installation data is used by the runtime library
InitialStr:	DEFS	16
ResetStr:	DEFS	16

;Cursor >>
CursorStr:	DEFS	16		;template for cursor positioning
BinaryAddr:	DEFB	0		;0=ASCII, 1=binary address
ColumnOff:	DEFB	0
LineOff:	DEFB	0
XPosition:	DEFB	0		;pos. in template
YPosition:	DEFB	0		;	"
DelayCursor:	DEFW	0		;delay after cursor address (0-255 ms)

;Line >>
ClearScrStr:	DEFS	6		;clear screen
HomeStr:	DEFS	6		;home cursor (this string is empty,
					;if clear screen already includes home)
InsLineStr:	DEFS	6		;insert line
DelLineStr:	DEFS	6		;delete line
DelayLine:	DEFW	0		;delay after clear, delete and
					;insert (0-255 ms)

;Highlight >>
EraToEolStr:	DEFS	6		;erase to end of line
HLStartStr:	DEFS	6		;start highlighting
HLEndStr:	DEFS	6		;end highlighting
DelayHL:	DEFW	0		;delay after EraToEol and HighLight
ENDIF

;terminal control routines
;-------------------------

;output string (first byte of string is length)
;E: pointer to string in HL
;V: AF, BC, DE, HL
;R: HL points behind string, A=0 and Zero. Carry if string was empty
OutString:	LD	A,(HL)		;get length
		OR	A		;=0?
		SCF
		RET	Z		;if yes, exit with Carry
OutString1:	INC	HL
		PUSH	AF
		PUSH	HL
		LD	A,(HL)
		CALL	OutChar
		POP	HL
		POP	AF
		DEC	A
IF TPVersion EQ 301
;this is the only place, where V3.01 and V3.00 differ
		JR	NZ,OutString1
		OR	A		;set NCarry
		RET
ELSE	;V1.00, V2.00, V2.01, V3.00
;minor error here: it is not guaranteed that NCarry is returned!
;DEC A doesn't change Carry, and if you trace back, you'll find that
;the Carry flag hasn't been changed since the last BIOS call.
;And what the BIOS call returns in the Carry flag is not defined.
		RET	Z
		JR	OutString1
ENDIF

;output carriage return/line feed
;E:- / R:- / V:-
NewLine:	CALL	Print
		DEFB	CR,LF,0
		RET

CodePiece1	MACRO
;output character (with saving registers)
;E: character in A / V:- / R:-
SConOut:	PUSH	BC
		PUSH	DE
		PUSH	HL
		PUSH	IX
		PUSH	IY
		PUSH	AF
		LD	L,A		;put character on stack
		LD	H,0		;to hand it over
		PUSH	HL
		CALL	ConOut
		POP	AF
IF TPVers1
		POP	IY
SConIO:
ELSE	;TPVers2, TPVers3
SConIO:		POP	IY
ENDIF
		POP	IX
		POP	HL
		POP	DE
		POP	BC
		RET
		ENDM

IF (TPVers1 OR TPVers2)
		CodePiece1
ENDIF

;E: character in A
;V: AF, BC, DE, HL / R:-
OutChar:	LD	L,A
		PUSH	HL		;JP ConOut is not possible here,
		CALL	ConOut		;because ConOut expects his parameter
		RET			;under the return address on the stack

;output character with Highlighting on/off
;E: character in A
;V: AF, BC, DE, HL / R:-
OutHChar:	CP	80h
		CALL	C,LowVideo
		CALL	NC,NormVideo
		AND	7Fh
		JR	OutChar

CodePiece2	MACRO
;input character (with saving registers)
;E:- / V: AF, bei TPVers1 u.U. IY
;R: characters in A
SConInp:	PUSH	BC
		PUSH	DE
		PUSH	HL
		PUSH	IX
IF NOT TPVers1
		PUSH	IY
ENDIF
		CALL	ConInp
		LD	A,L
		JR	SConIO
		ENDM

IF (TPVers1 OR TPVers2)
		CodePiece2
ENDIF

;output null-terminated string with Highlighting on/off
;E: (SP)=pointer to string
;V: (SP) / R:-
PrintH:		PUSH	HL
		LD	HL,OutHChar
		JR	Print1

;output null-terminated string
;E: (SP)=pointer to string
;V: (SP) / R:-
Print:		PUSH	HL
		LD	HL,OutChar
Print1:		LD	(PrintPatch),HL	;patch in subroutine for character output
		POP	HL
		EX	(SP),HL		;save HL and get pointer to string
		PUSH	AF		;save other registers
		PUSH	BC
		PUSH	DE
Print2:		LD	A,(HL)		;get character
		INC	HL
		OR	A		;end reached?
		JR	Z,Print3	;yes, then exit
		PUSH	HL		;no, then save pointer
PrintPatch	EQU	$+1		;and do character output
		CALL	1234		;TP programs have a CALL OutChar here,
					;because the compiler did already run
		POP	HL
		JR	Print2

Print3:		POP	DE		;restore registers
		POP	BC
		POP	AF
		EX	(SP),HL		;continue program after end of string
		RET

;delay
;E: ticks in HL
;V: AF, HL
;R: HL=A=0 and Zero, NCarry
Delay:		LD	A,L			;null ticks?
		OR	H			;(clears Carry)
		RET	Z			;yes, then exit
		LD	A,(Frequency)
		ADD	A,A
		ADD	A,A
		ADD	A,A 
Delay1:		EX	(SP),HL			;waste some time!
		EX	(SP),HL
		EX	(SP),HL
		EX	(SP),HL
		PUSH	BC
		LD	BC,1234			;very nice
		POP	BC
		DEC	A
		JR	NZ,Delay1
		DEC	HL
		JR	Delay

.COMMENT %----------------------------------------------------------------
inner loop:
	19+19+19+19+11+10+10+4+12 = 123 (+7 instead of +12 the last time)
outer loop:
	4+4+5+13+4+4+4+(8 x Frequency x 123)-5+6+12 = 984 x Frequency + 51
all:
	Delay x (984 x Frequency + 51)+4+4+11 =
		(984 x Delay x Frequency) + (51 x Delay) + 19
example:
	Frequency = 4 MHz --> 3987 x Delay + 19 cycles
1 tick is 3987 cycles, that is 0.99675 ms in this example. Mathematically
correct would be 4000 cycles. But there may be interrupts costing additional
time that is not measured here that compensates a bit.
----------------------------------------------------------------% ;COMMENT

;E: pointer to string in HL
;V: AF, BC, DE, HL
;R: A=0 and Zero. Carry if string was empty, else NCarry and HL=0
OutAndDelay:	CALL	OutString
		RET	C
		LD	HL,(DelayHL)
		JR	Delay		;could be omitted if routine
					;Delay is moved here

;clear screen
;E:- / V:- / R:-
ClrScr:		PUSH	AF
		PUSH	BC
		PUSH	DE
		PUSH	HL
		LD	HL,HomeStr
		CALL	OutAndDelay
		LD	HL,ClearScrStr
ClrDelIns:	CALL	OutString
		LD	HL,(DelayLine)	;Delay only, if Clear/Delete/
		CALL	NC,Delay	;Insert-string was not empty
		POP	HL
		POP	DE
		POP	BC
		POP	AF
		RET

;For all following routines:
;		PUSH	HL
;		LD	HL,..Str
;		JR	-->	PUSH DE/PUSH BC/PUSH AF ...
;would have saved space.

;delete line
;E:- / V:- / R:-
DelLine:	PUSH	AF
		PUSH	BC
		PUSH	DE
		PUSH	HL
		LD	HL,DelLineStr
		JR	ClrDelIns

;insert line
;E:- / V:- / R:-
InsLine:	PUSH	AF
		PUSH	BC
		PUSH	DE
		PUSH	HL
		LD	HL,InsLineStr
		JR	ClrDelIns

;output HLEndStr, if HLightFlag <> 0
;E:- / V:- / R: HLightFlag=0
LowVideo:	PUSH	AF
		LD	A,(HLightFlag)
		OR	A
		JR	Z,HLVideo2
		PUSH	BC
		PUSH	DE
		PUSH	HL
IF (TPVers1 OR TPVers2)
		DEC	A		;1 -> 0
ELSE	;TPVers3
		XOR	A		;is safer
ENDIF
		LD	(HLightFlag),A
		LD	HL,HLEndStr
HLVideo1:	CALL	OutAndDelay
		POP	HL
		POP	DE
		POP	BC
HLVideo2:	POP	AF
		RET

;output HLStartStr, if HLightFlag <> 0FFh (V1.00, 2.0x: <>1)
;E:- / V:- / R: HLightFlag=0FFh (V1.00, V2.0x: =1)
NormVideo:	PUSH	AF
		LD	A,(HLightFlag)
IF (TPVers1 OR TPVers2)
		OR	A
		JR	NZ,HLVideo2
ELSE	;TPVers3
		CP	0FFh
		JR	Z,HLVideo2
ENDIF
		PUSH	BC
		PUSH	DE
		PUSH	HL
IF (TPVers1 OR TPVers2)
		INC	A		;0 -> 1
ELSE	;TPVers3
		LD	A,0FFh		;well - DEC A would be ok too
ENDIF
		LD	(HLightFlag),A
		LD	HL,HLStartStr
		JR	HLVideo1

IF (TPVers1 OR TPVers2)
HLightFlag	DEFB	1
;Having a single flag in the mid of the code was really not a good
;idea. I'm glad they changed that in vers. 3.
ENDIF

;clear to end of line
;E:- / V:- / R:-
ClrEol:		PUSH	AF
		PUSH	BC
		PUSH	DE
		PUSH	HL
		LD	HL,EraToEolStr
		JR	HLVideo1

;move cursor
;E: x in H, y in L / V:- / R:-
CsrXY:		PUSH	AF
		PUSH	BC
		PUSH	DE
		PUSH	HL
		PUSH	HL
		LD	DE,CursorBuff	;cursor positioning template
		LD	HL,CursorStr	;copy it
		LD	BC,16
		LDIR
		POP	DE		;now x in D, y in E
		LD	A,(XPosition)	;convert x and y and put
		LD	C,A		;result in cursor pos. template
		LD	A,(ColumnOff)
		ADD	A,D
		PUSH	DE
		CALL	InsNumber
		POP	DE
		LD	A,(YPosition)
		LD	C,A
		LD	A,(LineOff)
		ADD	A,E
		CALL	InsNumber
		LD	HL,CursorBuff	;now output the complete cursor
		CALL	OutString	;positioning sequence
		LD	HL,(DelayCursor)
		CALL	Delay
		POP	HL
		POP	DE
		POP	BC
		POP	AF
		RET

;insert x- or y-value in templaten (binary or ascii)
;E: position in C, value in A
;V: AF, BC, DE, HL / R:-
InsNumber:	LD	HL,CursorBuff	;calculate pointer to x-/y-field
		LD	B,0		;LD B,H would be better
		ADD	HL,BC
		EX	DE,HL		;save it
		LD	HL,BinaryAddr
		INC	(HL)
		DEC	(HL)		;binary address?
		JR	Z,InsAscii	;no, convert
		LD	(DE),A		;yes, insert (one byte wide)
		RET

;insert x- or y-value in template (ascii)
;The pointer points to the last character of the field, which is 2 or 3
;characters wide and initialised with '0' characters. Leading zeros are
;not produced by this routine, thatswhy it can be used with both field
;widths. With a field width of two the value has to be smaller than 100
;though, otherwise the byte in front of the field will be destroyed.
;E: pointer to x- or y-field in DE, value in A
;V: AF, BC, DE, HL / R:-
InsAscii:	DEC	DE		;pointer to or before start of field
		DEC	DE
		LD	HL,InsTens+3
		LD	B,3
InsAscii1:	DEC	HL
		LD	C,'0'-1
InsAscii2:	INC	C		;subtract that power of 10
		SUB	(HL)		;until one time too much
		JR	NC,InsAscii2
		ADD	A,(HL)		;undo last subtraction
		PUSH	AF		;save remainder of division
		LD	A,C		;don't fill in zeros
		CP	'0'
		JR	Z,InsAscii3
		LD	(DE),A		;fill in cipher
InsAscii3:	INC	DE
		POP	AF		;get remainder of division
		DJNZ	InsAscii1	;continue until reaching the ones
		RET

InsTens:	DEFB	1,10,100

;E:- / V: AF, BC, DE, HL
;R: A=0 and Zero. Carry if InitialStr was empty, else NCarry and HL=0
CrtInit:	LD	HL,InitialStr
		JP	OutAndDelay

;E:- / V: AF, BC, DE, HL
;R: A=0 and Zero. Carry if ResetStr was empty, else NCarry and HL=0
CrtExit:	LD	HL,ResetStr
		JP	OutAndDelay

;character Input-/Output-routines
;--------------------------------
;All routines with a @ in their name are not called directly
;but via the IO jump table that is located in the zero page.
;For all routines, if not explicitely stated otherwise: V: AF, BC, DE, HL

;E:- / R: HL=1 (TRUE) if char available, else HL=0 (FALSE)
@ConSta:	LD	DE,1*3		;console status
		CALL	BiosCall	;E:- R: 0FFh if char available, else 0
		AND	1		;convert to BOOLEAN
		JR	AtoHL

;E:- / R: char in HL
@ConInp:	LD	DE,2*3		;console input
BiosInp:	CALL	BiosCall	;E:- / R: char in A
AtoHL:		LD	L,A
		LD	H,0
		RET

;E:- / R: char in HL
@RdrInp:	LD	DE,6*3		;reader input
		JR	BiosInp

;E: char on stack (under return address) / R:-
@LstOut:	LD	DE,4*3		;list output
		JR	BiosOut

;E: char on stack (under return address) / R:-
@PunOut:	LD	DE,5*3		;puncher output
		JR	BiosOut

;E: char on stack (under return address) / R:-
@ConOut:	LD	DE,3*3		;console output

.COMMENT %----------------------------------------------------------------
alternate idea for the above routines with masked instructions:
(3 byte shorter)
@LstOut:	LD	E,4*3		;12 cycles more
		DEFB	01h		;LD BC,...
@PunOut:	LD	E,5*3		;2 cycles more
		DEFB	01h
@ConOut:	LD	E,3*3		;4 cycles more
		LD	D,0
A totally different idea would be to copy the BIOS jump table or parts of
it to a fixed, known address when the program starts. Then you can always
jump to a fixed location without having to calculate (WBOOT+1)+Offset.
Needs some space in the data section though.
----------------------------------------------------------------% ;COMMENT

;E: DE= BiosCall number times 3, char on stack (under return address)
BiosOut:	POP	HL		;remove return address
		POP	BC		;get char to reg C
		PUSH	HL		;restore return address
		LD	A,(CBreak)
		OR	A		;shall ^S/^C be honored?
		JR	Z,BiosCall	;no -> output
IF (TPVers1 OR TPVers2)
		LD	A,C
		CP	CR
		JR	NZ,BiosCall
ENDIF
		PUSH	DE
		PUSH	BC
		CALL	ConSta		;look if char available
		LD	A,H
		OR	L
		JR	Z,BiosOut1	;no -> output
		CALL	SConInp		;yes -> get the character
		CP	CtlS		;does user wish to stop output?
		JR	NZ,BiosOut1	;no -> output
		CALL	SConInp		;yes -> wait for next char
		CP	CtlC		;does user wish to abort program?
		JP	Z,HaltProgram	;yes -> abort program
BiosOut1:	POP	BC
		POP	DE
BiosCall:	LD	HL,(WBoot+1)	;points to BIOS jump table
		ADD	HL,DE
		JP	(HL)

;E: buffer address (= end address-0080h) in HL,
;   directive C in B, directive U in C
;   V2.0x: pointer to Input- resp. OutputFIB in DE
;V: AF, BC, DE, HL / R:-
;This routine is called once at the beginning of the pascal program and
;is therefore well suited to implement the additional feature of saving
;the CP/M command line before it is overwritten by TPs variables.
InitCharIO:	LD	(BufPos),HL
IF (TPVers1 OR TPVers2)
		PUSH	DE		;save pointer to FIB
ENDIF
		LD	A,B		;directive C (^S/^C)
		LD	(CBreak),A
		LD	A,C		;directive U (^C breaks)
		OR	A
		JR	Z,DefaultIO
		LD	A,JumpOp	;install BreakPoint = RST 38h
		LD	(BreakEntry),A	;divert to handler
		LD	HL,BreakHandler
		LD	(BreakEntry+1),HL
	;TP programs for the Schneider (Amstrad) CPC computer have a patch
	;here: BreakEntry is moved to 30h from 38h (does anybody know why?)
DefaultIO: ;install IO jump table
		LD	HL,@IOJumps
		LD	DE,IOJumps
		LD	BC,8*3
		LDIR
	;install file interface blocks for the devices
		LD	HL,@FIBs	;unnecessary, cause the FIBs are
		LD	DE,FIBs		;located directly behind the IOJumps
IF (TPVers1 OR TPVers2)
		LD	BC,6*3		;LD C,... would be enough
		LDIR
		POP	HL
	;copy the 7th FIB
		LD	BC,1*3		;LD C,... would be enough
		LDIR
		LD	A,127
		LD	(BufLen),A
		XOR	A
		JP	AToIORes
ELSE	;TPVers3
		LD	BC,6*2		;LD C,... would be enough
		LDIR
		XOR	A
		LD	L,A
		LD	H,A
		LD	(IORes),A
		LD	(BufNext),HL	;input line is empty
		LD	(BufLast),HL
		LD	A,126
		LD	(BufLen),A
		LD	(HLightFlag),A	;unknown state
		RET
ENDIF

@IOJumps:	JP	@ConSta
		JP	@ConInp
		JP	@ConOut
		JP	@LstOut
		JP	@PunOut
		JP	@RdrInp
		JP	@ConOut
		JP	@ConInp

;File Interface Blocks (FIBs) for the devices.
;For the layout of FIBs see file-I/O (TP-RTL6.INC)
IF (TPVers1 OR TPVers2)
@FIBs:		DEFB	3,0,0		;Con/Trm
		DEFB	3,1,0		;Kbd
		DEFB	1,2,0		;Lst
		DEFB	2,3,0		;Aux
		DEFB	3,4,0		;Usr
		DEFB	3,5,0		;Input/Output
ELSE	;TPVers3
@FIBs:		DEFB	0C1h,0		;Con/Trm
		DEFB	082h,0		;Kbd
		DEFB	043h,0		;Lst
		DEFB	0C4h,0		;Aux
		DEFB	0C5h,0		;Usr
		DEFB	0C1h,0		;Input/Output

		CodePiece1
		CodePiece2
ENDIF

;parse file name
;---------------

;parse ambiguous file name (AFN)
;E: pointer to string in DE (terminated with 1Ah?)
;V: AF, BC, DE, HL
;R: File Control Block (FCB) in DefaultFCB, DE points to separator
;A pointer to this routine (V2.00: 03F3h, V3.00: 03EEh, V3.01: 03EFh)
;is handed over to TURBO.OVR!
ParseAFN:	LD	C,0FFh		;flag: WildCards allowed
		JR	ParseFND

;parse unambiguous file name (UFN)
;E: pointer to string in BufPos
;V: AF, BC, DE, HL
;R: FCB in DefaultFCB, DE points to separator
ParseUFN:	LD	C,0		;flag: WildCards not allowed
	;PATCH>> ASSIGN with WildCards
	;PATCH>> address V2.00: 03F8h, V3.00: 03F3h, V3.01: 03F4h
	;PATCH>> 00h -> FFh (-> LD C,0FFh)
		LD	DE,(BufPos)
ParseUFN1:	INC	DE		;skip leading spaces
		LD	A,(DE)
		CP	' '
		JR	Z,ParseUFN1

;parse file name, default extension = '   '
;E: pointer to string in DE
;   flag in C 0= WildCards not allowed, <>0 allowed
;V: AF, B, DE, HL
;R: FCB in DefaultFCB, DE points to separator
ParseFND:	LD	HL,DefaultFCB+9	;clear extension
		LD	B,3
		CALL	FillSpace

;parse file name, default extension is in DefaultFCB
;E: pointer to string in DE
;   flag in C 0= WildCards not allowed, <>0 allowed
;V: AF, B, DE, HL
;R: FCB in DefaultFCB, DE points to separator
ParseFN:	LD	A,(DE)		;see if drive given
		CALL	ToUpper
		CP	'A'		;'A' to 'P' valid
		JR	C,ParseFN2
		CP	'P'+1
		JR	NC,ParseFN2
		LD	B,A		;save supposed drive letter
		INC	DE		;examine next char
		LD	A,(DE)
		CP	':'		;must be colon
		JR	NZ,ParseFN1	;if not -> back one char
		LD	A,B		;ok, it is a drive designator
		SUB	'A'-1		;A -> 1, B -> 2, ...
		INC	DE
		JR	ParseFN3

ParseFN1:	DEC	DE		;we were one char too far
ParseFN2:	XOR	A		;0 = current drive
ParseFN3:	LD	HL,DefaultFCB
		LD	(HL),A		;insert drive into FCB
		INC	HL
		INC	C
		DEC	C		;WildCards allowed?
		JR	Z,ParseFN4	;no -> continue
		LD	A,(DE)		;yes -> look if at end of filename
IF (TPVers1 OR TPVers2)
		CP	EOF
		JR	NZ,ParseFN4
ELSE	;TPVers3
		CALL	IsSepar		;if so, fill FCB name with '?'
		JR	NZ,ParseFN4
		CP	'?'		;we are at the end of the file name
		JR	Z,ParseFN4	;if the next char is a separator,
		CP	'*'		;but not '?','*' or '.'
		JR	Z,ParseFN4
		CP	'.'
		JR	Z,ParseFN4
ENDIF
		LD	B,11		;ok, fill with '?'
		CALL	FillWild
		JR	ParseFN5

ParseFN4:	LD	B,8		;process first field (name)
		CALL	ParseField
		LD	A,(DE)		;if a point follows
		CP	'.'		;we are ready
		JR	NZ,ParseFN5
		INC	DE		;else we have to process the
		LD	B,3		;second field (extension)
		CALL	ParseField
ParseFN5:	LD	HL,DefaultFCB+12	;ready!
	;now clear the rest of the FCB
		LD	B,24
ParseFN6:	LD	(HL),0		;LD (HL),H would be faster
		INC	HL		;or: XOR A/JR FillIn
		DJNZ	ParseFN6
		RET

;process a field (name or extension)
;E: DE points in string, HL points in FCB
;   C is WildCard flag, B is (remaining) length of the FCB field
;V: AF, C, DE, HL
;R: HL points behind field, DE points to separator
ParseField:	LD	A,(DE)
		INC	C
		DEC	C		;WildCards allowed?
		JR	Z,ParseField1	;no -> look for separator
IF TPVers3
		CP	'?'		;question mark is simply copied
		JR	Z,ParseField2
ENDIF
		CP	'*'		;star fills the remainder of the
		JR	Z,SkipFillW	;field with '?'
IF (TPVers1 OR TPVers2)
ParseField1:	CP	'.'
		JR	Z,FillSpace
		CP	' '+1
		JR	C,FillSpace
		CP	'}'
		JR	Z,FillSpace
		CP	'*'
		JR	Z,FillSpace
		CALL	ToUpper
ELSE	;TPVers3
ParseField1:	CALL	IsSepar		;is it a separator?
		JR	Z,FillSpace	;yes -> fill the remainder with ' '
ENDIF
ParseField2:	LD	(HL),A		;legal char -> fill in
		INC	HL
		INC	DE
		DJNZ	ParseField	;until field full
		RET

SkipFillW:	INC	DE		;skip star
FillWild:	LD	A,'?'
		JR	FillIn

FillSpace:	LD	A,' '
FillIn:		LD	(HL),A
		INC	HL
		DJNZ	FillIn		;until field full
		RET

IF TPVers3
;E: char in A / V: AF
;R: ToUpper(char) in A. Zero if separator or control char
IsSepar:	CALL	ToUpper
		CP	' '		;control char?
		JR	C,IsSepar1
		PUSH	HL
		PUSH	BC
		LD	HL,SepTable
		LD	BC,SepLength
		CPIR
		POP	BC
		POP	HL
		RET

IsSepar1:	CP	A		;set Zero flag without
		RET			;destroying character

SepTable:	DEFB	' .,;:=?*[]<>{}'
SepLength	EQU	$-SepTable
ENDIF

;convert lower case to upper case
;E, R: char in A / V: AF
ToUpper:	CP	'a'		;if it's smaller than 'a'
		RET	C
		CP	'z'+1		;or bigger than 'z',
	;PATCH>> UpCase with umlaut characters
	;PATCH>> Adresse V2.00: 0488h, V3.00: 04AAh, V3.01: 04ABh
	;PATCH>> 7Bh -> 7Eh (-> CP '}'+1)
		RET	NC		;then it's no lower case letter
		SUB	20h		;else we convert it
		RET

;The following two routines may be used from within pascal programs.
;HexW: V2.00: InLine($cd/$48d), V3.00: InLine($cd/$4af), V3.01: InLine($cd/$4b0)
;HexB: V2.00: InLine($cd/$491), V3.00: InLine($cd/$4b3), V3.01: InLine($cd/$4b4)

;output word hexadecimal
;E: word in HL / V: AF / R:-
HexW:		LD	A,H		;first the high byte
		CALL	HexB
		LD	A,L		;then the low byte
;<fall through>

;output byte hexadecimal
;E: byte in A / V: AF / R:-
HexB:		PUSH	AF
		RRA			;first the high nibble
		RRA
		RRA
		RRA
		CALL	Nibble
		POP	AF		;then the low nibble
;<fall through>
Nibble:		AND	0Fh		;mask nibble
		ADD	A,90h		;00h-09h --> 30h-39h ('0'-'9')
		DAA			;0Ah-0Fh --> 41h-46h ('A'-'F')
		ADC	A,40h
		DAA
		JP	SConOut		;could be saved by putting HexW/HexB
					;directly in front of SConOut

;range 0-255:
;Check value and force it in legal range (by setting it to edge of
;legal range: negative value -> 0, too big -> 255)
;E: integer in HL / V: AF
;R: A=0, Carry, NZero if HL negative (Bit 7,H =1)
;   A=L, NCarry, Zero if H=0
;   A=0FFh, NCarry, NZero else
Range256:	XOR	A
		SCF
		BIT	7,H
		RET	NZ
		LD	A,H
		OR	A
		LD	A,L
		RET	Z
		LD	A,0FFh
		RET

IF (TPVers1 OR TPVers2)
;Initialisation of memory management
;E: continuation address in BC (=0 if stand alone),
;   stackpointer in DE, pointer behind program end in HL
;R: SP set
InitMem:	LD	(HeapPtr),HL
		LD	(ContAdr),BC
IF TPVers2
		LD	(FreeRoot),HL
		LD	B,4
InitMem1:	LD	(HL),0		;compare with ParseFN6
		INC	HL
		DJNZ	InitMem1
ENDIF
ELSE	;TPVers3
;Initialisation of memory management
;E: StandAlone flag in A
;   memory end in BC (as specified by compiler option E),
;   stackpointer in DE, pointer behind program end in HL
;R: SP set
InitMem:	LD	(StandAlone),A
		PUSH	BC		;save memory end
		CALL	InitHeap	;init. HeapPtr, FreeRoot
		POP	BC
		LD	HL,(BDOS+1)	;memory end
		OR	A
		SBC	HL,BC		;< TopOfMemory?
		JP	C,OutOfMem	;no -> Out Of Memory
ENDIF
		EX	DE,HL		;stackpointer to HL
		POP	DE		;return address to DE
		LD	SP,HL
		LD	BC,-1024	;reserve 1K for stack
		ADD	HL,BC
		LD	(RecurPtr),HL	;below that the recursion stack starts
IF TPVers3
		XOR	A
		LD	L,A
		LD	H,A
		LD	(RelErrPos),HL	;no error yet, i.e. rel. error position =0
		LD	(OvrDrv),A
		LD	A,JumpOp	;install default error handler
		LD	(ErrEntry),A
		LD	HL,ErrHandler
		LD	(ErrEntry+1),HL
ENDIF
		EX	DE,HL		;return address to HL
		LD	(ProgStart),HL	;basis for calculation of RelErrPos
IF TPVersion EQ 200
;this here is the only difference between V2.01 and V2.00!
		CALL	LowVideo
		CALL	NormVideo
ENDIF
		JP	(HL)		;back

;put variables and parameters on recursion stack
;E: size in BC, address (source) in HL
;V: F, BC, DE, HL
;R: no return if RecurPtr < HeapPtr
;   BC=0
PushVars:	PUSH	HL
		LD	HL,(RecurPtr)	;decrease RecurPtr by BC
		OR	A
		SBC	HL,BC
		LD	(RecurPtr),HL
		LD	DE,(HeapPtr)	;compare with HeapPtr
		OR	A
		SBC	HL,DE		;without destroying RecurPtr
		ADD	HL,DE		;smaller?
		EX	DE,HL
		POP	HL
		JP	C,HSCollision	;yes -> error
		LDIR			;no, copy them
		RET

;restore variables and parameters from recursion stack
;E: size in BC, address (destination) in DE
;V: F, BC, DE, HL
;R: registers are swapped (EXX)
PopVars:	LD	HL,(RecurPtr)
		LDIR			;copy them to DE
		LD	(RecurPtr),HL
		EXX
		RET

;END OF TP-RTL1.INC
;------------------
