;--------------------------------
;TP-RTL6A.INC	ho	24-JUL-92
;--------------------------------
;V1.00: 12FBh-1850h
;V2.00: 133Ch-1891h	V2.01: 1336h-188Bh

		IDENT	TP-RTL6A.INC

;FILE I/O
;--------
.COMMENT %----------------------------------------------------------------
FIB (File Interface Block) Struktur:

Off Groesse	Inhalt
--- -------	------
00  Byte	Bit 3-0: Flags

		3: Sektorp. voll (TEXT), Sektorp. veraendert (FILE of, FILE)
		2: Sektorpuffer leer
		1: open for output		0: open for input


01  Byte	Devicenummer

		0: CON:		4: AUX:		0FFh: Ausgabe in String/keine
		1: TRM:		5: USR:		      Eingabe (Pseudogeraet fuer
		2: KBD:		6: Datei	      die STR- bzw. VAL-Prozedur)
		3: LST:

02  Byte	aktuelles Zeichen (TEXT)
		Bei Dateien wird immer ein Zeichen im voraus gelesen und hier
		abgelegt (EOF wenn Dateiende). Bei Geraeten wird erst dann ein
		Zeichen gelesen, wenn es soweit ist, aber auch hier hinterlegt.

ab hier nur bei Dateien:
03  Byte	Offset in Sektorpuffer
04  Wort	Dateigroesse in Datensaetzen
06  Wort	Satzgroesse in Byte
08  Wort	Aktueller Satz
10  Wort

12  Byte	Laufwerk		*
13  8 Byte	Dateiname		*
21  3 Byte	Extension		* FCB
24  Byte	Extent			*
25  2 Byte	s1, s2			* (File
27  Byte	Record count		* Control
28  16 Byte	Blocknummern		* Block)
44  Byte	Current record		*
45  3 Byte	Random record position	*

48  128 Byte	Sektorpuffer
----------------------------------------------------------------% ;COMMENT

;Assign (TEXT)
;FIB initialisieren
;E: Dateiname und FilePointer auf Stack, BufPos
;V: AF, BC, DE, HL, IX, IY, Stack, FIOFlag1, FilePointer, DefaultFCB
;R: IORes
AssignT:	DEFB	3Eh		;LD A,0AFh

;Assign (FILE of ... oder FILE)
;wie Assign (TEXT)
AssignF:	XOR	A
		LD	(FIOFlag1),A	;0=FILE of/FILE, <>0=TEXT
		POP	IY		;Returnadresse
		LD	HL,(BufPos)
		LD	B,16		;max. Laenge Dateiname
		CALL	StoreString
		XOR	A		;Nullterminieren
		LD	(DE),A
		POP	HL		;FilePointer
		LD	(FilePointer),HL
		PUSH	IY		;Returnadresse wieder drauf
		LD	A,H
		OR	A		;FIB in Zeropage, d.h. Standard-FIB?
		LD	A,22h		;Assign to std files not allowed
		JP	Z,AToIORes
		LD	A,(FIOFlag1)
		OR	A		;TEXT?
		JR	Z,Assign2	;nein -> dann nur Dateiname erlaubt
		CALL	ParseDev	;versuche Geraetename
		JR	NZ,Assign2	;nicht geklappt -> versuche Dateiname
		LD	HL,(FilePointer) ;lege Tabellenwert ab
		LD	(HL),0		;loesche Flags
		INC	HL
		LD	(HL),A
		RET

Assign2:	CALL	ParseUFN
		LD	HL,(FilePointer)
		LD	(HL),0		;Datei, weder fuer Lesen noch
		INC	HL		;fuer Schreiben offen
		LD	(HL),6
		LD	DE,11
		ADD	HL,DE		;FCB adressieren
		EX	DE,HL
		LD	HL,DefaultFCB	;dort steht Ergebnis von ParseUFN
		LD	BC,36		;so lange ist ein FCB
		LDIR			;in den FIB kopieren
		RET

;E: Zeiger auf vermutlichen Geraetenamen in BufPos
;V: AF, B, DE, HL
;R: Zero und Tabellenwert in A wenn Geraetenamen
;   NZero sonst
;Wird nur von einer Stelle aus aufgerufen, braeuchte
;also keine Unterroutine zu sein.
ParseDev:	LD	B,6		;Anzahl Geraetenamen
		LD	HL,Devices
ParseDev1:	PUSH	BC
		PUSH	HL
		LD	B,3		;Laenge eines Geraetenamens
		LD	DE,(BufPos)
ParseDev2:	INC	DE		;Skip spaces
		LD	A,(DE)
		CP	' '
		JR	Z,ParseDev2
ParseDev3:	LD	A,(DE)
		CALL	ToUpper
		SUB	(HL)		;Buchstabe gleich?
		JR	Z,ParseDev4	;ja -> weiter vergleichen
		;vorruecken auf naechsten Eintrag
		POP	HL
		POP	BC
		LD	DE,4		;Laenge eines Eintrages
		ADD	HL,DE
		DJNZ	ParseDev1
		OR	A		;NZero setzen
		RET

ParseDev4:	;vorruecken auf naechstes Zeichen
		INC	HL
		INC	DE
		DJNZ	ParseDev3
		;gefunden!
		POP	BC		;wegwerfen
		POP	BC
		LD	A,(DE)		;naechstes Zeichen muss
		CP	':'		;ein Doppelpunkt sein
		RET	NZ		;wenn nicht -> raus mit NZero
		LD	A,(HL)		;Zero, Tabellenwert liefern
		RET

Devices:	;drei Byte Name + 1 Byte Device (fuer FIB)
		DEFB	'CON',0
		DEFB	'TRM',1
		DEFB	'KBD',2
		DEFB	'LST',3
		DEFB	'AUX',4
		DEFB	'USR',5

;Rewrite (TEXT)
;Datei zum Schreiben oeffnen. Ev. vorhandene Datei wird geloescht
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer, FIOFlag1
;R: IORes
RewriteT:	DEFB	3Eh		;LD A,0AFh

;Reset (TEXT)
;Vorhandene Datei zum Lesen oeffnen
;wie Rewrite (TEXT)
ResetT:		XOR	A
		LD	(FIOFlag1),A	;0=Reset, <>0=Rewrite
		CALL	CloseT		;Close
		CALL	ChkIOError
		LD	HL,(FilePointer)
		INC	HL
		LD	A,(HL)
		CP	6		;Datei?
		JR	NZ,ResetT2	;nein -> Geraete extra behandeln
		CALL	FOpen
		CALL	ChkIOError
		LD	HL,(FilePointer)
		LD	A,(FIOFlag1)
		OR	A		;Rewrite?
		LD	A,6		;ja -> offen zum Schreiben, Sektorp. leer
		JR	NZ,ResetT1	;hinter Sektorpuffer
		LD	A,5		;nein -> offen zum Lesen, Sektorp. leer
ResetT1:	LD	(HL),A
		INC	HL
		INC	HL
		INC	HL
		LD	(HL),0
		RET	NZ		;Wenn Rewrite
		JP	ReadText

;Reset/Rewrite Geraet
;Zeiger auf FCB+1 in HL
ResetT2:	LD	B,3		;input & output
		CP	2		;uberall, nur nicht bei 2 =KBD
		JR	NZ,ResetT3
		LD	B,1		;dort naemlich nur input
ResetT3:	CP	3		;auch nicht bei 3 =LST
		JR	NZ,ResetT4
		LD	B,2		;dort naemlich nur output
ResetT4:	INC	HL
		LD	(HL),0		;akt. Zeichen loeschen
		DEC	HL
		DEC	HL
		LD	(HL),B		;Flags eintragen
		RET

;Rewrite (FILE of ...)
;Datei zum Schreiben oeffnen. Ev. vorhandene Datei wird geloescht
;E: FilePointer in HL, Record Length in DE
;V: AF, BC, DE, HL, FIOFlag1, FIOVar, FilePointer, FIOFlag2
;R: IORes
RewriteFO:	DEFB	3Eh		;LD A,0AFh

;Reset (FILE of ...)
;Vorhandene Datei zum Lesen oeffnen
;wie Rewrite (FILE of)
ResetFO:	XOR	A		;0 = Reset, <>0 = Rewrite
		LD	(FIOFlag1),A
		LD	(FIOVar),DE	;Satzgroesse merken
		CALL	CloseFO		;erstmal zumachen, wenn offen war
		CALL	ChkIOError
		CALL	FOpen		;aufmachen
		LD	A,(IORes)
		OR	A		;hat's geklappt?
		RET	NZ		;nein -> raus
		LD	HL,(FilePointer)
		LD	(HL),7		;Offen zum Lesen und Schreiben,
		INC	HL		;Sektorp. leer
		INC	HL
		INC	HL
		LD	(HL),A		;(A=0) Sektoroffset := 0
		LD	DE,5
		ADD	HL,DE
		LD	(HL),A		;Akt. Satz := 0
		INC	HL
		LD	(HL),A
		LD	DE,36
		ADD	HL,DE
		LD	(HL),A		;Random record position := 0
		INC	HL
		LD	(HL),A
		LD	DE,-42
		ADD	HL,DE		;Dateigroesse in Saetzen adressieren
		LD	A,(FIOFlag1)
		OR	A		;Reset?
		JR	NZ,RewriteFO1	;nein -> Rewrite
	;ResetFO1
		PUSH	HL		;HL zeigt in FIB auf Dateigroesse in
		LD	BC,4		;Saetzen / Satzgroesse
		CALL	FileRead	;dorthin die ersten 4 Byte einlesen
		POP	HL
		INC	HL
		INC	HL
		LD	C,(HL)		;Satzgroesse holen
		INC	HL
		LD	B,(HL)
		LD	HL,(FIOVar)
		OR	A		;und vergleichen
		SBC	HL,BC
		RET	Z		;passt? ja -> fertig
		LD	A,90h		;nein -> Record length mismatch
		JP	AToIORes

RewriteFO1:	PUSH	HL
		XOR	A
		LD	(HL),A		;Anzahl Datensaetze := 0
		INC	HL
		LD	(HL),A
		INC	HL
		LD	DE,(FIOVar)	;Satzgroesse eintragen
		LD	(HL),E
		INC	HL
		LD	(HL),D
		POP	HL		;Anzahl Datensaetze und Satzgroesse
		LD	BC,4		;als erste 4 Byte der Datei schreiben
		JP	FileWrite

;Rewrite (FILE)
;Datei zum Schreiben oeffnen. Ev. vorhandene Datei wird geloescht
;E: FilePointer in HL
;V: AF, BC, DE, HL, FIOFlag1, FilePointer
;R: IORes
RewriteF:	DEFB	3Eh		;LD A,0AFh

;Reset (FILE)
;Vorhandene Datei zum Lesen oeffnen
;wie Rewrite (FILE)
ResetF:		XOR	A
		LD	(FIOFlag1),A	;=0 Reset, <>0 Rewrite
		CALL	CloseF		;zumachen
		CALL	ChkIOError
		CALL	FOpen		;aufmachen
		CALL	ChkIOError
		LD	HL,(FilePointer)
		LD	(HL),7		;Offen zum Lesen und Schreiben,
		PUSH	HL		;Sektorp. leer
		LD	DE,12
		ADD	HL,DE		;adressiere FCB
		EX	DE,HL
		LD	C,FileSize
		CALL	BDOS
		POP	HL
		LD	DE,45
		ADD	HL,DE		;adressiere random record position
		XOR	A
		LD	C,(HL)		;loeschen und alten Wert nach BC
		LD	(HL),A
		INC	HL
		LD	B,(HL)
		LD	(HL),A
		LD	DE,-42
		ADD	HL,DE
		LD	(HL),C		;ablegen als Dateigroesse in Saetzen
		INC	HL
		LD	(HL),B
		INC	HL
		LD	(HL),SecSize	;Satzgroesse in Byte
		INC	HL
		LD	(HL),A
		INC	HL
		LD	(HL),A		;Akt. Satz := 0
		INC	HL
		LD	(HL),A
		RET

;Datei Oeffnen
;E: FilePointer (mit geparstem Dateinamen im FCB),
;   Reset/Rewrite in FIOFlag1
;V: AF, BC, DE, HL
;R: IORes
FOpen:		CALL	ClearFcb
		LD	HL,(FilePointer)
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		EX	DE,HL
		LD	A,(FIOFlag1)
		OR	A		;Reset?
		LD	BC,0100h+OpenFile ;File does not exist
		JR	Z,FOpen1	;ja -> Oeffnen
		PUSH	DE		;nein -> Loeschen und Neu
		LD	C,DeleteFile
		CALL	BDOS		;ev. Fehler ignorieren
		POP	DE
		LD	BC,0F100h+MakeFile ;Directory is full
FOpen1:		PUSH	BC
		CALL	BDOS
		POP	BC
		INC	A		;trat ein Fehler auf?
		RET	NZ		;nein -> raus
		LD	A,B		;ja -> entsprech. Fehler melden
		JP	AToIORes

;FCB Nullen (Extent - Random Record Position)
;E: FilePointer
;V: F, B, DE, HL / R:-
ClearFcb:	LD	HL,(FilePointer)
		LD	DE,24		;Extent adressieren
		ADD	HL,DE
		LD	B,24		;bis zum Ende des FCB
ClearFcb1:	LD	(HL),0		;loeschen
		INC	HL
		DJNZ	ClearFcb1
		RET

;Close (TEXT)
;Datei schliessen (egal, ob sie fuer Lesen oder Schreiben offen war)
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer
;R: IORes
CloseT:		LD	(FilePointer),HL
		INC	HL
		LD	A,(HL)		;hole Device-Nummer
		DEC	HL
		CP	6		;war es ein Geraet?
		JR	NZ,FClose1	;ja -> loesche Flags
		BIT	1,(HL)		;zum Schreiben offen?
		JR	Z,CloseT2	;nein ->weiter
CloseT1:	LD	A,EOF		;ja -> Datei mit EOF terminieren
		CALL	SWriteText	;ein Byte schreiben
		LD	A,(IORes)
		OR	A		;Fehler?
		JR	NZ,FClose	;ja -> einfach so zumachen
		LD	HL,(FilePointer)
		BIT	3,(HL)		;Sektorp. voll?
		JR	NZ,CloseT1	;nein -> weiter fuellen
		JR	FClose

CloseT2: ;Datei war nicht zum Schreiben offen
		BIT	0,(HL)		;zum Lesen offen?
		RET	Z		;auch nicht, also war sie gar nicht offen!

;Datei war offen - schliesse sie
;E: FilePointer
;V: AF, BC, DE, HL
;R: IORes
FClose:		LD	HL,(FilePointer)
		PUSH	HL
		LD	DE,12		;adressiere FCB in FIB
		ADD	HL,DE
		EX	DE,HL
		LD	C,CloseFile
		CALL	BDOS
		POP	HL
		INC	A		;Fehler beim Schliessen?
		JR	NZ,FClose1	;nein -> raus
		LD	A,0FFh		;File disappeared
		LD	(IORes),A
FClose1:	LD	(HL),0		;Datei, ist jetzt zu
		RET

;Close (FILE OF ...)
;Datei schliessen (egal, ob sie fuer Lesen oder Schreiben offen war)
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer, FIOFlag2
;R: IORes
CloseFO:	LD	(FilePointer),HL
		LD	A,(HL)
		AND	3		;offen (fuer Ein- oder Ausgabe)?
		RET	Z		;nein -> Schliessen nicht noetig
	;zuletzt bearbeiteten Sektor flushen
		CALL	FlushRand
	;neue Anzahl Datensaetze eintragen an den Dateianfang
		LD	HL,(FilePointer)
		LD	DE,45
		ADD	HL,DE		;adressiere random record position
		XOR	A
		LD	(HL),A		;:= 0
		INC	HL
		LD	(HL),A
		LD	DE,-43
		ADD	HL,DE		;adressiere Offset in Sektorpuffer
		LD	(HL),A		;:=0
		INC	HL		;adressiere Dateigroesse
		LD	BC,4
		CALL	FileWrite	;in Datei schreiben
		CALL	FlushRand
		JR	FClose

;Close (FILE)
;Datei schliessen (egal, ob sie fuer Lesen oder Schreiben offen war)
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer
;R: IORes
CloseF:		LD	(FilePointer),HL
		LD	A,(HL)
		AND	3		;offen zum Lesen oder Schreiben?
		RET	Z		;nein -> fertig
		JR	FClose

;Erase (TEXT, FILE of ..., FILE)
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer
;R: IORes
Erase:		CALL	HLToFPointer	;Datei?
		RET	NZ		;nein -> Fehler!
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		EX	DE,HL
		LD	C,DeleteFile
		CALL	BDOS		;loeschen
		INC	A		;hat's geklappt?
		RET	NZ		;ja -> fertig
		JR	ErrNoFile	;File does not exist

;Rename (TEXT, FILE of ..., FILE)
;E: Dateiname (STRING) auf Stack, FilePointer auf Stack, BufPos
;V: AF, BC, DE, HL, IX, IY, Stack, FilePointer
;R: IORes
Rename:		POP	IY		;Returnadresse
		LD	HL,(BufPos)	;neuen Namen ablegen
		LD	B,16
		CALL	StoreString
		XOR	A		;Name terminieren
		LD	(DE),A
		POP	HL		;FilePointer holen
		PUSH	IY		;Returnadresse wieder drauf
		CALL	HLToFPointer	;Datei?
		RET	NZ		;nein -> Fehler!
		PUSH	HL
		CALL	ParseUFN	;neuen Namen parsen
		POP	HL
		PUSH	HL
		LD	DE,12+16	;adressiere zweite Haelfte FCB
		ADD	HL,DE
		EX	DE,HL
		LD	HL,DefaultFCB
		LD	BC,12		;kopiere neuen Namen rein
		LDIR			;alter Name steht in erster Haelfte
		POP	HL
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		PUSH	HL
		EX	DE,HL
		LD	C,RenameFile
		CALL	BDOS		;umbenennen
		POP	DE
		INC	A		;hat's geklappt?
		JP	Z,ErrNoFile	;nein -> Fehler
		LD	HL,DefaultFCB	;FCB in FIB kopieren
		LD	BC,36
		LDIR
		RET

ErrNoFile:	LD	A,01h		;File does not exist
ErrNoF1:	JP	AToIORes

;Execute
;E: FilePointer in HL, ContAdr, IORes
;V: AF, BC, DE, HL, FilePointer, FIOFlag1
;R: <no return> wenn ok
Execute:	DEFB	3Eh		;LD A,0AFh

;Chain
;wie Execute
Chain:		XOR	A
		LD	(FIOFlag1),A	;0= Chain, <>0= Execute
	;zulaessig?
		CALL	HLToFPointer	;Datei?
		RET	NZ		;nein -> Fehler!
		LD	HL,(ContAdr)
		LD	A,H		;=0, d.h. Stand alone?
		OR	L
		LD	A,21h		;Not allowed in direct mode
		JR	NZ,ErrNoF1	;nein -> Fehler
	;Datei aufmachen
		LD	HL,(FilePointer)
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		LD	DE,DefaultFCB	;FCB kopieren
		LD	BC,36
		LDIR
		LD	DE,DefaultFCB
		LD	C,OpenFile
		CALL	BDOS		;Datei oeffnen
		INC	A		;hat's geklappt?
		JR	Z,ErrNoFile	;nein -> Fehler
	;Overlay kopieren und starten
		LD	HL,@ChainOvly
		LD	DE,ChainOvly
		LD	BC,ChainLen
		LDIR
		LD	DE,TPA		;Ladeadresse fuer Execute
		LD	A,(FIOFlag1)
		OR	A		;Chain?
		JR	NZ,ExeChn	;nein -> Execute
		LD	DE,(TPA+1)	;Ladeadresse fuer Chain
ExeChn:		LD	SP,TPA
		JP	ChainOvly+1

@ChainOvly:
		.PHASE	ChainOvly
		RST	38h
;E: Ladeadresse in DE, SP aus dem Weg
;   DefaultFCB enthaelt FCB der zu ladenden Datei (bereits offen)
ChainO1:	PUSH	DE
		LD	C,SetDMA	;Ladeadresse setzen
		CALL	BDOS
		LD	DE,DefaultFCB
		LD	C,ReadSeq	;einen Sektor lesen
		CALL	BDOS
		POP	DE
		LD	HL,SecSize	;DMA weiterschalten
		ADD	HL,DE
		EX	DE,HL
		OR	A		;hat's geklappt?
		JR	Z,ChainO1	;ja -> weiter
	;Laden fertig
		JR	TPA		;geladenes Programm starten
		.DEPHASE
ChainLen	EQU	$-@ChainOvly

;E: FilePointer in HL
;V: AF, FilePointer
;R: Zero, wenn Datei
;   NZero, wenn Geraet (und Fehlercode in IORes)
HLToFPointer:	LD	(FilePointer),HL
		CALL	IsAFile		;Datei?
		RET	Z		;ja -> ok
		LD	A,20h		;Operation not allowed on a logical device
AToIORes:	LD	(IORes),A
		RET

;E: IORes
;V: AF / R: <no return> wenn IORes <>0
ChkIOError:	LD	A,(IORes)
		OR	A		;noch alles klar?
		RET	Z		;ja -> fertig
		POP	AF		;werfe Returnadresse weg
		RET

;Eingabe vorbereiten (input)
;E: BufLen, BufPos, CBreak
;V: AF, C, DE, IX, FilePointer, BufLen, BufNext
;R: IORes, Fehler-PC in IX,
;   Puffer gefuellt wenn ok
PrepInput:	POP	IX
		PUSH	IX		;merke PC fuer Fehlerfall
		PUSH	HL
		LD	HL,InputFIB
		CALL	PrepITxt
		POP	HL
		RET

;Eingabe vorbereiten (TEXT)
;E: FilePointer in HL, BufLen, BufPos, CBreak
;V: AF, C, DE, HL, IX, FilePointer, BufLen, BufNext
;R: IORes, Fehler-PC in IX,
;   Puffer gefuellt wenn ok
PrepInpText:	POP	IX
		PUSH	IX		;merke PC fuer Fehlerfall
PrepITxt:	LD	(FilePointer),HL
		BIT	0,(HL)		;open for input?
		JR	Z,PrepITxt1	;nein -> Fehler!
		INC	HL
		LD	A,(HL)		;Geraetenummer
		CP	0		;CON:? OR A waere besser!
		RET	NZ		;nein -> fertig
		INC	HL		;akt. Zeichen loeschen
		LD	(HL),0		;LD (HL),A waere besser!
		JP	Editor		;koennte entfallen, wenn Editor
					;dahinter angeordnet

PrepITxt1:	LD	A,02h		;File not open for input
XAToIRes:	JR	AToIORes

;Ausgabe vorbereiten (output)
;E:- / V: F, FilePointer (A wenn Fehler)
;R: IORes
PrepOutput:	PUSH	HL
		LD	HL,OutputFIB
		CALL	PrepOutText
		POP	HL
		RET

;Ausgabe vorbereiten (TEXT)
;E: FilePointer in HL
;V: F, FilePointer (A wenn Fehler)
;R: IORes
PrepOutText:	LD	(FilePointer),HL
		BIT	1,(HL)		;open for output?
		RET	NZ		;ja -> raus
		LD	A,03h		;File not open for output
		JR	XAToIRes

;Zeileneditor
;E: BufLen, BufPos, CBreak, Fehler-PC in IX
;V: AF, C, DE, HL, BufLen, BufNext
;R: <no return> wenn ^C, sonst Puffer gefuellt
EditInp:
Editor:		LD	HL,BufLen
		LD	A,(HL)
		CP	80h		;Puffer groesser als 127?
		JR	C,Editor1
		LD	A,7Fh		;ja -> begrenze auf 127
Editor1:	LD	C,A
		LD	(HL),7Fh
		LD	HL,(BufPos)
		LD	(BufNext),HL	;beginne am Anfang
EdInit:		LD	D,0

EdLoop:	;Registerbelegung:
	;C= max. Laenge, D= aktuelle Laenge
	;E= Flag =1 Zeichen loaschen, =0 Zeile loeschen
		CALL	SConInp		;hole Zeichen
		LD	(HL),A		;lege es ab
		CP	CR
		JR	Z,EdCR
		LD	E,1		;Zeichen loeschen
		CP	BS
		JR	Z,EdBack
		CP	DEL
		JR	Z,EdBack
		DEC	E		;Zeile loeschen
		CP	CtlX
		JR	Z,EdBack
		CP	CtlC
		JR	NZ,EdChar
		LD	A,(CBreak)
		OR	A
		JR	Z,EdLoop
		JP	UserBreak

EdChar:	;normales Zeichen (20h-7Eh)
		CP	' '		;ignoriere unbekannte Control-Zeichen
		JR	C,EdLoop
		LD	A,C
		CP	D		;noch Platz?
		JR	Z,EdLoop	;nein -> ignoriere Zeichen
		LD	A,(HL)
		INC	D		;weiterzaehlen
		INC	HL
		CALL	SConOut		;Echo auf Bildschirm
		JR	EdLoop

EdBack:	;zurueck
		DEC	D		;sind wir schon am Anfang?
		JP	M,EdInit	;ja -> starte Zeile neu
		DEC	HL		;eins zurueck
		CALL	Print		;auch auf dem Bildschirm
		DEFB	BS,' ',BS,0
		DEC	E		;ganze Zeile loeschen?
		JR	Z,EdLoop	;nein -> normal weiter
		JR	EdBack		;ja -> bis alles geloescht

EdCR:	;Carriage Return (^M)
		LD	(HL),EOF
		RET

;E: FilePointer
;V: AF / R: Geraet in A. Zero wenn Datei, NZero sonst
IsAFile:	PUSH	HL
		LD	HL,(FilePointer)
		INC	HL
		LD	A,(HL)		;Geraetenummer
		CP	6		;ist es eine Datei?
		POP	HL
		RET

;Zeichen holen, wenn Geraet und wenn kein Fehler
;Muss zuanfang aufgerufen werden, weil Datei bereits
;aktuelles Zeichen in FIB gesetzt hat, Geraet aber nicht
;E:/V:/R: wie ReadText, zusaetzlich E: IORes
ReadTxtDev:	CALL	IsAFile
		RET	Z
		CALL	ReadAkt
		CP	EOF
		RET	Z
;<fall through>

;Ein Zeichen von Datei/Geraet holen (TEXT)
;E: FilePointer, BufNext, CBreak, BufPos
;V: AF, BufNext
;R: <no return> wenn ^C, Zeichen in akt. Zeichen (und in A), IORes
;Achtung: obige E:V:R:-Litanei habe ich nicht vollstaendig in jede Routine
;	  uebernommen, die diese Routine aufruft. Das war mir zu unuebersichtlich.
ReadText:	PUSH	BC
		PUSH	DE
		PUSH	HL
		LD	HL,(FilePointer)
		INC	HL
		LD	A,(HL)
		OR	A		;CON:?
		JR	NZ,ReadTxt1	;nein -> gehe Geraete durch
	;CON: gepufferte Eingabe (Editor)
		LD	HL,(BufNext)
		LD	A,(HL)
		CP	EOF		;Ende der Eingabezeile?
		JR	Z,ReadTxt9	;ja -> liefere EOF
		INC	HL
		LD	(BufNext),HL
		JR	ReadTxt9	;liefere Zeichen

ReadTxt1:	DEC	A		;=1 (TRM:)?
		JR	NZ,ReadTxt4
	;TRM: ungepufferte Eingabe mit Echo (druckbare Zeichen und CR)
		CALL	SConInp
		PUSH	AF
		CP	' '
		JR	C,ReadTxt2
		CALL	SConOut
		JR	ReadTxt3

ReadTxt2:	CP	CR
		CALL	Z,NewLine
ReadTxt3:	POP	AF
		JR	ReadTxt9	;liefere Zeichen

ReadTxt4:	DEC	A		;=2 (KBD:)?
		JR	NZ,ReadTxt5	;nein -> weiter
	;KBD: ungepufferte Eingabe ohne Echo
		CALL	SConInp		;ungepufferte Eingabe
		JR	ReadTxt9	;das Zeichen liefern

ReadTxt5:	DEC	A		;3 ist LST:, darf nicht
		DEC	A		;=4 (AUX:)?
		JR	NZ,ReadTxt6	;nein -> weiter
	;Reader
		CALL	RdrInp
		LD	A,L
		JR	ReadTxt9	;das Zeichen liefern

ReadTxt6:	DEC	A		;=5 (USR:)?
		JR	NZ,ReadTxt7	;nein -> bleibt nur 6 (Datei)
	;User
		CALL	ConInpx
		LD	A,L
		JR	ReadTxt9	;das Zeichen liefern

ReadTxt7: ;Eingabe aus Datei
		LD	C,ReadSeq
		CALL	ReadSector
		JR	NZ,ReadTxt8
		LD	HL,(FilePointer)
		INC	HL
		INC	HL
		INC	HL
		PUSH	HL
		LD	A,(HL)		;hole Sektoroffset
		ADD	45
		LD	E,A
		LD	D,0
		ADD	HL,DE
		LD	A,(HL)		;hole Zeichen aus Sektorpuffer
		POP	HL
		CP	EOF		;ist es End-Of-File?
		JR	Z,ReadTxt9	;ja -> liefere EOF
		INC	(HL)
		JP	P,ReadTxt9
		LD	(HL),0
		LD	HL,(FilePointer)
		SET	2,(HL)		;Sektorpuffer leer
		JR	ReadTxt9	;und liefere das Zeichen (EOF)

ReadTxt8:	LD	A,99h		;Unexpected end-of-file
		LD	(IORes),A
		LD	A,EOF

;liefere Zeichen (in A)
ReadTxt9:	LD	HL,(FilePointer)
		INC	HL
		INC	HL
		LD	(HL),A		;in FIB ablegen: aktuelles Zeichen
		POP	HL
		POP	DE
		POP	BC
		RET

;E: IORes, FilePointer
;V: AF / R: EOF in A wenn Fehler, sonst akt. Zeichen in A
ReadAkt:	LD	A,(IORes)
		OR	A		;Fehler?
		LD	A,EOF
		RET	NZ		;dann liefere EOF
		PUSH	HL
		LD	HL,(FilePointer)
		INC	HL
		INC	HL
		LD	A,(HL)		;hole akt. Zeichen
		POP	HL
		RET

;Lese Zahl von Datei in Umwandlungs-Puffer ein
;E: FilePointer
;V: AF, BC, DE
;R: Zahl in ConvBuf, IORes
ReadNumber:	PUSH	HL
		LD	HL,(FilePointer)
		INC	HL
		LD	A,(HL)
		CP	0FFh		;VAL-Prozedur?
		JR	Z,ReadNum7	;String steht schon in ConvBuf!
		CALL	ReadTxtDev	;Lese von Geraet
ReadNum1: ;fuehrende Spaces, TABs, CR/LFs ignorieren
		CALL	ReadAkt
		CP	' '		;Space?
		JR	Z,ReadNum2
		CP	TAB
		JR	Z,ReadNum2
		CP	CR
		JR	Z,ReadNum2
		CP	LF
		JR	NZ,ReadNum3
ReadNum2:	CALL	ReadText
		JR	ReadNum1

ReadNum3:	LD	HL,ConvBuf
		LD	B,30		;max. Laenge
ReadNum4:	CALL	ReadAkt
		CP	' '		;Space?
		JR	Z,ReadNum5
		CP	TAB
		JR	Z,ReadNum5
		CP	CR
		JR	Z,ReadNum6
		CP	EOF
		JR	Z,ReadNum6
		LD	(HL),A		;lege Ziffer ab
		INC	HL
		DEC	B
		JR	Z,ReadNum5	;max. bis Puffer voll
		CALL	ReadText
		JR	ReadNum4

ReadNum5:	CALL	IsAFile		;Datei?
		CALL	Z,ReadText	;ja -> ein Zeichen im voraus lesen
ReadNum6:	LD	(HL),0		;Puffer terminieren
ReadNum7:	POP	HL
		RET

;Untersuche Vorzeichen
;E: Zahl in Ascii in ConvBuf
;V: AF, B, IX
;R: Zero wenn ConvBuf leer,
;   sonst: B=0 wenn Zahl positiv, =1 wenn negativ
;	   IX zeigt auf erste Ziffer
ExamSign:	LD	IX,ConvBuf
		LD	A,(IX)
		OR	A		;Puffer leer?
		RET	Z		;ja -> raus mit Zero
		LD	B,0
		CP	'-'		;Zahl negativ?
		RET	NZ		;nein -> raus mit NZero und B=0
		INC	B		;ja -> NZero
		INC	IX
		RET

;E: Zeiger in umzuwandelnden String in IX,
;   Carry wenn Fehler (von AtoI bzw. AtoR)
;V: AF
;R: Carry wenn Fehler (von AtoI/AtoR oder String nicht zuende), IORes
;   sonst Zero
ChkForErr:	JR	C,ChkForErr1	;Fehler von AtoI/AtoR weiterleiten
		LD	A,(IX)
		OR	A		;umzuwandelnder String zuende?
		RET	Z		;ja -> ok
ChkForErr1:	LD	A,10h		;Error in numeric format
		SCF
		JP	AToIORes

;Lese CHAR (TEXT)
;E: Zeiger auf Ziel in HL, FilePointer
;V: AF, DE, HL
;R:-
ReadChar:	EX	DE,HL
		CALL	IsAFile
		JR	NZ,ReadChar1
		CALL	ReadAkt
		LD	(DE),A
		JP	ReadText

ReadChar1:	CALL	ReadText	;hole Zeichen
		LD	(DE),A		;lege Zeichen ab
		RET

;Lese BYTE (TEXT)
;E: Zeiger auf Ziel in HL, FilePointer
;V: AF, BC, DE, HL, IX
;R: gelesener Wert in HL wenn kein Fehler,
;   sonst Fehlercode in IORes und IX zeigt auf fehlerhaftes Zeichen
ReadByte:	DEFB	3Eh		;LD A,0AFh

;Lese INTEGER (TEXT)
;wie ReadByte
ReadInt:	XOR	A		;0 = Integer, <>0 = Byte
		LD	C,A		;Flag merken
		PUSH	BC
		CALL	ReadNumber
		POP	BC
		CALL	ExamSign
		RET	Z		;raus wenn Puffer leer (nicht zuweisen)
		PUSH	BC		;Flags und
		PUSH	HL		;Zieladresse retten
		CALL	AtoI
		POP	DE		;Zieladresse nach DE
		POP	BC
		CALL	ChkForErr
		RET	C		;raus wenn Fehler
		DEC	B		;negativ?
		CALL	Z,NegateHL	;ja -> umdrehen
		EX	DE,HL
		LD	(HL),E		;(Low-)Byte ablegen
		INC	C
		DEC	C		;Integer?
		JR	NZ,ReadInt1	;nein -> fertig
		INC	HL
		LD	(HL),D		;ja -> HighByte ablegen
ReadInt1:	EX	DE,HL		;eingelesene Zahl nach HL (wozu?)
		RET

;Lese REAL (TEXT)
;E: Zeiger auf Ziel in HL, FilePointer
;V: AF, BC, DE, HL, BCDEHL', IX
;R: Fehlercode in IORes und IX zeigt auf fehlerhaftes Zeichen
ReadReal:	CALL	ReadNumber
		CALL	ExamSign
		RET	Z		;raus wenn Puffer leer (nicht zuweisen)
		PUSH	BC		;Flag in B und
		PUSH	HL		;Zieladresse retten
		CALL	AtoR
		EXX			;Real-Zahl nach BCDEHL'
		POP	HL		;Zieladresse und
		POP	BC		;Flag holen
		CALL	ChkForErr
		RET	C		;raus wenn Fehler
		DEC	B		;negativ?
		EXX
		CALL	Z,NegateReal	;ja -> umdrehen
		EXX
		JP	StoreReal	;Realzahl ablegen

;Lese STRING (TEXT)
;E: Zeiger auf Ziel in HL, max. Laenge in B, FilePointer
;V: AF, BC, DE
;R: Fehlercode in IORes
ReadString:	PUSH	HL		;Zieladresse merken
		CALL	ReadTxtDev
ReadStr1: ;ueberlese LineFeeds
		CALL	ReadAkt
		CP	LF
		JR	NZ,ReadStr2
		CALL	ReadText
		JR	ReadStr1

ReadStr2:	LD	C,0		;aktuelle Laenge
ReadStr3:	CALL	ReadAkt
		CP	CR		;CR beendet String
		JR	Z,ReadStr5
		CP	EOF		;EOF auch
		JR	Z,ReadStr5
		INC	C		;akt. Laenge erhoehen
		INC	HL
		LD	(HL),A		;Zeichen ablegen
		DEC	B		;max. Laenge erreicht?
		JR	Z,ReadStr4	;ja -> auch fertig
		CALL	ReadText
		JR	ReadStr3

ReadStr4:	CALL	IsAFile
		CALL	Z,ReadText
ReadStr5:	POP	HL		;Zieladresse holen
		LD	(HL),C		;Stringlaenge eintragen
		RET

;Lese Zeilenwechsel (TEXT)
;liest so lange, bis EOF, CR oder CR/LF auftritt
;E: FilePointer
;V: AF, HL / R:-
ReadLine:	LD	HL,(FilePointer)
		INC	HL
		LD	A,(HL)
		CP	0		;CON:? OR A waere besser!
		JP	Z,NewLine
ReadLin1: ;nach CR oder EOF Ausschau halten
		CALL	ReadAkt
		CP	CR
		JR	Z,ReadLin2
		CP	EOF		;End-of-file?
		RET	Z
		CALL	ReadText
		JR	ReadLin1

ReadLin2: ;war CR. evtl. LF?
		CALL	IsAFile		;Datei?
		JR	NZ,ReadLin3	;nein -> Geraet
		CALL	ReadText
		CP	LF
		RET	NZ
		JP	ReadText

ReadLin3: ;Geraet
		LD	HL,(FilePointer)
		INC	HL
		INC	HL
		LD	A,(HL)
		CP	EOF
		RET	Z
		LD	(HL),0
		RET

;ENDE TP-RTL6A.INC
;-----------------
