;--------------------------------
;TP-RTL6B.INC	ho	24-JUL-92
;--------------------------------
;V3.00: 136Fh-180Fh	V3.01: 1370h-1810h

		IDENT	TP-RTL6B.INC

;FILE I/O
;--------
.COMMENT %----------------------------------------------------------------
FIB (File Interface Block) Struktur:

Off Groesse	Inhalt
--- -------	------
00  Byte	Bit 7-4: Flags

		7: open for input		6: open for output
		5: aktuelles Zeichen nicht abgeholt (TEXT)
		   Sektorpuffer veraendert (FILE of, FILE)
		4: noch nichts eingelesen

		Bit 3-0: Devicenummer

		0: Datei	3: LST:		6: Ausg.in String/keine Eingabe
		1: CON:/TRM:	4: AUX:		   (Pseudogeraet fuer die
		2: KBD:		5: USR:		   STR- bzw. VAL-Prozedur)

01  Byte	aktuelles Zeichen (TEXT)
		Aufeinanderfolgende Aufrufe der Leseroutine liefern
		solange dieses Zeichen, bis die Annahme des Zeichens
		durch Loeschen des Flags 5 quittiert wird.

ab hier nur bei Dateien:
02  Wort	Offset in Sektorpuffer
04  Wort	Dateigroesse in Datensaetzen
06  Wort	Satzgroesse in Byte
08  Wort	Aktueller Satz
10  Wort

12  Byte	Laufwerk		*
13  8 Byte	Dateiname		*
21  3 Byte	Extension		* FCB
24  Byte	Extent			*
25  2 Byte	s1, s2			* (File
27  Byte	Record count		* Control
28  16 Byte	Blocknummern		* Block)
44  Byte	Current record		*
45  3 Byte	Random record position	*

48  128 Byte	Sektorpuffer
----------------------------------------------------------------% ;COMMENT

;Assign (TEXT)
;FIB initialisieren
;E: Dateiname und Zeiger auf FIB auf Stack, BufPos
;V: AF, BC, DE, HL, IX, IY, Stack, FIOFlag1, FilePointer, DefaultFCB
;R: IORes
AssignT:	DEFB	3Eh		;LD A,0AFh

;Assign (FILE of ... oder FILE)
;wie Assign (TEXT)
AssignF:	XOR	A
		LD	(FIOFlag1),A	;0=FILE of/FILE, <>0=TEXT
		POP	IY		;Returnadresse
		LD	HL,(BufPos)
		LD	B,16		;max. Laenge Dateiname
		CALL	StoreString
		XOR	A		;Nullterminieren
		LD	(DE),A
		POP	HL		;Zeiger auf FIB
		LD	(FilePointer),HL
		PUSH	IY		;Returnadresse wieder drauf
		LD	A,H
		OR	A		;FIB in Zeropage, d.h. Standard-FIB?
		JR	NZ,Assign1	;nein, ok
		LD	A,22h		;Assign to std files not allowed
		LD	(IORes),A
		RET

Assign1:	LD	A,(FIOFlag1)
		OR	A		;TEXT?
		JR	Z,Assign2	;nein -> dann nur Dateiname erlaubt
		CALL	ParseDev	;versuche Geraetename
		JR	NZ,Assign2	;nicht geklappt -> versuche Dateiname
		LD	HL,(FilePointer) ;lege Tabellenwert ab
		LD	(HL),A
		RET

Assign2:	CALL	ParseUFN
		LD	HL,(FilePointer)
		LD	(HL),0		;Datei, weder fuer Lesen noch
		LD	DE,12		;fuer Schreiben offen
		ADD	HL,DE
		EX	DE,HL
		LD	HL,DefaultFCB	;dort steht Ergebnis von ParseUFN
		LD	BC,36		;so lange ist ein FCB
		LDIR			;in den FIB kopieren
		RET

;E: Zeiger auf vermutlichen Geraetenamen in BufPos
;V: AF, B, DE, HL
;R: Zero und Tabellenwert in A wenn Geraetenamen
;   NZero sonst
;Wird nur von einer Stelle aus aufgerufen, braeuchte
;also keine Unterroutine zu sein.
ParseDev:	LD	B,6		;Anzahl Geraetenamen
		LD	HL,Devices
ParseDev1:	PUSH	BC
		PUSH	HL
		LD	B,3		;Laenge eines Geraetenamens
		LD	DE,(BufPos)
ParseDev2:	INC	DE		;Skip spaces
		LD	A,(DE)
		CP	' '
		JR	Z,ParseDev2
ParseDev3:	LD	A,(DE)
		CALL	ToUpper
		SUB	(HL)		;Buchstabe gleich?
		JR	Z,ParseDev4	;ja -> weiter vergleichen
		;vorruecken auf naechsten Eintrag
		POP	HL
		POP	BC
		LD	DE,4		;Laenge eines Eintrages
		ADD	HL,DE
		DJNZ	ParseDev1
		OR	A		;NZero setzen
		RET

ParseDev4:	;vorruecken auf naechstes Zeichen
		INC	HL
		INC	DE
		DJNZ	ParseDev3
		;gefunden!
		POP	BC		;wegwerfen
		POP	BC
		LD	A,(DE)		;naechstes Zeichen muss
		CP	':'		;ein Doppelpunkt sein
		RET	NZ		;wenn nicht -> raus mit NZero
		LD	A,(HL)		;Zero, Tabellenwert liefern
		RET

Devices:	;drei Byte Name + 1 Byte Flags/Device (fuer FIB)
		DEFB	'CON',0C1H
		DEFB	'TRM',0C1H
		DEFB	'KBD',082H
		DEFB	'LST',043h
		DEFB	'AUX',0C4H
		DEFB	'USR',0C5H

;Rewrite (TEXT)
;Datei zum Schreiben oeffnen. Ev. vorhandene Datei wird geloescht
;E: Zeiger auf FIB in HL
;V: AF, BC, DE, HL, FilePointer, FIOFlag1
;R: IORes
RewriteT:	DEFB	3Eh		;LD A,0AFh

;Reset (TEXT)
;Vorhandene Datei zum Lesen oeffnen
;wie Rewrite (TEXT)
ResetT:		XOR	A
		LD	(FIOFlag1),A	;0=Reset, <>0=Rewrite
		CALL	CloseT		;Close
		LD	A,(IORes)
		OR	A		;Fehler aufgetreten?
		RET	NZ		;ja -> raus
		LD	HL,(FilePointer)
		RES	5,(HL)		;es steht kein Zeichen an
		LD	A,(HL)
		AND	0Fh		;Geraet?
		RET	NZ		;ja -> raus
		CALL	FOpen
		LD	A,(IORes)
		OR	A		;Fehler aufgetreten?
		RET	NZ		;ja -> raus
		LD	HL,(FilePointer)
		LD	A,(FIOFlag1)
		OR	A		;Reset?
		LD	BC,8080h	;ja -> offen zum Lesen, Lesezeiger
		JR	Z,ResetT1	;hinter Sektorpuffer
		LD	BC,0040h	;nein -> offen zum Schreiben, Schreib-
ResetT1:	LD	(HL),C		;zeiger auf Sektoranfang
		INC	HL
		INC	HL
		LD	(HL),B
		RET

;Datei Oeffnen
;E: FilePointer (mit geparstem Dateinamen im FCB),
;   Reset/Rewrite in FIOFlag1
;V: AF, BC, DE, HL
;R: IORes
FOpen:		CALL	ClearFcb
		LD	HL,(FilePointer)
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		EX	DE,HL
		LD	A,(FIOFlag1)
		OR	A		;Reset?
		LD	BC,0100h+OpenFile ;File does not exist
		JR	Z,FOpen1	;ja -> Oeffnen
		PUSH	DE		;nein -> Loeschen und Neu
		LD	C,DeleteFile
		CALL	BDOS		;ev. Fehler ignorieren
		POP	DE
		LD	BC,0F100h+MakeFile ;Directory is full
FOpen1:		PUSH	BC
		CALL	BDOS
		POP	BC
		INC	A		;trat ein Fehler auf?
		RET	NZ		;nein -> raus
		LD	A,B		;ja -> entsprech. Fehler melden
		LD	(IORes),A
		RET

;FCB Nullen (Extent - Random Record Position)
;E: FilePointer
;V: F, B, DE, HL / R:-
ClearFcb:	LD	HL,(FilePointer)
		LD	DE,24		;Extent adressieren
		ADD	HL,DE
		LD	B,24		;bis zum Ende des FCB
ClearFcb1:	LD	(HL),0		;loeschen
		INC	HL
		DJNZ	ClearFcb1
		RET

;Close (TEXT)
;Datei schliessen (egal, ob sie fuer Lesen oder Schreiben offen war)
;E: Zeiger auf FIB in HL
;V: AF, BC, DE, HL, FilePointer
;R: IORes
CloseT:		LD	(FilePointer),HL
		LD	A,(HL)		;hole die Device-Nummer
		AND	0Fh		;war es ein Geraet?
		RET	NZ		;ja -> fertig
		BIT	6,(HL)		;zum Schreiben offen?
		JR	Z,CloseT1	;nein ->weiter
		LD	A,EOF		;ja -> Datei mit EOF terminieren
		CALL	WriteText	;ein Byte schreiben
		CALL	FlushSeq	;Sektor flushen (TEXT)
		JR	FClose

CloseT1: ;Datei war nicht zum Schreiben offen
		BIT	7,(HL)		;zum Lesen offen?
		RET	Z		;auch nicht, also war sie gar nicht offen!

;Datei war offen - schliesse sie
;E: FilePointer
;V: AF, BC, DE, HL
;R: IORes
FClose:		LD	HL,(FilePointer)
		PUSH	HL
		LD	DE,12		;adressiere FCB in FIB
		ADD	HL,DE
		EX	DE,HL
		LD	C,CloseFile
		CALL	BDOS
		POP	HL
		INC	A		;Fehler beim Schliessen?
		JR	NZ,FClose1	;nein -> raus
		LD	A,0FFh		;File disappeared
		LD	(IORes),A
FClose1:	LD	(HL),0		;Datei, ist jetzt zu
		RET

;Ausgabe vorbereiten (output)
;E:- / V: FIOPC, FilePointer / R:-
PrepOutput:	EX	(SP),HL
		LD	(FIOPC),HL	;merke PC fuer Fehlerfall
		EX	(SP),HL
		PUSH	HL
		LD	HL,OutputFIB
		LD	(FilePointer),HL
		POP	HL
		RET

;Eingabe vorbereiten (TEXT)
;E: FilePointer in HL
;V: AF, FIOPC, FilePointer
;R: IORes
PrepInpText:	EX	(SP),HL
		LD	(FIOPC),HL	;merke PC fuer Fehlerfall
		EX	(SP),HL
		LD	(FilePointer),HL
		BIT	7,(HL)		;open for input?
		RET	NZ		;ja -> raus
		LD	A,02h		;File not open for input
		LD	(IORes),A
		RET

;Ausgabe vorbereiten (TEXT)
;E: FilePointer in HL
;V: AF, FIOPC, FilePointer
;R: IORes
PrepOutText:	EX	(SP),HL
		LD	(FIOPC),HL	;merke PC fuer Fehlerfall
		EX	(SP),HL
		LD	(FilePointer),HL
		BIT	6,(HL)		;open for output?
		RET	NZ		;ja -> raus
		LD	A,03h		;File not open for output
		LD	(IORes),A
		RET

;Eingabe vorbereiten (input) mit Zeilenwechsel
;E:- / V: AF, BC, DE, FilePointer, BufLen, BufNext, BufLast / R:-
PrepInpLine:	DEFB	3Eh		;LD A,0AFH

;Eingabe vorbereiten (input) ohne Zeilenwechsel
;wie PrepInpLine
PrepInput:	XOR	A
		EX	(SP),HL
		LD	(FIOPC),HL	;merke PC fuer Fehlerfall
		EX	(SP),HL
		PUSH	HL
		LD	HL,InputFIB
		LD	(FilePointer),HL
		RES	5,(HL)
		PUSH	AF
		CALL	EditInp
		POP	AF
		OR	A
		JR	Z,PrepInp1
		CALL	NewLine
PrepInp1:	POP	HL
		RET

;Zeileneditor
EditInp:	LD	B,0

;E: Flag in B (=0 input, <>0 CON:/TRM:)
;   BufLen, BufPos, CBreak, FIOPC
;V: AF, C, DE, HL, BufLen, BufNext, BufLast
;R: <no return> wenn ^C,
;   sonst Puffer gefuellt, BufLast
Editor:		LD	HL,BufLen
		LD	A,(HL)
		CP	7Fh		;Puffer groesser als 126?
		JR	C,Editor1
		LD	A,7Eh		;ja -> begrenze auf 126
Editor1:	LD	C,A
		LD	(HL),7Eh
		LD	HL,(BufPos)
		LD	(BufNext),HL	;beginne am Anfang
EdInit:		LD	D,0

EdLoop:	;Registerbelegung:
	;B= Flag =0 input, <>0 CON:/TRM:
	;C= max. Laenge, D= aktuelle Laenge
	;E= Flag =1 Zeichen loaschen, =0 Zeile loeschen
		CALL	SConInp		;hole Zeichen
		LD	(HL),A		;lege es ab
		LD	E,1		;Zeichen loeschen
		CP	BS
		JR	Z,EdBack
		CP	DEL
		JR	Z,EdBack
		DEC	E		;Zeile loeschen
		CP	CtlX
		JR	Z,EdBack
		CP	ESC
		JR	Z,EdBack
		CP	EOF
		JR	Z,EdEOF
		CP	CR
		JR	Z,EdCR
		CP	' '
		JR	NC,EdChar
	;hierher kommen alle Control-Zeichen ausser BS, CR, ^X, EOF, ESC
		CP	CtlC
		JR	NZ,EdLoop
		LD	A,(CBreak)
		OR	A
		JR	Z,EdLoop
		LD	IX,(FIOPC)	;hole fuer Fehlerfall gemerkten PC
		JP	UserBreak

EdChar:	;normales Zeichen (20h-7Eh)
		LD	A,C
		CP	D		;noch Platz?
		JR	Z,EdLoop	;nein -> ignoriere Zeichen
		LD	A,(HL)
		INC	D		;weiterzaehlen
		INC	HL
		CALL	SConOut		;Echo auf Bildschirm
		JR	EdLoop

EdBack:	;zurueck
		DEC	D		;sind wir schon am Anfang?
		JP	M,EdInit	;ja -> starte Zeile neu
		DEC	HL		;eins zurueck
		CALL	Print		;auch auf dem Bildschirm
		DEFB	BS,' ',BS,0
		DEC	E		;ganze Zeile loeschen?
		JR	Z,EdLoop	;nein -> normal weiter
		JR	EdBack		;ja -> bis alles geloescht

EdEOF:	;End-Of-File (^Z)
		INC	B
		DEC	B		;input?
		JR	Z,EdLoop	;ja -> ignorieren
		JR	TermEOF

EdCR:	;Carriage Return (^M)
		INC	B
		DEC	B		;input?
		JR	NZ,TermCR	;nein -> Zeile mit CR/LF beenden
TermEOF: ;Zeile mit EOF beenden
		LD	(HL),EOF
		JR	EdExit

TermCR:	;Zeile mit CR/LF beenden
		CALL	NewLine		;Echo auf Bildschirm
		LD	(HL),CR
		INC	HL
		LD	(HL),LF
EdExit:		INC	HL
		LD	(BufLast),HL	;Zeiger hinter Ende ablegen
		RET

;Ein Zeichen von akt. File holen (TEXT)
;E: FilePointer, IORes, BufNext, BufLast, CBreak, FIOPC, BufPos
;V: AF, BC, DE, HL, BufNext, BufLen, BufLast
;R: <no return> wenn ^C
;   sonst FilePointer in HL, Zeichen in A
;Achtung: obige E:V:R:-Litanei habe ich nicht vollstaendig in jede Routine
;	  uebernommen, die diese Routine aufruft. Das war mir zu unuebersichtlich.
ReadText:	LD	HL,(FilePointer)
		LD	A,(IORes)
		OR	A		;trat ein Fehler auf?
		JR	NZ,ReadTxt10	;ja -> liefere EOF
		LD	A,(HL)
		BIT	5,A		;letztes Zeichen noch nicht abgeholt?
		JR	NZ,ReadTxt9	;ja -> liefere es nochmal
		AND	0Fh		;Devicenummer =0 (Datei)?
		JR	NZ,ReadTxt3	;nein -> Geraet
		INC	HL
		INC	HL
		LD	A,(HL)		;hole Sektoroffset
		OR	A		;0..127?
		JP	P,ReadTxt2	;ja -> brauche nicht naechsten Sektor lesen
		LD	C,ReadSeq
		PUSH	HL
		CALL	FBDOS
		POP	HL		;hats geklappt?
		JR	Z,ReadTxt1	;ja -> Sektorpuffer ist gefuellt
		PUSH	HL		;nein -> stelle ein EOF in den
		LD	DE,46		;Sektorpuffer
		ADD	HL,DE
		LD	(HL),EOF
		POP	HL
ReadTxt1:	XOR	A		;fange mit dem Anfang des
		LD	(HL),A		;neuen Sektors an
ReadTxt2:	INC	(HL)
		ADD	A,46		;so gross ist ein FIB
		LD	E,A
		LD	D,0		;Adressiere gewuenschtes Byte
		ADD	HL,DE		;im Sektorpuffer
		LD	A,(HL)		;hole es
		CP	EOF		;ist es End-Of-File?
		JR	NZ,ReadTxt8	;nein -> liefere Zeichen
		LD	HL,(FilePointer)
		INC	HL		;ja -> korrigiere Sektoroffset,
		INC	HL		;damit wir nicht hinter EOF lesen
		DEC	(HL)
		JR	ReadTxt8	;und liefere das Zeichen (EOF)

ReadTxt3: ;Lese von Geraet
		DEC	A		;=1 (CON:/TRM:)?
		JR	NZ,ReadTxt5	;nein -> weiter
		LD	HL,(BufNext)
		LD	DE,(BufLast)
		OR	A
		SBC	HL,DE		;BufNext < BufLast?
		JR	C,ReadTxt4	;ja -> es ist noch was im Puffer
		LD	B,0FFh		;nein -> Zeile einlesen (CON:/TRM:)
		CALL	Editor
ReadTxt4:	LD	HL,(BufNext)	;die Zeile ist nie leer, da mindestens
		LD	A,(HL)		;das terminierende Zeichen vorhanden ist
		INC	HL
		LD	(BufNext),HL
		JR	ReadTxt8	;das Zeichen liefern

ReadTxt5:	DEC	A		;=2 (KBD:)?
		JR	NZ,ReadTxt6	;nein -> weiter
		CALL	ConInp		;ungepufferte Eingabe
		LD	A,L
		JR	ReadTxt8	;das Zeichen liefern

ReadTxt6:	DEC	A		;3 ist LST:, darf nicht
		DEC	A		;=4 (AUX:)?
		JR	NZ,ReadTxt7	;nein -> bleibt nur noch 5 (USR:)
		CALL	RdrInp
		LD	A,L
		JR	ReadTxt8	;das Zeichen liefern

ReadTxt7:	CALL	ConInpx
		LD	A,L

ReadTxt8: ;Zeichen in A
		LD	HL,(FilePointer)
		SET	5,(HL)		;'ich hab was!'
		INC	HL
		LD	(HL),A		;in FIB merken
		DEC	HL
		RET

ReadTxt9: ;zuletzt gelesenes Zeichen nochmal liefern (Flag 5 ist noch gesetzt)
		INC	HL
		LD	A,(HL)
		DEC	HL
		RET

ReadTxt10: ;EOF liefern (Flag 5 wird nicht gesetzt)
		LD	A,EOF
		RET


;Lese Zahl von Datei in Umwandlungs-Puffer ein
;E: FilePointer
;V: AF, BC, DE
;R: Zahl in ConvBuf
ReadNumber:	PUSH	HL
		LD	HL,(FilePointer)
		LD	A,(HL)
		AND	0Fh
		CP	6		;VAL-Prozedur?
		JR	Z,ReadNum5	;String steht schon in ConvBuf!
ReadNum1: ;fuehrende Spaces und Control-Zeichen (ausser EOF) ignorieren
		CALL	ReadText	;Lese ein Zeichen
		CP	' '+1		;Control/Space?
		JR	NC,ReadNum2	;nein -> fange an mit Zahl
		CP	EOF		;ist es EOF?
		JR	Z,ReadNum2	;ja -> war wohl nix mit Zahl
		RES	5,(HL)		;Empfang quittieren
		JR	ReadNum1

ReadNum2:	LD	DE,ConvBuf
		LD	B,30		;max. Laenge
ReadNum3:	PUSH	BC		;Laenge und
		PUSH	DE		;Zeiger in Puffer retten
		CALL	ReadText	;Lese ein Zeichen
		POP	DE
		POP	BC
		CP	' '+1		;Control/Space?
		JR	C,ReadNum4	;ja -> fertig
		RES	5,(HL)		;Empfang quittieren
		LD	(DE),A		;lege Ziffer ab
		INC	DE
		DJNZ	ReadNum3	;max. bis Puffer voll
ReadNum4:	XOR	A		;terminiere Puffer
		LD	(DE),A
ReadNum5:	POP	HL
		RET

;Untersuche Vorzeichen
;E: Zahl in Ascii in ConvBuf
;V: AF, B, IX
;R: Zero wenn ConvBuf leer,
;   sonst: B=0 wenn Zahl positiv, =1 wenn negativ
;	   IX zeigt auf erste Ziffer
ExamSign:	LD	IX,ConvBuf
		LD	A,(IX)
		OR	A		;Puffer leer?
		RET	Z		;ja -> raus mit Zero
		LD	B,0
		CP	'-'		;Zahl negativ?
		RET	NZ		;nein -> raus mit NZero und B=0
		INC	B		;ja -> NZero
		INC	IX
		RET

;E: Zeiger in umzuwandelnden String in IX,
;   Carry wenn Fehler (von AtoI bzw. AtoR)
;V: AF
;R: Carry wenn Fehler (von AtoI/AtoR oder String nicht zuende), IORes
;   sonst Zero
ChkForErr:	JR	C,ChkForErr1	;Fehler von AtoI/AtoR weiterleiten
		LD	A,(IX)
		OR	A		;umzuwandelnder String zuende?
		RET	Z		;ja -> ok
ChkForErr1:	LD	A,10h		;Error in numeric format
		LD	(IORes),A
		SCF
		RET

;Lese CHAR (TEXT)
;E: Zeiger auf Ziel in HL
;V: AF, BC, DE
;R:-
ReadChar:	PUSH	HL
		CALL	ReadText	;hole Zeichen
		RES	5,(HL)		;Empfang quittieren
		POP	HL
		LD	(HL),A		;lege Zeichen ab
		RET

;Lese BYTE (TEXT)
;E: Zeiger auf Ziel in HL, FilePointer
;V: AF, BC, DE, HL, IX
;R: gelesener Wert in HL wenn kein Fehler,
;   sonst Fehlercode in IORes und IX zeigt auf fehlerhaftes Zeichen
ReadByte:	DEFB	3Eh		;LD A,0AFh

;Lese INTEGER (TEXT)
;wie ReadByte
ReadInt:	XOR	A		;0 = Integer, <>0 = Byte
		LD	C,A		;Flag merken
		PUSH	BC
		CALL	ReadNumber
		POP	BC
		CALL	ExamSign
		RET	Z		;raus wenn Puffer leer (nicht zuweisen)
		PUSH	BC		;Flags und
		PUSH	HL		;Zieladresse retten
		CALL	AtoI
		POP	DE		;Zieladresse nach DE
		POP	BC
		CALL	ChkForErr
		RET	C		;raus wenn Fehler
		DEC	B		;negativ?
		CALL	Z,NegateHL	;ja -> umdrehen
		EX	DE,HL
		LD	(HL),E		;(Low-)Byte ablegen
		INC	C
		DEC	C		;Integer?
		JR	NZ,ReadInt1	;nein -> fertig
		INC	HL
		LD	(HL),D		;ja -> HighByte ablegen
ReadInt1:	EX	DE,HL		;eingelesene Zahl nach HL (wozu?)
		RET

;Lese REAL (TEXT)
;E: Zeiger auf Ziel in HL, FilePointer
;V: AF, BC, DE, HL, BCDEHL', IX
;R: Fehlercode in IORes und IX zeigt auf fehlerhaftes Zeichen
ReadReal:	CALL	ReadNumber
		CALL	ExamSign
		RET	Z		;raus wenn Puffer leer (nicht zuweisen)
		PUSH	BC		;Flag in B und
		PUSH	HL		;Zieladresse retten
		CALL	AtoR
		EXX			;Real-Zahl nach BCDEHL'
		POP	HL		;Zieladresse und
		POP	BC		;Flag holen
		CALL	ChkForErr
		RET	C		;raus wenn Fehler
		DEC	B		;negativ?
		EXX
		CALL	Z,NegateReal	;ja -> umdrehen
		EXX
		JP	StoreReal	;Realzahl ablegen

;Lese STRING (TEXT)
;E: Zeiger auf Ziel in HL, max. Laenge in B, FilePointer
;V: AF, BC, DE
;R: Fehlercode in IORes
ReadString:	PUSH	HL		;Zieladresse merken
		EX	DE,HL
		LD	C,0		;aktuelle Laenge
ReadStr1:	PUSH	BC		;akt. und max. Laenge sowie
		PUSH	DE		;Zieladresse retten
		CALL	ReadText	;Zeichen holen
		POP	DE
		POP	BC
		CP	CR		;CR beendet String
		JR	Z,ReadStr2
		CP	EOF		;EOF auch
		JR	Z,ReadStr2
		RES	5,(HL)		;Empfang quittieren
		INC	C		;akt. Laenge erhoehen
		INC	DE
		LD	(DE),A		;Zeichen ablegen
		DJNZ	ReadStr1	;weiter, aber nur bis max. Laenge
ReadStr2:	POP	HL		;Zieladresse holen
		LD	(HL),C		;Stringlaenge eintragen
		RET

;Lese Zeilenwechsel (TEXT)
;liest so lange, bis EOF, LF, CR oder CR/LF auftritt
;E: FilePointer
;V: AF, BC, DE, HL / R:-
ReadLine:	CALL	ReadText	;Zeichen holen
		CP	EOF		;End-of-file?
		JR	Z,ReadLin1	;ja -> fertig (warum nicht RET Z?)
		RES	5,(HL)		;Empfang quittieren
		CP	LF		;ist es nur LF?
		JR	Z,ReadLin1	;ja -> fertig
		CP	CR		;ist es CR?
		JR	NZ,ReadLine	;nein -> weiterlesen
		CALL	ReadText	;ja -> schaue naechstes Zeichen an
		CP	LF		;ist es LF?
		JR	NZ,ReadLin1	;nein -> war nur CR, lasse Zeichen
		RES	5,(HL)		;ja -> war CR/LF, nehme LF mit
ReadLin1:	RET

;Schreibe ein Byte auf akt. File (TEXT)
;E: Byte in A, FilePointer, IORes, StrPointer, StrLength, CBreak
;V: AF, BC, DE, HL
;R: <no return> wenn ^C
;   IORes sonst
;Achtung: obige E:V:R:-Litanei habe ich nicht vollstaendig in jede Routine
;	  uebernommen, die diese Routine aufruft. Das war mir zu unuebersichtlich.
WriteText:	LD	HL,(FilePointer)
		LD	C,A
		LD	A,(IORes)
		OR	A
		RET	NZ
		LD	A,(HL)
		AND	0Fh		;Devicenummer=0 (Datei)?
		JR	NZ,WriteTxt1	;nein -> auf Geraet ausgeben
		;auf Datei ausgeben
		INC	HL
		INC	HL
		PUSH	HL
		LD	A,(HL)		;Sektoroffset
		ADD	A,46
		LD	E,A		;naechstes freies Byte im Sektor-
		LD	D,0		;puffer adressieren
		ADD	HL,DE
		LD	(HL),C		;Byte ablegen
		POP	HL
		INC	(HL)		;Sektoroffset erhoehen
		RET	P		;wenn Sektor nicht voll, dann fertig
		JR	FlushSeq	;sonst Sektor schreiben

WriteTxt1: ;auf Geraet ausgeben
		CP	6		;Ausgabe in String?
		JR	Z,WriteTxt2
		POP	HL
		LD	B,0
		PUSH	BC
		PUSH	HL
		DEC	A		;=1 (CON:/TRM:)?
		JP	Z,ConOut	;ja -> ausgeben
		DEC	A		;2=KBD: darf nicht
		DEC	A		;=3 (LST:)?
		JP	Z,LstOut	;ja -> ausgeben
		DEC	A		;=4 (AUX:)?
		JP	Z,PunOut	;ja -> raus
		JP	ConOutx		;bleibt nur noch 5 (USR:)

WriteTxt2: ;Ausgabe in String (Pseudogeraet fuer STR-Prozedur)
		LD	HL,(StrPointer)
		LD	A,(StrLength)
		CP	(HL)
		RET	Z
		INC	(HL)
		LD	E,(HL)
		LD	D,0
		ADD	HL,DE
		LD	(HL),C
		RET

;Sektor flushen (fuer TEXT)
;E: FilePointer
;V: AF, BC, DE, HL
;R: IORes
FlushSeq:	LD	HL,(FilePointer)
		INC	HL
		INC	HL
		LD	A,(HL)		;Sektoroffset
		OR	A		;=0, d.h. nix reingeschrieben?
		RET	Z		;ja -> dann Schreiben nicht noetig
		LD	(HL),0		;Sektoroffset auf 0
		LD	C,WriteSeq
		CALL	FBDOS
		RET	Z		;raus wenn kein Fehler
		LD	A,0F0h		;Disk write error
		LD	(IORes),A
		RET

;Schreibe CHAR (TEXT)
;hier nur unformatierte Ausgabe. Formatierte Ausgabe:
;CHAR wird in STRING der Laenge 1 verwandelt und dieser dann formatiert ausgegeben
;E: Zeichen in (H)L, FilePointer
;V: AF, BC, DE, HL / R: IORes
WriteChar:	LD	A,L
		JP	WriteText

;Schreibe BYTE, INTEGER (TEXT)
;E: BYTE/INTEGER auf Stack, Feldbreite in HL (nicht angegeben = 0), FilePointer
;V: AF, BC, DE, HL, IX, Stack
;R: IORes
WriteInt:	POP	BC		;Returnadresse
		POP	DE		;Zahl nach DE
		PUSH	BC
		LD	IX,(BufPos)
		BIT	7,H		;Feldbreite positiv?
		JR	Z,WriteInt1	;ja -> vorzeichenbehaftete Ausgabe
	;vorzeichenlose Ausgabe
		CALL	NegateHL	;Feldbreite positiv machen
		EX	DE,HL		;Feldbreite nach DE, Zahl nach HL
		JR	WriteInt2

WriteInt1: ;vorzeichenbehaftete Ausgabe
		EX	DE,HL		;Feldbreite nach DE, Zahl nach HL
		BIT	7,H		;Zahl positiv?
		JR	Z,WriteInt2	;ja -> kein Vorzeichen
		CALL	NegateHL	;Zahl positiv machen
		LD	(IX),'-'	;Minus davor
		INC	IX
WriteInt2:	PUSH	DE		;Feldbreite merken
		CALL	ItoA		;Zahl umwandeln

	;Feldbreite auf Stack, Zeiger in Buffer in IX (nach erzeugtem String)
WriteIR:	POP	HL		;Feldbreite
		CALL	Range256	;HL -> A
		LD	DE,(BufPos)	;Laenge des erzeugten Strings berechnen
		PUSH	IX		;(Ende - Anfang)
		POP	HL
		OR	A
		SBC	HL,DE
		LD	C,L
		EX	DE,HL		;HL = Zeiger auf Anfang Buffer
;<fall through>

;Schreibe String rechtsbuendig in Feld
;E: HL = Zeiger auf String, C = Stringlaenge, A = Feldbreite
;V: AF, B, DE
;R: IORes
WriteRechts:	SUB	C		;Feld kleiner als erzeugter String?
		JR	C,WriteRec2	;ja -> kann man nix machen, trotzdem ausgeben
		JR	Z,WriteRec2	;gleich gross? ja -> einfach ausgeben
	;rechstbuendig: Leerzeichen davor
		LD	B,A		;soviele
		PUSH	HL
WriteRec1:	LD	A,' '
		PUSH	BC
		CALL	WriteText
		POP	BC
		DJNZ	WriteRec1
		POP	HL
WriteRec2: ;String ausgeben
		LD	B,C		;Stringlaenge
		INC	B
WriteRec3:	DEC	B
		RET	Z
		LD	A,(HL)
		PUSH	BC
		PUSH	HL
		CALL	WriteText
		POP	HL
		POP	BC
		INC	HL
		JR	WriteRec3

;Schreibe REAL (TEXT)
;E: REAL auf Stack, Feldbreite auf Stack (nicht angegeben = 18),
;   Anzahl Nachkommastellen in HL (nicht angegeben = -1), FilePointer
;V: AF, BC, DE, HL, BCDEHL', IX, IY, Stack
;R: IORes
WriteReal:	POP	BC		;Returnadresse
		POP	DE		;Feldbreite
		EXX
		POP	HL		;Real-Zahl
		POP	DE
		POP	BC
		EXX
		PUSH	BC		;Returnadresse
		LD	IX,(BufPos)
		PUSH	DE
		CALL	RtoA		;umwandeln nach ASCII
		JR	WriteIR

;Schreibe BOOLEAN (TEXT)
;E: BOOLEAN auf Stack, Feldbreite in HL (nicht angegeben = 0), FilePointer
;V: AF, BC, DE, HL, Stack
;R: IORes
WriteBool:	POP	BC		;Returnadresse
		POP	DE		;Wert
		PUSH	BC
		CALL	Range256	;HL -> A
		BIT	0,E
		LD	HL,TrueTxt
		LD	C,TrueLen
		JR	NZ,WriteRechts
		LD	HL,FalseTxt
		LD	C,FalseLen
		JR	WriteRechts

TrueTxt:	DEFB	'TRUE'
TrueLen		EQU	$-TrueTxt
FalseTxt:	DEFB	'FALSE'
FalseLen	EQU	$-FalseTxt

;Schreibe STRING (TEXT)
;E: STRING auf Stack, Feldbreite in HL (nicht angegeben = 0), FilePointer
;V: AF, BC, DE, HL, Stack
;R: IORes
WriteString:	CALL	Range256	;HL -> A
		LD	HL,2
		ADD	HL,SP		;String adressieren
		LD	C,(HL)		;Laenge holen
		INC	HL
		CALL	WriteRechts	;ausgeben
		POP	DE		;Returnadresse
		LD	SP,HL		;String wegwerfen
		PUSH	DE
		RET

;Schreibe konstanten STRING (TEXT)
;E: STRING im Code direkt hinter CALL, FilePointer
;V: AF, B, DE, HL
;R: IORes
WriteCString:	POP	HL		;Returnadresse = Zeiger auf String
		LD	A,(HL)		;Laenge holen
		INC	HL
		OR	A		;=0?
		JR	Z,WriteCStr2	;ja -> fertig
		LD	B,A
WriteCStr1:	LD	A,(HL)		;Zeichen holen
		PUSH	BC
		PUSH	HL
		CALL	WriteText	;ausgeben
		POP	HL
		POP	BC
		INC	HL
		DJNZ	WriteCStr1	;bis zum Stringende
WriteCStr2:	JP	(HL)		;dahinter Code fortsetzen

;Schreibe Zeilenwechsel (TEXT)
;E: FilePointer
;V: AF, BC, DE, HL / R: IORes
WriteLine:	LD	A,CR
		CALL	WriteText
		LD	A,LF
		JP	WriteText

;SeekEoln (TEXT)
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer
;R: TRUE (=1) in HL
SeekEoln:	LD	DE,0100h+CR
		JR	SeekEnd

;End Of Line (TEXT)
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer
;R: TRUE/FALSE in HL
EndOfLine:	LD	DE,0000h+CR
		JR	SeekEnd

;SeekEof (TEXT)
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer
;R: TRUE (=1) in HL
SeekEof:	LD	DE,0100h+EOF
		JR	SeekEnd

;End Of File (TEXT)
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer
;R: TRUE/FALSE in HL
EndOfFileT:	LD	DE,0000h+EOF

;E: D= Seek-Flag (0=Anfrage, 1=Seek), E wonach gesucht werden soll
;   FilePointer in HL
;V: AF, BC, HL, FilePointer
;R: TRUE/FALSE in HL
SeekEnd:	LD	(FilePointer),HL
		BIT	7,(HL)		;open for input?
		JR	Z,SeekEnd3	;nein -> liefere FALSE
SeekEnd1:	PUSH	DE
		CALL	ReadText	;lese ein Zeichen
		POP	DE
		CP	E		;ist es das gesuchte?
		JR	Z,SeekEnd2	;ja -> liefere TRUE
		CP	EOF		;ist es EOF?
		JR	Z,SeekEnd2	;ja -> TRUE (wenn EOF, dann auch EOLN)
		CP	'!'		;Control/Space?
		JR	NC,SeekEnd3	;nein -> liefere FALSE
		INC	D
		DEC	D		;Seek?
		JR	Z,SeekEnd3	;nein -> liefere FALSE
		RES	5,(HL)		;ja -> quittiere Empfang
		JR	SeekEnd1	;und lese weiter

SeekEnd2:	LD	HL,1		;lade TRUE
		RET

SeekEnd3:	LD	HL,0		;lade FALSE
		RET

;ENDE TP-RTL6B.INC
;-----------------
