;--------------------------------
;TP-RTL7A.INC	ho	24-JUL-92
;--------------------------------
;V1.00: 1851h-1BDAh
;V2.00: 1892h-1CA4h	V2.01: 188Ch-1C9Eh

		IDENT	TP-RTL7A.INC

;Schreibe ein Byte auf akt. File (TEXT) (mit Registerretten)
;E: Byte in A, FilePointer, IORes, StrPointer, StrLength, CBreak
;V: AF
;R: <no return> wenn ^C
;   IORes sonst
;Achtung: obige E:V:R:-Litanei habe ich nicht vollstaendig in jede Routine
;	  uebernommen, die diese Routine aufruft. Das war mir zu unuebersichtlich.
SWriteText:	PUSH	BC
		PUSH	DE
		PUSH	HL
		CALL	WriteText
		POP	HL
		POP	DE
		POP	BC
		RET

;Schreibe ein Byte auf akt. File (TEXT)
;E: Byte in A, FilePointer, IORes, StrPointer, StrLength, CBreak
;V: AF, BC, DE, HL
;R: <no return> wenn ^C
;   IORes sonst
;Achtung: obige E:V:R:-Litanei habe ich nicht vollstaendig in jede Routine
;	  uebernommen, die diese Routine aufruft. Das war mir zu unuebersichtlich.
WriteText:	LD	C,A
		CALL	ChkIOError
		LD	HL,(FilePointer)
		INC	HL
		LD	A,(HL)
		CP	6		;Datei?
		JR	Z,WriteTxt1	;ja ->
		JR	NC,WriteTxt2	;Ausgabe in String ->
	;auf Geraet ausgeben
		POP	HL
		LD	B,0
		PUSH	BC
		PUSH	HL
		OR	A		;=0 (CON:)?
		JP	Z,ConOut	;ja -> ausgeben
		DEC	A		;=1 (TRM:)?
		JP	Z,ConOut	;ja -> ausgeben
		DEC	A		;2=KBD: darf nicht
		DEC	A		;=3 (LST:)?
		JP	Z,LstOut	;ja -> ausgeben
		DEC	A		;=4 (AUX:)?
		JP	Z,PunOut	;ja -> raus
		JP	ConOutx		;bleibt nur noch 5 (USR:)

WriteTxt1: ;auf Datei ausgeben
		DEC	HL
		SET	3,(HL)		;Sektorpuffer modifiziert
		INC	HL
		INC	HL
		INC	HL
		PUSH	HL
		LD	A,(HL)		;Sektoroffset
		ADD	A,45
		LD	E,A		;naechstes freies Byte im Sektor-
		LD	D,0		;puffer adressieren
		ADD	HL,DE
		LD	(HL),C		;Byte ablegen
		POP	HL
		INC	(HL)		;Sektoroffset erhoehen
		RET	P		;wenn Sektor nicht voll, dann fertig
		LD	(HL),0
		LD	C,WriteSeq
		CALL	WriteSector
		RET	Z
		LD	A,0F0h		;Disk write error
		JP	AToIORes

WriteTxt2: ;Ausgabe in String (Pseudogeraet fuer STR-Prozedur)
		LD	HL,(StrPointer)
		LD	A,(StrLength)
		CP	(HL)
		RET	Z
		INC	(HL)
		LD	E,(HL)
		LD	D,0
		ADD	HL,DE
		LD	(HL),C
		RET

;Schreibe CHAR (TEXT)
;hier nur unformatierte Ausgabe. Formatierte Ausgabe:
;CHAR wird in STRING der Laenge 1 verwandelt und dieser dann formatiert ausgegeben
;E: Zeichen in (H)L, FilePointer
;V: AF / R: IORes
WriteChar:	LD	A,L
		JP	SWriteText

;Schreibe BYTE, INTEGER (TEXT)
;E: BYTE/INTEGER auf Stack, Feldbreite in HL (nicht angegeben = 0),
;   FilePointer, BufPos
;V: AF, BC, DE, HL, IX, Stack
;R: IORes
WriteInt:	POP	BC		;Returnadresse
		POP	DE		;Zahl nach DE
		PUSH	BC
		LD	IX,(BufPos)
		BIT	7,H		;Feldbreite positiv?
		JR	Z,WriteInt1	;ja -> vorzeichenbehaftete Ausgabe
	;vorzeichenlose Ausgabe
		CALL	NegateHL	;Feldbreite positiv machen
		EX	DE,HL		;Feldbreite nach DE, Zahl nach HL
		JR	WriteInt2

WriteInt1: ;vorzeichenbehaftete Ausgabe
		EX	DE,HL		;Feldbreite nach DE, Zahl nach HL
		BIT	7,H		;Zahl positiv?
		JR	Z,WriteInt2	;ja -> kein Vorzeichen
		CALL	NegateHL	;Zahl positiv machen
		LD	(IX),'-'	;Minus davor
		INC	IX
WriteInt2:	PUSH	DE		;Feldbreite merken
		CALL	ItoA		;Zahl umwandeln

	;Feldbreite auf Stack, Zeiger in Buffer in IX (nach erzeugtem String)
WriteIR:	POP	HL		;Feldbreite
		CALL	Range256	;HL -> A
		LD	DE,(BufPos)	;Laenge des erzeugten Strings berechnen
		PUSH	IX		;(Ende - Anfang)
		POP	HL
		OR	A
		SBC	HL,DE
		EX	DE,HL		;HL = Zeiger auf Anfang Buffer
;<fall through>

;Schreibe String rechtsbuendig in Feld
;E: HL = Zeiger auf String, E = Stringlaenge, A = Feldbreite
;V: AF, B, HL / R: IORes
WriteRechts:	SUB	E		;Feld kleiner als erzeugter String?
		JR	C,WriteRec2	;ja -> kann man nix machen, trotzdem ausgeben
		JR	Z,WriteRec2	;gleich gross? ja -> einfach ausgeben
	;rechstbuendig: Leerzeichen davor
		LD	B,A		;soviele
WriteRec1:	LD	A,' '
		CALL	SWriteText
		DJNZ	WriteRec1
WriteRec2: ;String ausgeben
		LD	B,E		;Stringlaenge
		INC	B
WriteRec3:	DEC	B
		RET	Z
		LD	A,(HL)
		CALL	SWriteText
		INC	HL
		JR	WriteRec3

;Schreibe REAL (TEXT)
;E: REAL auf Stack, Feldbreite auf Stack (nicht angegeben = 18),
;   Anzahl Nachkommastellen in HL (nicht angegeben = -1), FilePointer, BufPos
;V: AF, BC, DE, HL, BCDEHL', IX, IY, Stack
;R: IORes
WriteReal:	POP	BC		;Returnadresse
		POP	DE		;Feldbreite
		EXX
		POP	HL		;Real-Zahl
		POP	DE
		POP	BC
		EXX
		PUSH	BC		;Returnadresse
		LD	IX,(BufPos)
		PUSH	DE
		CALL	RtoA		;umwandeln nach ASCII
		JR	WriteIR

;Schreibe BOOLEAN (TEXT)
;E: BOOLEAN auf Stack, Feldbreite in HL (nicht angegeben = 0), FilePointer
;V: AF, BC, DE, HL, Stack
;R: IORes
WriteBool:	POP	BC		;Returnadresse
		POP	DE		;Wert
		PUSH	BC
		CALL	Range256	;HL -> A
		BIT	0,E
		LD	HL,TrueTxt
		LD	E,TrueLen
		JR	NZ,WriteRechts
		LD	HL,FalseTxt
		LD	E,FalseLen
		JR	WriteRechts

TrueTxt:	DEFB	'TRUE'
TrueLen		EQU	$-TrueTxt
FalseTxt:	DEFB	'FALSE'
FalseLen	EQU	$-FalseTxt

;Schreibe STRING (TEXT)
;E: STRING auf Stack, Feldbreite in HL (nicht angegeben = 0), FilePointer
;V: AF, B, DE, HL, Stack
;R: IORes
WriteString:	CALL	Range256	;HL -> A
		LD	HL,2
		ADD	HL,SP		;String adressieren
		LD	E,(HL)		;Laenge holen
		INC	HL
		CALL	WriteRechts	;ausgeben
		POP	DE		;Returnadresse
		LD	SP,HL		;String wegwerfen
		PUSH	DE
		RET

;Schreibe konstanten STRING (TEXT)
;E: STRING im Code direkt hinter CALL, FilePointer
;V: AF, B, HL
;R: IORes
WriteCString:	POP	HL		;Returnadresse = Zeiger auf String
		LD	A,(HL)		;Laenge holen
		INC	HL
		OR	A		;=0?
		JR	Z,WriteCStr2	;ja -> fertig
		LD	B,A
WriteCStr1:	LD	A,(HL)		;Zeichen holen
		CALL	SWriteText	;ausgeben
		INC	HL
		DJNZ	WriteCStr1	;bis zum Stringende
WriteCStr2:	JP	(HL)		;dahinter Code fortsetzen

;Schreibe Zeilenwechsel (TEXT)
;E: FilePointer
;V: AF / R: IORes
WriteLine:	LD	A,CR
		CALL	SWriteText
		LD	A,LF
		JP	SWriteText

;End Of Line (TEXT)
;E: FilePointer in HL
;V: AF, BC, DE, HL
;R: TRUE/FALSE in HL
EndOfLine:	LD	B,CR
		DEFB	11h		;LD DE,... naechsten Befehl maskieren
;<fall through>

;End Of File (TEXT)
;E: FilePointer in HL
;V: AF, BC, DE, HL
;R: TRUE/FALSE in HL
EndOfFileT:	LD	B,EOF
	;B= wonach gesucht werden soll
		LD	(FilePointer),HL
		BIT	0,(HL)		;open for input?
		LD	HL,0
		RET	Z		;nein -> liefere FALSE
		CALL	ReadAkt
		CP	B		;ist es das gesuchte?
		JR	Z,EndOfT	;ja -> liefere TRUE
		CP	EOF		;ist es EOF?
		RET	NZ
EndOfT:		INC	HL
		RET

;Lese Datensatz (aus FILE OF ...) (fuer alle Typen)
;E: Zieladresse in HL, FilePointer
;V: AF, BC, DE, HL, FIOFlag2
;R: IORes
ReadFO:		PUSH	HL
		CALL	FileSizeFP	;Dateigroesse in HL, akt. Satz in DE
		EX	DE,HL		;Satzgroesse in BC
		OR	A
		SBC	HL,DE		;Dateigroesse > akt. Satz?
		POP	HL
		JR	NC,UnexpEOF	;nein -> unerwartetes Dateiende
		CALL	FileRead	;ok, lese Datensatz
ReadWriteFO: ;akt. Satz erhoehen
		LD	HL,(FilePointer)
		LD	DE,8
		ADD	HL,DE		;adressiere akt. Satz
		INC	(HL)
		RET	NZ
		INC	HL
		INC	(HL)
		RET

UnexpEOF:	LD	A,99h		;Unexpected end-of-file
YAToIRes:	JP	AToIORes

;Schreibe Datensatz (in FILE OF ...) (fuer alle Typen)
;E: Quelladresse in HL, FilePointer
;V: AF, BC, DE, HL, FIOFlag2
;R: IORes
WriteFO:	PUSH	HL
		CALL	FileSizeFP	;Dateigroesse in HL, akt. Satz in DE
		OR	A		;Satzgroesse in BC
		SBC	HL,DE		;stehen wir am Dateiende?
		JR	NZ,WriteFO1	;nein -> in Datei schreiben
	;Dateigroesse erhoehen
		LD	HL,(FilePointer)
		LD	DE,4
		ADD	HL,DE		;Dateigroesse adressieren
		INC	(HL)
		JR	NZ,WriteFO1
		INC	HL		;erhoehen
		INC	(HL)		;mehr als 65535 Datensaetze?
		JR	Z,WriteFO2	;ja -> Datei zu gross
WriteFO1:	POP	HL
		CALL	FileWrite	;schreibe Datensatz
		JR	ReadWriteFO

WriteFO2: ;hier ist ein Fehler (in V3.00 weg): POP HL fehlt!
		LD	A,0F2h		;File size overflow
		JR	YAToIRes

;Random Schreiben in Datei
;E: BC = Anzahl Byte, HL = Quelladresse, FilePointer
;V: AF, BC, DE, HL, FIOFlag2
;R: IORes,
;   HL = aktualisierte Quelladresse  <- wer braucht das?
FileWrite:	DEFB	3Eh		;LD A,0AFh

;Random Lesen aus Datei
;E: BC = Anzahl Byte, HL = Zieladresse, FilePointer
;V: AF, BC, DE, HL, FIOFlag2
;R: IORes,
;   HL = aktualisierte Zieladresse  <- wer braucht das?
FileRead:	XOR	A
		LD	(FIOFlag2),A	;0= Read, <>0= Write
		CALL	ChkIOError
		EX	DE,HL		;Quell-/Zieladresse nach DE
FileRW1: ;einlesen, wenn erforderlich
		LD	HL,(FilePointer)
		BIT	2,(HL)		;Sektor leer?
		JR	Z,FileRW4	;nein, muss nicht mehr
		RES	2,(HL)
		LD	A,(FIOFlag2)
		OR	A		;lesen?
		JR	Z,FileRW2	;ja -> auf alle Faelle einlesen
	;einlesen vor schreiben
		INC	HL
		LD	A,(HL)		;Geraet
		DEC	HL
		OR	A		;=0?
		JR	NZ,FileRW2	;nein -> einlesen
		LD	A,B		;Anzahl Bytes zu schreiben
		OR	A		;groesser als ein Sektor (128 Byte)?
		JR	NZ,FileRW4	;ja -> dann nicht einlesen
		LD	A,C
		OR	A
		JP	M,FileRW4
FileRW2: ;Sektor einlesen in Puffer
		PUSH	BC
		PUSH	DE
		LD	C,ReadRand
		CALL	FBDOS
		POP	DE
		POP	BC
		JR	Z,FileRW4
		DEC	A
		JR	Z,FileRW3
		CP	3
		JR	NZ,FileRW9	;Unexpected end-of-file
FileRW3:	LD	A,(FIOFlag2)
		OR	A		;lesen?
		JR	Z,FileRW9	;ja -> Unexpected end-of-file
FileRW4:	LD	HL,(FilePointer)
		LD	A,(FIOFlag2)
		OR	A		;lesen?
		JR	Z,FileRW5	;ja -> weiter
		SET	3,(HL)		;nein -> 'Puffer veraendert' setzen
FileRW5:	INC	HL
		INC	HL
		INC	HL
		LD	A,(HL)		;Offset in Sektorpuffer
		ADD	A,45
		PUSH	DE
		LD	E,A
		LD	D,0
		ADD	HL,DE		;HL zeigt in Sektorpuffer
		POP	DE		;an aktuelle Schreib-/Leseposition
		SUB	45		;wieder Offset in A
		CALL	FileRWSwap	;Richtung bestimmen
FileRW6:	LDI			;kopieren
		JP	PO,FileRW7	;bis BC=0 (fertig)
		INC	A
		JP	P,FileRW6	;oder Offset >127 (Sektor voll)
		DEC	A
FileRW7:	INC	A
		CALL	FileRWSwap	;HL/DE wiederherstellen
		LD	HL,(FilePointer)
		INC	HL
		INC	HL
		INC	HL
		AND	7Fh		;Offset ablegen
		LD	(HL),A		;Ist der Sektor voll geworden?
		JR	NZ,FileRW8	;nein -> nicht rausschreiben
	;Sektor rausschreiben: Platz machen fuer weitere Daten
		PUSH	BC
		PUSH	DE
		PUSH	HL
		CALL	FlushRand	;u.A.: setze 'nichts eingelesen'
		POP	HL
		POP	DE
		POP	BC
		JR	NZ,DskWrErr	;Disk write error
		PUSH	DE
		LD	DE,42
		ADD	HL,DE		;adressiere random record position
		POP	DE
		INC	(HL)		;einen Sektor weiter
		JR	NZ,FileRW8
		INC	HL
		INC	(HL)
FileRW8:	LD	A,B		;war das alles, was zu schreiben war?
		OR	C
		JP	NZ,FileRW1	;nein -> nochmal
		EX	DE,HL		;aktualisierte Quell-/Zieladr.in HL
		RET

FileRW9:	LD	A,99h		;Unexpected end-of-file
		DEFB	01h		;LD BC,0F03Eh (naechsten Befehl maskieren)
DskWrErr:	LD	A,0F0h		;Disk write error
		JP	AToIORes

;E: FIOFlag2, DE, HL
;V: DE, HL
;R: DE, HL wenn Lesen, vertauscht wenn Schreiben
FileRWSwap:	PUSH	AF
		LD	A,(FIOFlag2)
		OR	A		;Lesen?
		JR	Z,FileRWSw1	;ja -> nix tun
		EX	DE,HL		;nein -> vertauschen
FileRWSw1:	POP	AF
		RET

;Flush (FILE of ...)
;E: FilePointer in HL
;V: AF, BC, DE, HL
;R: IORes
FlushFO:	LD	(FilePointer),HL
		CALL	FlushRand
		RET	Z		;Fehler? nein -> raus
		JR	DskWrErr	;Disk write error

;Flush
;E: FilePointer
;V: AF, BC, DE, HL / R: Zero und A=0 wenn kein Fehler
FlushRand:	LD	C,WriteRand
;<fall through>

;E: BDOS-Funktionsnummer in C, FilePointer
;V: AF, BC, DE, HL / R: Zero und A=0 wenn kein Fehler
WriteSector:	LD	HL,(FilePointer)
		SET	2,(HL)		;setze 'Sektorp. leer'
		BIT	3,(HL)		;Sektorp. veraendert?
		RET	Z		;nein -> fertig
		RES	3,(HL)		;ja, schreiben
		JR	FBDOS

;E: BDOS-Funktionsnummer in C, FilePointer
;V: AF, BC, DE, HL / R: Zero und A=0 wenn kein Fehler
ReadSector:	LD	HL,(FilePointer)
		BIT	2,(HL)		;Sektorp. leer?
		RET	Z		;nein -> fertig
		RES	2,(HL)		;setze Sektorp. nicht mehr leer
;<fall through>

;File-IO BDOS-Funktion ausfuehren
;E: Funktionsnummer in C, FilePointer in HL
;V: AF, BC, DE, HL
;R: Zero und A=0 wenn kein Fehler,
;   NZero und Fehlercode in A sonst
FBDOS:		PUSH	HL		;rette FilePointer
		PUSH	BC		;und Funktionsnummer
		LD	DE,48		;adressiere Sektorpuffer
		ADD	HL,DE
		EX	DE,HL
		LD	C,SetDMA
		CALL	BDOS
		POP	BC		;hole Funktionsnummer
		POP	HL		;und FilePointer
		LD	DE,12		;adressiere FCB
		ADD	HL,DE
		EX	DE,HL
		CALL	BDOS
		OR	A
		RET

;Seek (FILE of ...)
;E: FilePointer auf Stack, Nummer des Datensatzes in HL
;V: AF, BC, DE, HL, HL', FilePointer
;R: IORes
SeekFO:		POP	BC		;Returnadresse
		POP	DE
		LD	(FilePointer),DE
		PUSH	BC
		PUSH	HL		;Datensatz
		CALL	FileSizeFP	;Dateikenngroessen holen
		POP	DE
		OR	A
		SBC	HL,DE		;> max.?
		JR	C,SeekBEOF	;ja -> Seek beyond end-of-file
		LD	HL,(FilePointer)
		LD	BC,6
		ADD	HL,BC
		LD	C,(HL)		;Satzgroesse
		INC	HL
		LD	B,(HL)
		INC	HL
		LD	(HL),E		;akt. Satz
		INC	HL
		LD	(HL),D
		CALL	Mult32
		LD	BC,4		;Groesse der Info am Dateianfang
		ADD	HL,BC		;+ (Satzgroesse x akt.Satz)
		JR	NC,SeekFO1	;32-Bit Addition
		INC	DE
SeekFO1:	LD	A,L		;Offset in File (in Byte) in DEHL
		AND	7Fh		;MOD 128 merken
		ADD	HL,HL		;dann DIV 128 berechnen
		EX	DE,HL
		ADC	HL,HL
		EX	DE,HL
		LD	D,E
		LD	E,H		;DE = log. Sektornummer
		LD	HL,(FilePointer)
		INC	HL
		INC	HL
		INC	HL
		LD	(HL),A		;Offset in Sektor
		LD	BC,42
		ADD	HL,BC		;adressiere random record position
		LD	C,(HL)		;alte Position nach BC
		INC	HL
		LD	B,(HL)
		EX	DE,HL
		OR	A
		SBC	HL,BC
		ADD	HL,BC		;gleich geblieben?
		RET	Z		;ja -> fertig
		PUSH	DE		;nein -> flush
		PUSH	HL
		CALL	FlushRand
		POP	DE
		POP	HL
		LD	(HL),D		;neue Position
		DEC	HL
		LD	(HL),E
		RET

SeekBEOF:	LD	A,91h		;Seek beyond end-of-file
		JP	AToIORes

;Vorzeichenlose 16-Bit Multiplikation mit 32-Bit Ergebnis
;E: X in BC, Y in DE
;V: AF, DEHL, HL'
;R: X * Y in DEHL
Mult32:		PUSH	DE		;Y nach HL' bringen
		EXX
		POP	HL
		EXX
		LD	HL,0		;DEHL = 32-Bit Akku
		LD	D,H
		LD	E,L
		LD	A,16		;Zaehler
Mult33:		ADD	HL,HL		;DEHL links schieben
		EX	DE,HL
		ADC	HL,HL
		EX	DE,HL
		EXX
		ADD	HL,HL		;Y links schieben
		EXX			;Bit rausgefallen?
		JR	NC,Mult34	;nein -> nix tun
		ADD	HL,BC		;ja -> X draufaddieren
		JR	NC,Mult34	;und zwar 32-Bit breit
		INC	DE
Mult34:		DEC	A		;fertig?
		JR	NZ,Mult33	;nein -> weiter
		RET

;End Of File (FILE OF ..., FILE)
;E: Filepointer in HL
;V: F, BC, DE, HL
;R: TRUE/FALSE in HL
;Verfahren:
;EOF genau dann, wenn die akt. Satznummer gleich der Dateigroesse in Saetzen ist.
EndOfFileF:	CALL	FileSizeHL
		OR	A
		SBC	HL,DE		;Dateigroesse - akt. Satznummer
		LD	HL,0		;FALSE annehmen
		RET	NZ		;ungleich -> fertig
		INC	HL		;gleich -> TRUE liefern
		RET

;FilePos (FILE of ..., FILE)
;E: FilePointer in HL
;V: F, BC, DE, HL
;R: akt. Satznummer in HL
FilePos:	CALL	FileSizeHL
		EX	DE,HL
		RET

;Dateikenngroessen holen
;E: FilePointer
;V: F, BC, DE, HL
;R: Dateigroesse in Saetzen in HL, Satzgroesse in BC, akt. Satznummer in DE
FileSizeFP:	LD	HL,(FilePointer)
;<fall through>

;FileSize (FILE of ..., FILE)
;E: FilePointer in HL
;V: F, BC, DE, HL
;R: Dateigroesse in Saetzen in HL
;   (Satzgroesse in BC, akt. Satznummer in DE)
FileSizeHL:	LD	DE,4
		ADD	HL,DE
		LD	E,(HL)		;Dateigroesse in Datensaetzen
		INC	HL
		LD	D,(HL)
		INC	HL
		PUSH	DE
		LD	C,(HL)		;Satzgroesse in Bytes
		INC	HL
		LD	B,(HL)
		INC	HL
		LD	E,(HL)		;Aktueller Satz
		INC	HL
		LD	D,(HL)
		POP	HL
		RET

;Blockwrite (FILE) mit 3 Parameter
;blockwrite(var f:FILE, var v:irgendeine Variable, rec:INT)
;E: rec in HL, Zeiger auf v und Zeiger auf f auf Stack
;V: AF, BC, DE, HL, IX, FilePointer, FIOVar, MemVar1, FIOFlag2
;R: IORes
BlockWr3:	LD	A,WriteRand
		JR	BlockRdWr3

;Blockread (FILE) mit 3 Parameter
;wie Blockwrite mit 3 Parametern
BlockRd3:	LD	A,ReadRand
BlockRdWr3:	LD	(FIOFlag2),A
		LD	B,H		;rec nach BC
		LD	C,L
		POP	IX		;Returnadresse
		POP	DE		;Zeiger auf v
		POP	HL		;Zeiger auf f
		PUSH	IX
	;BlockRW1
		LD	(FilePointer),HL
		LD	A,(HL)
		AND	3		;offen zum Lesen oder Schreiben?
		JP	Z,FNotOpen	;nein -> File not open
BlockRW2:	LD	A,B		;rec=0?
		OR	C
		JR	Z,BlockRW4	;ja -> fertig
		PUSH	BC
		PUSH	DE		;DMA setzen
		LD	C,SetDMA
		CALL	BDOS
		LD	HL,(FilePointer)
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		EX	DE,HL		;nach DE
		LD	A,(FIOFlag2)	;BDOS-Funktionsnummer holen
		LD	C,A
		CALL	BDOS		;ausfuehren (read/write random)
		POP	DE
		POP	BC
		OR	A		;Fehler?
		JR	Z,BlockRW3	;nein -> weiter
		LD	L,A
		LD	A,(FIOFlag2)
		CP	WriteRand	;Schreiben?
		JR	NZ,BlockRW5	;nein -> Unexpected end-of-file
		LD	A,L
		DEC	A
		JR	Z,BlockRW3
		CP	3
		JR	NZ,BlockRW6	;Disk write error
BlockRW3:	PUSH	BC
		PUSH	DE
		LD	HL,(FilePointer)
		LD	DE,45		;random record position adressieren
		ADD	HL,DE
		LD	C,(HL)		;erhoehen
		INC	HL
		LD	B,(HL)
		INC	BC
		LD	(HL),B
		DEC	HL
		LD	(HL),C
		LD	DE,-37		;akt. Satz adressieren
		ADD	HL,DE
		LD	(HL),C		;akt. Position eintragen
		INC	HL
		LD	(HL),B
		POP	DE
		POP	BC
		LD	HL,SecSize
		ADD	HL,DE
		EX	DE,HL
		DEC	BC
		JR	BlockRW2

BlockRW4:	LD	HL,(FilePointer)
		LD	DE,9
		ADD	HL,DE
		LD	B,(HL)		;akt. Satz nach BC
		DEC	HL
		LD	C,(HL)
		DEC	HL
		DEC	HL
		DEC	HL
		LD	D,(HL)		;Dateigroesse in Saetzen nach DE
		DEC	HL
		LD	E,(HL)
		EX	DE,HL
		OR	A		;stehen wir weiter hinten, d.h.
		SBC	HL,BC		;haben wir gerade die Datei verlaengert?
		RET	NC		;nein -> fertig
		EX	DE,HL		;ja -> akt. Position ist neue Laenge
		LD	(HL),C
		INC	HL
		LD	(HL),B
		RET

BlockRW5:	LD	A,99h		;ja -> Unexpected end-of-file
		JR	BlkRWErr

BlockRW6:	LD	A,0F0h		;nein -> Disk write error
		JR	BlkRWErr

FNotOpen:	LD	A,04h		;File not open
BlkRWErr:	JP	AToIORes

;Seek (FILE)
;E: FilePointer auf Stack, Nummer des Datensatzes in HL
;V: AF, BC, DE, HL, FilePointer
;R: IORes
SeekF:		POP	BC		;Returnadresse
		POP	DE		;FilePointer
		LD	(FilePointer),DE
		PUSH	BC		;Returnadresse
		PUSH	HL
		CALL	FileSizeFP
		POP	DE		;DE= Datensatz,
		OR	A		;HL= Dateigroesse in Saetzen
		SBC	HL,DE		;Seek hinter Ende?
		JP	C,SeekBEOF	;ja -> Fehler
		LD	HL,(FilePointer)
		LD	BC,8		;akt. Satz adressieren
		ADD	HL,BC
		LD	(HL),E		;gewuenschte Satznummer eintragen
		INC	HL
		LD	(HL),D
		LD	BC,36		;random record position adressieren
		ADD	HL,BC
		LD	(HL),E		;auch dort eintragen
		INC	HL
		LD	(HL),D
		RET

IF TPVers2
;OVERLAYs

.COMMENT %----------------------------------------------------------------
Grundlagen:
(Wo im folgenden 'Funktion' steht, so ist damit immer
'Funktion bzw. Prozedur' gemeint!)

Verwendung siehe Handbuch bzw. TurboPascal-Buecher. Kurz zur Erinnerung:
Alle im Quelltext aufeinanderfolgenden Funktionen, die mit 'OVERLAY' versehen
sind, werden in eine Overlaydatei compiliert. Die einzelnen Funktionen werden
darin einfach aneinandergereiht. Jeweils nach einer Funktion wird genau soviel
Platz gelassen, dass die naechste auf einer Sektorgrenze (Vielfaches von 128)
anfaengt.Overlaydateien tragen den Namen des Programms und die Endung .000 bis
.099. Jeder Overlaydatei ist ein Overlaybereich im Hauptspeicher zugeordnet,
der folgende Struktur aufweist:

		CALL	Overlay
		FCB der Overlaydatei (36 Byte)
		DEFS	n * 128		Platz fuer die groesste Funktion, die
					in dieser Overlaydatei enthalten ist
----------------------------------------------------------------% ;COMMENT

;Overlay laden
;E: Startsektor in HL, Laenge in Sektoren in DE, Returnadresse zeigt
;   auf Overlaybereich+3 (Struktur s.o.)
;V: AF, BC, DE, HL, IX, OvrBegin, OvrLength, OvrArea
;R: Overlay-Prozedur:-
;   Overlay-Funktion: was sie halt so liefert
Overlay:	LD	(OvrBegin),HL	;Parameter retten
		LD	(OvrLength),DE
		ADD	HL,DE		;Ende ausrechnen
		EX	DE,HL
		POP	HL		;Zeiger auf Overlaybereich
		LD	(OvrArea),HL	;merken
		LD	BC,33
		ADD	HL,BC		;random record position adressieren
		LD	C,(HL)		;holen
		INC	HL
		LD	B,(HL)
		EX	DE,HL
		OR	A		;mit dem Ende vergleichen
		SBC	HL,BC		;gleich?
		JR	Z,Overlay5	;ja -> schon geladen
		LD	A,B		;random record pos. =0?
		OR	C		;d.h. stehen wir noch am Anfang der Datei
		JR	NZ,Overlay2	;nein -> sie ist schon offen
	;Datei aufmachen
		LD	HL,(OvrArea)
		LD	BC,12		;Extent bis random rec.pos.
		ADD	HL,BC
		LD	B,24		;mit 0 initialisieren
Overlay1:	LD	(HL),0
		INC	HL
		DJNZ	Overlay1
		LD	DE,(OvrArea)
		LD	C,OpenFile
		CALL	BDOS
		INC	A		;hat's geklappt?
		JR	Z,Overlay6	;nein -> Fehler
Overlay2: ;Funktion einlesen
		LD	HL,(OvrArea)
		LD	BC,33
		ADD	HL,BC		;random record position adressieren
		LD	BC,(OvrBegin)
		LD	(HL),C		;Anfang eintragen
		INC	HL
		LD	(HL),B
		INC	HL
		INC	HL		;zeigt auf Platz fuer Funktion
		EX	DE,HL
		LD	BC,(OvrLength)
Overlay3:	PUSH	BC
		PUSH	DE
		LD	C,SetDMA
		CALL	BDOS
		LD	DE,(OvrArea)
		LD	C,ReadRand
		CALL	BDOS
		OR	A		;hat's geklappt?
		JR	NZ,Overlay6	;nein -> Fehler
	;random record position erhoehen
		LD	HL,(OvrArea)
		LD	BC,33
		ADD	HL,BC
		INC	(HL)
		JR	NZ,Overlay4
		INC	HL
		INC	(HL)
Overlay4:	POP	DE
		LD	HL,SecSize	;Zieladresse weiterschalten
		ADD	HL,DE
		EX	DE,HL
		POP	BC
		DEC	BC		;Zaehler erniedrigen
		LD	A,B		;fertig?
		OR	C
		JR	NZ,Overlay3	;nein -> weiterlesen

Overlay5: ;Funktion starten
		LD	HL,(OvrArea)	;Startadresse ausrechnen
		LD	BC,36
		ADD	HL,BC
		JP	(HL)		;los geht's

Overlay6: ;Fehler beim Oeffnen der Datei oder beim Lesen
		LD	IX,(OvrArea)	;Fehler-PC
		LD	A,0F0h
		JP	RunTimErr
ENDIF
;ENDE FILE I/O

;ENDE TP-RTL7A.INC
;-----------------
