;--------------------------------
;TP-RTL7B.INC	ho	24-JUL-92
;--------------------------------
;V3.00: 1810h-1CE4h	V3.01: 1811h-1CE5h

		IDENT	TP-RTL7B.INC

;Rewrite (FILE of ...)
;Datei zum Schreiben oeffnen. Ev. vorhandene Datei wird geloescht
;E: FilePointer in HL, Satzgroesse in DE, IORes
;V: AF, BC, DE, HL, FIOFlag1, FIOFlag2, FIOVar, FilePointer
;R: IORes
RewriteFO:	DEFB	3Eh		;LD A,0AFh

;Reset (FILE of ...)
;Vorhandene Datei zum Lesen oeffnen
;wie Rewrite (FILE of ...)
ResetFO:	XOR	A		;0 = Reset, <>0 = Rewrite
		LD	(FIOFlag1),A
		LD	(FIOVar),DE	;Satzgroesse merken
		CALL	CloseFO		;erstmal zumachen, wenn offen war
		LD	A,(IORes)
		OR	A		;hats geklappt?
		RET	NZ		;nein -> raus
		CALL	FOpen		;aufmachen
		LD	A,(IORes)
		OR	A		;hats geklappt?
		RET	NZ		;nein -> raus
		LD	HL,(FilePointer)
		LD	(HL),0D0h	;Offen zum Lesen und Schreiben,
		INC	HL		;noch nichts eingelesen
		INC	HL
		LD	(HL),A		;(A=0) Sektoroffset := 0
		LD	DE,6
		ADD	HL,DE
		LD	(HL),A		;Akt. Satz := 0
		INC	HL
		LD	(HL),A
		LD	DE,36
		ADD	HL,DE
		LD	(HL),A		;Random record position := 0
		INC	HL
		LD	(HL),A
		LD	DE,-42
		ADD	HL,DE		;Dateigroesse in Saetzen adressieren
		LD	A,(FIOFlag1)
		OR	A		;Reset?
		JR	NZ,RewriteFO1	;nein -> Rewrite
	;ResetFO1
		PUSH	HL		;HL zeigt in FIB auf Dateigroesse in
		LD	BC,4		;Saetzen / Satzgroesse
		XOR	A		;dorthin die ersten 4 Byte einlesen
		CALL	FileRW
		POP	HL
		INC	HL
		INC	HL
		LD	C,(HL)		;Satzgroesse holen
		INC	HL
		LD	B,(HL)
		LD	HL,(FIOVar)
		OR	A		;und vergleichen
		SBC	HL,BC
		RET	Z		;passt? ja -> fertig
		LD	A,90h		;nein -> Record length mismatch
		LD	(IORes),A
		RET

RewriteFO1:	PUSH	HL
		XOR	A
		LD	(HL),A		;Anzahl Datensaetze := 0
		INC	HL
		LD	(HL),A
		INC	HL
		LD	DE,(FIOVar)	;Satzgroesse eintragen
		LD	(HL),E
		INC	HL
		LD	(HL),D
		POP	HL		;Anzahl Datensaetze und Satzgroesse
		LD	BC,4		;als erste 4 Byte der Datei schreiben
		LD	A,3		;anhaengen
		JP	FileRW

;Close (FILE OF ...)
;Datei schliessen (egal, ob sie fuer Lesen oder Schreiben offen war)
;E: FilePointer in HL, IORes
;V: AF, BC, DE, HL, FilePointer, FIOFlag2
;R: IORes
CloseFO:	LD	(FilePointer),HL
		LD	A,(HL)
		AND	0C0h		;offen (fuer Ein- oder Ausgabe)?
		RET	Z		;nein -> Schliessen nicht noetig
	;zuletzt bearbeiteten Sektor flushen
		CALL	FlushRand
	;neue Anzahl Datensaetze eintragen an den Dateianfang
		LD	HL,(FilePointer)
		LD	DE,45
		ADD	HL,DE		;adressiere random record position
		XOR	A
		LD	(HL),A		;:= 0
		INC	HL
		LD	(HL),A
		LD	DE,-44
		ADD	HL,DE		;adressiere Offset in Sektorpuffer
		LD	(HL),A		;:=0
		INC	HL
		INC	HL		;adressiere Dateigroesse
		LD	BC,4
		LD	A,1		;in Datei schreiben
		CALL	FileRW
		CALL	FlushRand
		JP	FClose

;Eingabe und Ausgabe vorbereiten (FILE OF ..)
;E: FilePointer in HL
;V: AF, FilePointer, FIOPC
;R: IORes
PrepFO:		EX	(SP),HL
		LD	(FIOPC),HL	;PC fuer Fehlerfall merken
		EX	(SP),HL
		LD	(FilePointer),HL
		LD	A,(HL)
		AND	0C0h		;Datei offen (fuer Lesen oder Schreiben)?
		RET	NZ		;ja -> fertig
FNotOpen:	LD	A,04h		;File not open
		LD	(IORes),A
		RET

;Lese Datensatz (aus FILE OF ...) (fuer alle Typen)
;E: Zieladresse in HL, IORes, FilePointer
;V: AF, BC, DE, HL, FIOFlag2
;R: IORes
ReadFO:		LD	A,(IORes)
		OR	A		;bisher alles paletti?
		RET	NZ		;nein -> raus
		PUSH	HL
		CALL	FileSizeFP	;Dateigroesse in HL, akt. Satz in DE
		EX	DE,HL		;Satzgroesse in BC
		OR	A
		SBC	HL,DE		;Dateigroesse > akt. Satz?
		POP	HL
		JR	NC,UnexpEOF	;nein -> unerwartetes Dateiende
		XOR	A		;ok, lese Datensatz
		CALL	FileRW
ReadWriteFO: ;akt. Satz erhoehen
		LD	HL,(FilePointer)
		LD	DE,8
		ADD	HL,DE		;adressiere akt. Satz
		INC	(HL)
		RET	NZ
		INC	HL
		INC	(HL)
		RET

UnexpEOF:	LD	A,99h		;Unexpected end-of-file
		LD	(IORes),A
		RET

;Schreibe Datensatz (in FILE OF ...) (fuer alle Typen)
;E: Quelladresse in HL, IORes, FilePointer
;V: AF, BC, DE, HL, FIOFlag2
;R: IORes
WriteFO:	LD	A,(IORes)
		OR	A		;bisher alles paletti?
		RET	NZ		;nein -> raus
		PUSH	HL
		CALL	FileSizeFP	;Dateigroesse in HL, akt. Satz in DE
		OR	A		;Satzgroesse in BC
		SBC	HL,DE		;stehen wir am Dateiende?
		LD	A,1
		JR	NZ,WriteFO2	;nein -> in Datei schreiben
	;Dateigroesse erhoehen
		LD	HL,(FilePointer)
		LD	DE,4
		ADD	HL,DE		;Dateigroesse adressieren
		INC	(HL)
		JR	NZ,WriteFO1
		INC	HL		;erhoehen
		INC	(HL)		;mehr als 65535 Datensaetze?
		JR	Z,WriteFO3	;ja -> Datei zu gross
WriteFO1:	LD	A,3		;anhaengen
WriteFO2:	POP	HL
		CALL	FileRW		;schreibe Datensatz
		JR	ReadWriteFO

WriteFO3:	POP	HL		;Quelladresse wegwerfen
		LD	A,0F2h		;File size overflow
		LD	(IORes),A
		RET

;Random Lesen/Schreiben in Datei
;E: Flag in A: 0= lesen, 1= schreiben in Datei, 3= anhaengen
;   BC = Anzahl Byte, HL = Quell-/Zieladresse, FilePointer
;V: AF, BC, DE, HL, FIOFlag2
;R: IORes,
;   HL = aktualisierte Quell-/Zieladresse  <- wer braucht das?
FileRW:		LD	(FIOFlag2),A	;Flags merken
		EX	DE,HL		;Quell-/Zieladresse nach DE
FileRW1: ;einlesen, wenn erforderlich
		LD	HL,(FilePointer)
		BIT	4,(HL)		;noch nichts eingelesen?
		JR	Z,FileRW3	;doch, muss nicht mehr
		RES	4,(HL)
		LD	A,(FIOFlag2)
		BIT	0,A		;lesen?
		JR	Z,FileRW2	;ja -> auf alle Faelle einlesen
	;einlesen vor schreiben
		INC	HL
		INC	HL
		LD	A,(HL)		;Offset in Sektorpuffer
		DEC	HL
		DEC	HL
		OR	A		;=0?
		JR	NZ,FileRW2	;nein -> einlesen
		LD	A,(FIOFlag2)
		BIT	1,A		;anhaengen?
		JR	NZ,FileRW3	;ja -> brauch ich nicht einlesen
		LD	A,B		;Anzahl Bytes zu schreiben
		OR	A		;groesser als ein Sektor (128 Byte)?
		JR	NZ,FileRW3	;ja -> dann nicht einlesen
		LD	A,C
		OR	A
		JP	M,FileRW3
FileRW2: ;Sektor einlesen in Puffer
		PUSH	BC
		PUSH	DE
		LD	C,ReadRand
		CALL	FBDOS
		POP	DE
		POP	BC
		JR	NZ,FileRW8	;Unexpected end-of-file
		LD	HL,(FilePointer)
FileRW3:	LD	A,(FIOFlag2)
		BIT	0,A		;schreiben?
		JR	Z,FileRW4	;nein -> weiter
		SET	5,(HL)		;ja -> 'Puffer veraendert' setzen
FileRW4:	INC	HL
		INC	HL
		LD	A,(HL)		;Offset in Sektorpuffer
		ADD	A,46
		PUSH	DE
		LD	E,A
		LD	D,0
		ADD	HL,DE		;HL zeigt in Sektorpuffer
		POP	DE		;an aktuelle Schreib-/Leseposition
		SUB	46		;wieder Offset in A
		CALL	FileRWSwap	;Richtung bestimmen
FileRW5:	LDI			;kopieren
		JP	PO,FileRW6	;bis BC=0 (fertig)
		INC	A
		JP	P,FileRW5	;oder Offset >127 (Sektor voll)
		DEC	A
FileRW6:	INC	A
		CALL	FileRWSwap	;HL/DE wiederherstellen
		LD	HL,(FilePointer)
		INC	HL
		INC	HL
		AND	7Fh		;Offset ablegen
		LD	(HL),A		;Ist der Sektor voll geworden?
		JR	NZ,FileRW7	;nein -> nicht rausschreiben
	;Sektor rausschreiben: Platz machen fuer weitere Daten
		PUSH	BC
		PUSH	DE
		PUSH	HL
		CALL	FlushRand	;u.A.: setze 'nichts eingelesen'
		POP	HL
		POP	DE
		POP	BC
		JR	NZ,DskWrErr	;Disk write error
		PUSH	DE
		LD	DE,43
		ADD	HL,DE		;adressiere random record position
		POP	DE
		INC	(HL)		;einen Sektor weiter
		JR	NZ,FileRW7
		INC	HL
		INC	(HL)
FileRW7:	LD	A,B		;war das alles, was zu schreiben war?
		OR	C
		JP	NZ,FileRW1	;nein -> nochmal
		EX	DE,HL		;aktualisierte Quell-/Zieladr.in HL
		RET

FileRW8:	LD	A,99h		;Unexpected end-of-file
		DEFB	01h		;LD BC,0F03Eh (naechsten Befehl maskieren)
DskWrErr:	LD	A,0F0h		;Disk write error
		LD	(IORes),A
		RET

;E: FIOFlag2, DE, HL
;V: DE, HL
;R: DE, HL wenn Lesen, vertauscht wenn Schreiben
FileRWSwap:	PUSH	AF
		LD	A,(FIOFlag2)
		BIT	0,A		;Lesen?
		JR	Z,FileRWSw1	;ja -> nix tun
		EX	DE,HL		;nein -> vertauschen
FileRWSw1:	POP	AF
		RET

;Flush (FILE of ...)
;E: FilePointer in HL
;V: AF, BC, DE, HL, FilePointer
;R: IORes
FlushFO:	LD	(FilePointer),HL
		CALL	FlushRand
		RET	Z		;Fehler? nein -> raus
		JR	DskWrErr	;Disk write error

;Flush
;E: FilePointer
;V: AF, BC, DE, HL
;R: Zero und A=0 wenn kein Fehler, NZero und Fehlercode in A sonst
FlushRand:	LD	C,WriteRand
		LD	HL,(FilePointer)
		SET	4,(HL)		;setze 'Nichts eingelesen'
		BIT	5,(HL)		;Sektor veraendert?
		RET	Z		;nein -> fertig
		RES	5,(HL)		;ja, schreiben
;<fall through>

;File-IO BDOS-Funktion ausfuehren
;E: Funktionsnummer in C, FilePointer
;V: AF, BC, DE, HL
;R: Zero und A=0 wenn kein Fehler,
;   NZero und Fehlercode in A sonst
FBDOS:		LD	HL,(FilePointer)
		PUSH	HL		;rette FilePointer
		PUSH	BC		;und Funktionsnummer
		LD	DE,48		;adressiere Sektorpuffer
		ADD	HL,DE
		EX	DE,HL
		LD	C,SetDMA
		CALL	BDOS
		POP	BC		;hole Funktionsnummer
		POP	HL		;und FilePointer
		LD	DE,12		;adressiere FCB
		ADD	HL,DE
		EX	DE,HL
		CALL	BDOS
		OR	A
		RET

;Seek (FILE of ...)
;E: FilePointer auf Stack, Nummer des Datensatzes in HL
;V: AF, BC, DE, HL, HL', FilePointer
;R: IORes
SeekFO:		POP	BC		;Returnadresse
		POP	DE
		LD	(FilePointer),DE
		PUSH	BC
		PUSH	HL		;Datensatz
		CALL	FileSizeFP	;Dateikenngroessen holen
		POP	DE
		OR	A
		SBC	HL,DE		;> max.?
		JR	C,SeekBEOF	;ja -> Seek beyond end-of-file
		LD	HL,(FilePointer)
		LD	BC,6
		ADD	HL,BC
		LD	C,(HL)		;Satzgroesse
		INC	HL
		LD	B,(HL)
		INC	HL
		LD	(HL),E		;akt. Satz
		INC	HL
		LD	(HL),D
		CALL	Mult32
		LD	BC,4		;Groesse der Info am Dateianfang
		ADD	HL,BC		;+ (Satzgroesse x akt.Satz)
		JR	NC,SeekFO1	;32-Bit Addition
		INC	DE
SeekFO1:	LD	A,L		;Offset in File (in Byte) in DEHL
		AND	7Fh		;MOD 128 merken
		ADD	HL,HL		;dann DIV 128 berechnen
		EX	DE,HL
		ADC	HL,HL
		EX	DE,HL
		LD	D,E
		LD	E,H		;DE = log. Sektornummer
		LD	HL,(FilePointer)
		INC	HL
		INC	HL
		LD	(HL),A		;Offset in Sektor
		LD	BC,43
		ADD	HL,BC		;adressiere random record position
		LD	C,(HL)		;alte Position nach BC
		INC	HL
		LD	B,(HL)
		EX	DE,HL
		OR	A
		SBC	HL,BC
		ADD	HL,BC		;gleich geblieben?
		RET	Z		;ja -> fertig
		PUSH	DE		;nein -> flush
		PUSH	HL
		CALL	FlushRand
		POP	DE
		POP	HL
		LD	(HL),D		;neue Position
		DEC	HL
		LD	(HL),E
		RET

SeekBEOF:	LD	A,91h		;Seek beyond end-of-file
		LD	(IORes),A
		RET

;Vorzeichenlose 16-Bit Multiplikation mit 32-Bit Ergebnis
;E: X in BC, Y in DE
;V: AF, DEHL, HL'
;R: X * Y in DEHL
Mult32:		PUSH	DE		;Y nach HL' bringen
		EXX
		POP	HL
		EXX
		LD	HL,0		;DEHL = 32-Bit Akku
		LD	D,H
		LD	E,L
		LD	A,16		;Zaehler
Mult33:		ADD	HL,HL		;DEHL links schieben
		EX	DE,HL
		ADC	HL,HL
		EX	DE,HL
		EXX
		ADD	HL,HL		;Y links schieben
		EXX			;Bit rausgefallen?
		JR	NC,Mult34	;nein -> nix tun
		ADD	HL,BC		;ja -> X draufaddieren
		JR	NC,Mult34	;und zwar 32-Bit breit
		INC	DE
Mult34:		DEC	A		;fertig?
		JR	NZ,Mult33	;nein -> weiter
		RET

;End Of File (FILE OF ..., FILE)
;E: Filepointer in HL
;V: F, BC, DE, HL
;R: TRUE/FALSE in HL
;Verfahren:
;EOF genau dann, wenn die akt. Satznummer gleich der Dateigroesse in Saetzen ist.
EndOfFileF:	CALL	FileSizeHL
		OR	A
		SBC	HL,DE		;Dateigroesse - akt. Satznummer
		LD	HL,0		;FALSE annehmen
		RET	NZ		;ungleich -> fertig
		INC	HL		;gleich -> TRUE liefern
		RET

;FilePos (FILE of ..., FILE)
;E: FilePointer in HL
;V: F, BC, DE, HL
;R: akt. Satznummer in HL
FilePos:	CALL	FileSizeHL
		EX	DE,HL
		RET

;Dateikenngroessen holen
;E: FilePointer
;V: F, BC, DE, HL
;R: Dateigroesse in Saetzen in HL, Satzgroesse in BC, akt. Satznummer in DE
FileSizeFP:	LD	HL,(FilePointer)
;<fall through>

;FileSize (FILE of ..., FILE)
;E: FilePointer in HL
;V: F, BC, DE, HL
;R: Dateigroesse in Saetzen in HL
;   (Satzgroesse in BC, akt. Satznummer in DE)
FileSizeHL:	LD	DE,4
		ADD	HL,DE
		LD	E,(HL)		;Dateigroesse in Datensaetzen
		INC	HL
		LD	D,(HL)
		INC	HL
		PUSH	DE
		LD	C,(HL)		;Satzgroesse in Bytes
		INC	HL
		LD	B,(HL)
		INC	HL
		LD	E,(HL)		;Aktueller Satz
		INC	HL
		LD	D,(HL)
		POP	HL
		RET

;Rewrite (FILE)
;Datei zum Schreiben oeffnen. Ev. vorhandene Datei wird geloescht
;E: FilePointer in HL, IORes
;V: AF, BC, DE, HL, FIOFlag1, FilePointer
;R: IORes
RewriteF:	DEFB	3Eh		;LD A,0AFh

;Reset (FILE)
;Vorhandene Datei zum Lesen oeffnen
;wie Rewrite (FILE)
ResetF:		XOR	A
		LD	(FIOFlag1),A	;=0 Reset, <>0 Rewrite
		CALL	CloseF		;zumachen
		LD	A,(IORes)
		OR	A		;trat ein Fehler auf?
		RET	NZ		;ja -> raus
		CALL	FOpen		;aufmachen
		LD	A,(IORes)
		OR	A		;trat ein Fehler auf?
		RET	NZ		;ja -> raus
		LD	HL,(FilePointer)
		LD	(HL),0C0h	;Datei, offen zum Lesen und Schreiben
		PUSH	HL
		LD	DE,12
		ADD	HL,DE		;adressiere FCB
		EX	DE,HL
		LD	C,FileSize
		CALL	BDOS
		POP	HL
		LD	DE,45
		ADD	HL,DE		;adressiere random record position
		XOR	A
		LD	C,(HL)		;loeschen und alten Wert nach BC
		LD	(HL),A
		INC	HL
		LD	B,(HL)
		LD	(HL),A
		LD	DE,-42
		ADD	HL,DE
		LD	(HL),C		;ablegen als Dateigroesse in Saetzen
		INC	HL
		LD	(HL),B
		INC	HL
		LD	(HL),SecSize	;Satzgroesse in Byte
		INC	HL
		LD	(HL),A
		INC	HL
		LD	(HL),A		;Akt. Satz := 0
		INC	HL
		LD	(HL),A
		RET

;Close (FILE)
;Datei schliessen (egal, ob sie fuer Lesen oder Schreiben offen war)
;E: Zeiger auf FIB in HL
;V: AF, BC, DE, HL, FilePointer
;R: IORes
CloseF:		LD	(FilePointer),HL
		LD	A,(HL)
		AND	0C0h		;offen zum Lesen oder Schreiben?
		RET	Z		;nein -> fertig
		JP	FClose

;Blockwrite (FILE) mit 3 Parameter
;blockwrite(var f:FILE, var v:irgendeine Variable, rec:INT)
;E: rec in HL, Zeiger auf v und Zeiger auf f auf Stack
;V: AF, BC, DE, HL, IX, FilePointer, FIOVar, MemVar1, FIOFlag2
;R: IORes
BlockWr3:	LD	A,WriteRand
		JR	BlockRdWr3

;Blockread (FILE) mit 3 Parameter
;wie Blockwrite mit 3 Parametern
BlockRd3:	LD	A,ReadRand
BlockRdWr3:	LD	B,H		;rec nach BC
		LD	C,L
		LD	HL,MemVar1	;tatsaechliche Anzahl gelesener/
		LD	(FIOVar),HL	;geschriebener Records nach MemVar1
		POP	IX		;Returnadresse
		POP	DE		;Zeiger auf v
		POP	HL		;Zeiger auf f
		PUSH	IX
		PUSH	BC		;rec merken
		CALL	BlockRW1	;Blockread/write
		POP	BC
		LD	A,(IORes)
		OR	A		;trat Fehler auf?
		RET	NZ		;ja -> raus
		LD	HL,(MemVar1)	;tatsaechliche Anzahl holen
		SBC	HL,BC		;mit rec vergleichen.Stimmt es?
		RET	Z		;ja -> raus
		LD	A,(FIOFlag2)
		CP	ReadRand	;war es Blockread?
		LD	A,99h		;ja -> Unexpected end-of-file
		JR	Z,BlkRWErr
		LD	A,0F0h		;nein -> Disk write error
BlkRWErr:	LD	(IORes),A
		RET

;Blockwrite (FILE) mit 4 Parameter
;blockwrite(var f:FILE, var v:irgendeine Variable, rec:INT, var c:INT)
;E: Adresse von c in HL, rec und Zeiger auf v und Zeiger auf f auf Stack
;V: AF, BC, DE, HL, IX, FilePointer, FIOVar, FIOFlag2
;R: IORes
BlockWr4:	LD	A,WriteRand
		JR	BlockRdWr4

;Blockread (FILE) mit 4 Parameter
;wie Blockwrite mit 4 Parametern
BlockRd4:	LD	A,ReadRand
BlockRdWr4:	LD	(FIOVar),HL	;Adresse von c
		POP	IX		;Returnadresse
		POP	BC		;rec
		POP	DE		;Adresse von v
		POP	HL		;Adresse von f
		PUSH	IX
;<fall through>

;Blockread/write
;E: BDOS-Funktion in A, rec in BC, Adresse von v in DE, Adresse von f in HL,
;   Adresse von c in FIOVar
;V: AF, BC, DE, HL, FIOFlag2, FilePointer
;R: BDOS-Funktion in FIOFlag2, IORes
BlockRW1:	LD	(FIOFlag2),A
		LD	(FilePointer),HL
		LD	A,(HL)
		AND	0C0h		;offen zum Lesen oder Schreiben?
		JP	Z,FNotOpen	;nein -> File not open
		LD	HL,(FIOVar)	;c loeschen
		XOR	A
		LD	(HL),A
		INC	HL
		LD	(HL),A
BlockRW2:	LD	A,B		;rec=0?
		OR	C
		JR	Z,BlockRW5	;ja -> fertig
		PUSH	BC
		PUSH	DE		;DMA setzen
		LD	C,SetDMA
		CALL	BDOS
		LD	HL,(FilePointer)
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		EX	DE,HL		;nach DE
		LD	A,(FIOFlag2)	;BDOS-Funktionsnummer holen
		LD	C,A
		CALL	BDOS		;ausfuehren (read/write random)
		POP	DE
		POP	BC
		OR	A		;Fehler?
		JR	NZ,BlockRW5	;ja -> aufhoeren
		PUSH	DE
		LD	HL,(FilePointer)
		LD	DE,45		;random record position adressieren
		ADD	HL,DE
		INC	(HL)		;erhoehen
		JR	NZ,BlockRW3
		INC	HL
		INC	(HL)
BlockRW3:	POP	DE
		LD	HL,SecSize	;DMA weiterschalten
		ADD	HL,DE
		EX	DE,HL
		LD	HL,(FIOVar)	;c erhoehen
		INC	(HL)
		JR	NZ,BlockRW4
		INC	HL
		INC	(HL)
BlockRW4:	DEC	BC		;rec erniedrigen
		JR	BlockRW2

BlockRW5:	;fertig oder Fehler
		LD	HL,(FilePointer)
		LD	DE,45		;random record position adressieren
		ADD	HL,DE
		LD	C,(HL)
		INC	HL
		LD	B,(HL)
		LD	DE,-38		;akt. Satz adressieren
		ADD	HL,DE
		LD	(HL),C		;akt. Position eintragen
		INC	HL
		LD	(HL),B
		LD	DE,-4		;Dateigroesse in Saetzen adressieren
		ADD	HL,DE
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		EX	DE,HL
		OR	A		;stehen wir weiter hinten, d.h.
		SBC	HL,BC		;haben wir gerade die Datei verlaengert?
		RET	NC		;nein -> fertig
		EX	DE,HL		;ja -> akt. Position ist neue Laenge
		LD	(HL),C
		INC	HL
		LD	(HL),B
		RET

;Seek (FILE)
;E: FilePointer auf Stack, Nummer des Datensatzes in HL
;V: AF, BC, DE, HL, FilePointer
;R: IORes
SeekF:		POP	BC		;Returnadresse
		POP	DE		;Zeiger auf FIB
		LD	(FilePointer),DE
		PUSH	BC		;Returnadresse
		PUSH	HL
		CALL	FileSizeFP
		POP	DE		;DE= Datensatz,
		OR	A		;HL= Dateigroesse in Saetzen
		SBC	HL,DE		;Seek hinter Ende?
		JP	C,SeekBEOF	;ja -> Fehler
		LD	HL,(FilePointer)
		LD	BC,8		;akt. Satz adressieren
		ADD	HL,BC
		LD	(HL),E		;gewuenschte Satznummer eintragen
		INC	HL
		LD	(HL),D
		LD	BC,36		;random record position adressieren
		ADD	HL,BC
		LD	(HL),E		;auch dort eintragen
		INC	HL
		LD	(HL),D
		RET

;Erase (TEXT, FILE of ..., FILE)
;E: Zeiger auf FIB in HL
;V: AF, BC, DE, HL, FilePointer
;R: IORes
Erase:		CALL	HLToFPointer	;Datei?
		RET	NZ		;nein -> Fehler!
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		EX	DE,HL
		LD	C,DeleteFile
		CALL	BDOS		;loeschen
		INC	A		;hat's geklappt?
		RET	NZ		;ja -> fertig
		JR	ErrNoFile	;File does not exist

;Rename (TEXT, FILE of ..., FILE)
;E: Dateiname (STRING) auf Stack, FilePointer auf Stack, BufPos
;V: AF, BC, DE, HL, IX, IY, Stack, FilePointer
;R: IORes
Rename:		POP	IY		;Returnadresse
		LD	HL,(BufPos)	;neuen Namen ablegen
		LD	B,16
		CALL	StoreString
		XOR	A		;Name terminieren
		LD	(DE),A
		POP	HL		;Zeiger auf FIB holen
		PUSH	IY		;Returnadresse wieder drauf
		CALL	HLToFPointer	;Datei?
		RET	NZ		;nein -> Fehler!
		PUSH	HL
		CALL	ParseUFN	;neuen Namen parsen
		POP	HL
		PUSH	HL
		LD	DE,12+16	;adressiere zweite Haelfte FCB
		ADD	HL,DE
		EX	DE,HL
		LD	HL,DefaultFCB
		LD	BC,12		;kopiere neuen Namen rein
		LDIR			;alter Name steht in erster Haelfte
		POP	HL
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		PUSH	HL
		EX	DE,HL
		LD	C,RenameFile
		CALL	BDOS		;umbenennen
		POP	DE
		INC	A		;hat's geklappt?
		JR	Z,ErrNoFile	;nein -> Fehler
		LD	HL,DefaultFCB	;FCB in FIB kopieren
		LD	BC,36		;(aehnlich Assign2, hier
		LDIR			;liesse sich vmtl. ein
		RET			;wenig Platz sparen)

ErrNoFile:	LD	A,01h		;File does not exist
ErrNoF1:	LD	(IORes),A
		RET


;Execute
;E: FilePointer in HL, IORes, StandAlone
;V: AF, BC, DE, HL, FilePointer, FIOFlag1
;R: <no return> wenn ok, sonst Fehlercode in IORes
Execute:	DEFB	3Eh		;LD A,0AFh

;Chain
;wie Execute
Chain:		XOR	A
		LD	(FIOFlag1),A	;0= Chain, <>0= Execute
	;zulaessig?
		CALL	HLToFPointer	;Datei?
		RET	NZ		;nein -> Fehler!
		LD	A,(StandAlone)
		OR	A
		LD	A,21h		;Not allowed in direct mode
		JR	Z,ErrNoF1
	;Datei aufmachen
		LD	HL,(FilePointer)
		LD	DE,12		;FCB adressieren
		ADD	HL,DE
		LD	DE,DefaultFCB	;FCB kopieren
		LD	BC,36
		LDIR
		LD	DE,DefaultFCB
		LD	C,OpenFile
		CALL	BDOS		;Datei oeffnen
		INC	A		;hat's geklappt?
		JR	Z,ErrNoFile	;nein -> Fehler
	;Overlay kopieren und starten
		LD	HL,@ChainOvly
		LD	DE,ChainOvly
		LD	BC,ChainLen
		LDIR
		LD	DE,TPA		;Ladeadresse fuer Execute
		LD	A,(FIOFlag1)
		OR	A		;Chain?
		JR	NZ,ExeChn	;nein -> Execute
		LD	DE,(TPA+1)	;Ladeadresse fuer Chain
ExeChn:		LD	SP,TPA
		JP	ChainOvly

@ChainOvly:
		.PHASE	ChainOvly
;E: Ladeadresse in DE, SP aus dem Weg
;   DefaultFCB enthaelt FCB der zu ladenden Datei (bereits offen)
ChainO1:	PUSH	DE
		LD	C,SetDMA	;Ladeadresse setzen
		CALL	BDOS
		LD	DE,DefaultFCB
		LD	C,ReadSeq	;einen Sektor lesen
		CALL	BDOS
		POP	DE
		LD	HL,SecSize	;DMA weiterschalten
		ADD	HL,DE
		EX	DE,HL
		OR	A		;hat's geklappt?
		JR	Z,ChainO1	;ja -> weiter
	;Laden fertig
		JR	TPA		;geladenes Programm starten
		.DEPHASE
ChainLen	EQU	$-@ChainOvly

;E: FilePointer in HL
;V: AF, FilePointer
;R: Zero, wenn Datei
;   NZero, wenn Geraet (und Fehlercode in IORes)
HLToFPointer:	LD	(FilePointer),HL
		LD	A,(HL)
		AND	0Fh		;Datei?
		RET	Z		;ja -> ok
		LD	A,20h		;Operation not allowed on a logical device
		LD	(IORes),A
		RET

;OVERLAYs

.COMMENT %----------------------------------------------------------------
Grundlagen:
(Wo im folgenden 'Funktion' steht, so ist damit immer
'Funktion bzw. Prozedur' gemeint!)

Verwendung siehe Handbuch bzw. TurboPascal-Buecher. Kurz zur Erinnerung:
Alle im Quelltext aufeinanderfolgenden Funktionen, die mit 'OVERLAY' versehen
sind, werden in eine Overlaydatei compiliert. Die einzelnen Funktionen werden
darin einfach aneinandergereiht. Jeweils nach einer Funktion wird genau soviel
Platz gelassen, dass die naechste auf einer Sektorgrenze (Vielfaches von 128)
anfaengt.Overlaydateien tragen den Namen des Programms und die Endung .000 bis
.099. Jeder Overlaydatei ist ein Overlaybereich im Hauptspeicher zugeordnet,
der folgende Struktur aufweist:

		CALL	Overlay
		DEFW	-1		Startsektor der im Moment geladenen
					Funktion (-1 = nichts geladen)
		DEFB	'HALLO   000'	Name der Overlaydatei, geparsed
		DEFS	n * 128		Platz fuer die groesste Funktion, die
					in dieser Overlaydatei enthalten ist
----------------------------------------------------------------% ;COMMENT

;Overlay laden
;E: Startsektor in HL, Laenge in Sektoren in DE, Returnadresse zeigt
;   auf Overlaybereich+3 (Struktur s.o.), OvrDrv
;V: AF, BC, DE, HL, IX, OvrBegin, OvrLength, OvrArea
;R: Overlay-Prozedur:-
;   Overlay-Funktion: was sie halt so liefert
Overlay:	LD	(OvrBegin),HL	;Parameter retten
		LD	(OvrLength),DE
		EX	DE,HL
		POP	HL		;Zeiger auf Overlaybereich
		LD	(OvrArea),HL	;merken
		LD	C,(HL)		;Startsektor der im Moment
		LD	(HL),E		;geladenen Funktion holen
		INC	HL		;und Startsektor der gewuenschten
		LD	B,(HL)		;Funktion ablegen
		LD	(HL),D
		EX	DE,HL
		OR	A
		SBC	HL,BC		;diese Funktion schon geladen?
		JR	Z,Overlay3	;ja -> starten, nicht mehr laden
		EX	DE,HL
		INC	HL		;zeigt auf Name der Overlaydatei
	;FCB basteln
		LD	DE,DefaultFCB
		LD	A,(OvrDrv)	;Laufwerk eintragen
		LD	(DE),A
		INC	DE
		LD	BC,11		;Name kopieren
		LDIR
		LD	B,24		;Rest mit 0 initialisieren
		XOR	A
Overlay1:	LD	(DE),A
		INC	DE
		DJNZ	Overlay1
		PUSH	HL		;zeigt auf Platz fuer Funktion
	;Datei aufmachen
		LD	DE,DefaultFCB
		LD	C,OpenFile
		CALL	BDOS
		POP	DE
		INC	A		;hat's geklappt?
		JR	Z,Overlay4	;nein -> Fehler
		LD	HL,(OvrBegin)
		LD	(DefaultFCB+33),HL ;random record position
		LD	BC,(OvrLength)
Overlay2: ;Funktion einlesen
		PUSH	BC
		PUSH	DE
		LD	C,SetDMA
		CALL	BDOS
		LD	DE,DefaultFCB
		LD	C,ReadRand
		CALL	BDOS
		POP	DE
		POP	BC
		OR	A		;hat's geklappt?
		JR	NZ,Overlay4	;nein -> Fehler
		LD	HL,(DefaultFCB+33) ;random rec. erhoehen
		INC	HL
		LD	(DefaultFCB+33),HL
		LD	HL,SecSize	;Zieladresse weiterschalten
;auch	LD HL,DefaultFCB+33
;	CALL ReadWriteFO+7	= INC (HL)/RET NZ/INC HL/INC (HL)/RET
;	LD L,SecSize
;moeglich, spart 2 Byte
		ADD	HL,DE
		EX	DE,HL
		DEC	BC		;Zaehler erniedrigen
		LD	A,B		;fertig?
		OR	C
		JR	NZ,Overlay2	;nein -> weiterlesen
	;Datei schliessen
		LD	DE,DefaultFCB
		LD	C,CloseFile
		CALL	BDOS
Overlay3: ;Funktion starten
		LD	HL,(OvrArea)	;Startadresse ausrechnen
		LD	DE,13
		ADD	HL,DE
		JP	(HL)		;los geht's

Overlay4: ;Fehler beim Oeffnen der Datei oder beim Lesen
		LD	IX,(OvrArea)	;Fehler-PC
		LD	A,0F0h
		JP	RunTimErr

;Ovrdrive
;E: Laufwerk in HL (0= aktuelles, 1= A usw.)
;V: AF, OvrDrv / R:-
OvrDrive:	CALL	Range256	;HL -> A
		CP	17		;<=16?
		RET	NC		;nein -> ignorieren
		LD	(OvrDrv),A
		RET
;ENDE FILE I/O

;ENDE TP-RTL7B.INC
;-----------------
