;--------------------------------
;TP-RTL8.INC	ho	24-JUL-92
;--------------------------------
;V1.00: 1BDBh-1D75h
;V2.00: 1CA5h-1FC8h	V2.01: 1C9Fh-1FC2h
;V3.00: 1CE5h-20E1h	V3.01: 1CE6h-20E2h

		IDENT	TP-RTL8.INC

.COMMENT %----------------------------------------------------------------
		SPEICHERVERWALTUNG

Speicheraufteilung:

0000		ZeroPage
0100		Laufzeitsystem
in ProgStart	Beginn TP-Programm
		Ende TP-Programm = Anfang Heap (verkettete Liste freier Bloecke)
in HeapPtr	Ende Heap = Anfang nichtzugeordneter Speicher
in RecurPtr	Ende nichtzugeordneter Speicher = Anfang Rekursionsstack
		Ende Rekursionsstack = Beginn fuer Stack reservierter Bereich
+1024		Ende Stack = Beginn Variablen
		Ende Variablen = Beginn Zeilenpuffer
+128		Ende Zeilenpuffer = Speicherende (Compiler-Option E)
		von TP nicht verwendet (entfaellt wenn nicht Option E)
		BDOS
----------------------------------------------------------------% ;COMMENT

IF TPVers1
;New
;E: Groesse in HL, Adresse der Zeigervariablen p auf Stack
;V: F, DE, HL, Stack
;R: <no return> wenn Out Of Memory
GetMem:		EX	DE,HL		;Groesse nach DE
		POP	HL
		EX	(SP),HL		;Adresse von p nach HL
		PUSH	HL		;und wieder merken
		LD	HL,(HeapPtr)
		PUSH	HL
		ADD	HL,DE		;Heap entsprechend vergroessern
		LD	(HeapPtr),HL
		LD	DE,(RecurPtr)
		OR	A
		SBC	HL,DE		;neuer HeapPtr >= RecurPtr?
		POP	DE		;alter HeapPtr-Wert
		POP	HL		;Adresse von p
		JR	NC,HSCollision	;ja -> Fehler
New1:		LD	(HL),E
		INC	HL
		LD	(HL),D
		RET

HSCollision:	LD	A,0FFh		;Heap/stack collision
		JP	RunTimErrX

;Mark
;E: Adresse einer Zeigervariablen in HL, HeapPtr
;V: DE, HL / R:-
Mark:		LD	DE,(HeapPtr)
		JR	New1

;Release
;E: Adresse einer Zeigervariablen in HL
;V: DE, HL / R: HeapPtr
Release:	LD	E,(HL)
		INC	HL
		LD	D,(HL)
		LD	(HeapPtr),DE
		RET

;Memavail
;E: RecurPtr, HeapPtr
;V: F, DE, HL
;R: verfuegbarer Heap-Speicher in HL
MemAvail:	LD	HL,0		;schauen, was niedriger ist,
		ADD	HL,SP		;der Stack oder der
		LD	DE,(RecurPtr)	;Rekursionszeiger
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		JR	C,MemAvail1
		EX	DE,HL		;das niedrigere nehmen
MemAvail1:	LD	DE,(HeapPtr)
		OR	A		;Platz ab Ende Heap bis
		SBC	HL,DE		;dahin berechnen
		RET
ELSE	;TPVers2, TPVers3

.COMMENT %----------------------------------------------------------------
Heap-Struktur:

Speicheranforderungen werden auf ein Vielfaches von 4 Byte aufgerundet,
dadurch sind auch die freien Bloecke mindestens 4 Byte gross.
Vergebene Bloecke tragen keine zusaetzliche Information.
Freie Bloecke haben folgende Struktur:

Off Groesse	Inhalt
--- -------	------
00  Wort	Zeiger auf den Nachfolger in der verketteten Liste der
		freien Bloecke
02  Wort	Laenge in Byte
04  (Laenge-4) Bytes beliebig

Die Liste ist an FreeRoot aufgehaengt und adressenmaessig sortiert.
Sie enthaelt als letztes Element stets einen Dummy-freien Block, der
aus zwei Null-Worten besteht.
----------------------------------------------------------------% ;COMMENT

;New, Getmem
;E: Groesse in HL, Adresse der Zeigervariablen p auf Stack
;V: AF, BC, DE, HL, IX, Stack
;R: <no return> wenn Out Of Memory
GetMem:		LD	(MemVar1),HL	;Groesse
		EX	DE,HL
		POP	HL
		EX	(SP),HL
		LD	(MemVar2),HL	;Adresse von p
		INC	DE		;Groesse auf naechstes
		INC	DE		;Vielfaches von 4 aufrunden
		INC	DE
		LD	A,E
		AND	0FCh
		LD	E,A
		LD	HL,FreeRoot	;Zeiger auf Vorgaenger-Block merken
		LD	(MemVar5),HL	;(um Nachfolge-Zeiger aendern zu koennen)
		LD	IX,(FreeRoot)	;Suche passenden freien Block
GetMem1:	LD	L,(IX+02)	;Groesse des Blocks
		LD	H,(IX+03)
		LD	A,L
		OR	H		;=0, d.h. Ende der Liste?
		JR	Z,GetMem6	;ja -> Heap-Bereich vergroessern
		SBC	HL,DE		;Block gross genug?
		JR	NC,GetMem2	;ja -> nimm ihn ('first fit' Strategie)
		LD	L,(IX)		;hole Zeiger auf Nachfolge-Block
		LD	H,(IX+01)
		PUSH	HL
		LD	(MemVar5),IX	;aktueller Block wird Vorgaenger
		POP	IX		;Nachfolger wird aktueller Block
		JR	GetMem1		;weiter suchen

GetMem2: ;Block ist gross genug
		JR	NZ,GetMem3	;groesser? ja -> Block teilen
		LD	E,(IX)		;nein -> Block passt genau, also
		LD	D,(IX+01)	;aus Freiliste entfernen:
		PUSH	IX		;Nachfolger des akt. Blocks als
		JR	GetMem5		;Nachfolger des Vorgaengers eintragen

GetMem3: ;Block teilen
		LD	C,L		;HL= Groesse des Rest-Blocks
		LD	B,H
		LD	L,(IX)		;Nachfolge-Block
		LD	H,(IX+01)
GetMem4:	PUSH	IX
		ADD	IX,DE		;Beginn des Rest-Blocks nach IX
		LD	(IX),L		;aktueller Nachfolger wird Nach-
		LD	(IX+01),H	;folger des Rest-Blocks
		LD	(IX+02),C	;Rest-Groesse eintragen
		LD	(IX+03),B
		PUSH	IX		;ersten Teil-Block aus Freiliste
		POP	DE		;entfernen: Rest-Block als Nachfol-
GetMem5:	LD	HL,(MemVar5)	;ger des Vorgaengers eintragen
		LD	(HL),E
		INC	HL
		LD	(HL),D
		POP	DE		;Zeiger auf zugeteilten Block
		LD	HL,(MemVar2)	;Adresse von p holen
		LD	(HL),E		;Zeiger in p eintragen
		INC	HL
		LD	(HL),D
		RET

GetMem6: ;kein Block gross genug, versuche Heap-Bereich zu vergroessern
		PUSH	IX		;zeigt auf Listenende
		POP	HL
		ADD	HL,DE		;neues Heap-Ende berechnen
		LD	(HeapPtr),HL
		LD	HL,(MemVar1)	;Groesse
		LD	BC,4
		ADD	HL,BC
		PUSH	IX
		POP	BC
		ADD	HL,BC		;Listenende+4+Groesse > 65535?
		JP	C,HSCollision	;ja -> Fehler
		LD	BC,(RecurPtr)
		SBC	HL,BC		;< RecurPtr?
		LD	BC,0
		LD	HL,0
		JP	C,GetMem4	;ja -> erzeuge neuen Block
HSCollision:	LD	A,0FFh		;Heap/stack collision
		JP	RunTimErrX

;Dispose, Freemem
;E: Groesse in HL, Adresse der Zeigervariablen p auf Stack
;V: AF, BC, DE, HL, IX, IY, Stack
;R:-
FreeMem:	EX	DE,HL		;Groesse nach DE
		POP	HL
		EX	(SP),HL		;Adresse von p nach HL
		LD	A,(HL)
		INC	HL
		LD	H,(HL)
		LD	L,A		;p in HL
		INC	DE		;Groesse auf naechstes Viel-
		INC	DE		;faches von 4 aufrunden
		INC	DE
		LD	A,E
		AND	0FCh
		LD	E,A
		EX	DE,HL		;p nach DE, Groesse nach HL
		LD	(MemVar1),HL	;Groesse merken
		LD	HL,(FreeRoot)
		PUSH	HL
		POP	IX
		OR	A		;FreeRoot >= p, d.h. muss vor
		SBC	HL,DE		;ersten Block einsortiert werden?
		JR	NC,FreeMem4	;ja -> neues FreeRoot
FreeMem1:	LD	L,(IX)
		LD	H,(IX+01)	;Nachfolger adressieren
		PUSH	HL
		OR	A
		SBC	HL,DE		;naechster Block >p?
		JR	NC,FreeMem2	;ja -> Block dazwischen einsortieren
		POP	IX		;nein -> weiter suchen
		JR	FreeMem1

FreeMem2: ;Block einsortieren zwischen IX = Zeiger auf Vorgaenger
	  ;und auf Stack = Zeiger auf Nachfolger, DE = einzusortierender Block
		POP	HL		;Zeiger auf Nachfolger
		PUSH	DE
		POP	IY		;einzusortierender Block
		LD	BC,(MemVar1)	;Laenge dazu
		LD	(IY+02),C	;eintragen
		LD	(IY+03),B
		LD	(IY),L		;Nachfolger eintragen
		LD	(IY+01),H
		LD	(IX),E		;als Nachfolger des Vorgaengers eintragen
		LD	(IX+01),D
		PUSH	IX
		POP	HL		;Vorgaenger
		LD	C,(IX+02)	;Laenge des Vorgaengers
		LD	B,(IX+03)	;DE = einsortierter Block
		CALL	JoinBlock	;erfolgreich?
		JR	Z,FreeMem3	;ja -> Vorgaenger umfasst jetzt beide Bloecke
		LD	E,(IX)		;nein -> einsortierten Block hernehmen
		LD	D,(IX+01)
		PUSH	DE
		POP	IX
FreeMem3:	PUSH	IX
		POP	HL
		LD	C,(IX+02)	;Laenge des Blocks A
		LD	B,(IX+03)
		LD	E,(IX)		;Block B
		LD	D,(IX+01)
		JR	JoinBlock

FreeMem4: ;Spezialfall: Block muss vor erstem Block einsortiert werden
	  ;Adresse des Blocks in DE, Laenge in MemVar1
		LD	HL,(FreeRoot)	;Adresse des bisher ersten Blocks
		LD	(FreeRoot),DE	;neue Wurzel
		PUSH	DE
		POP	IX
		LD	(IX),L		;Nachfolger der neuen Wurzel
		LD	(IX+01),H	;ist der alte erste Block
		LD	BC,(MemVar1)	;gemerkte Groesse
		LD	(IX+02),C	;eintragen
		LD	(IX+03),B
		EX	DE,HL
;<fall through>

;Schauen, ob Block A mit Block B verschmolzen werden kann
;E: IX = HL = Zeiger auf Block A, BC = Laenge von Block A,
;   DE = Zeiger auf Block B
;V: AF, HL, IY
;R: Zero wenn Verschmelzen/Freigeben klappte, NZero sonst
JoinBlock:	ADD	HL,BC		;Ende von Block A ausrechnen
		OR	A
		SBC	HL,DE		;mit Anfang von Block B vergleichen
		RET	NZ		;stimmt nicht -> fertig
	;Verschmelzen
		PUSH	DE
		POP	IY		;Block B
		LD	HL,(HeapPtr)
		OR	A
		SBC	HL,DE		;steht HeapPtr auf Block B?
		JR	Z,JoinBl1	;ja -> Heap verkleinern
		LD	A,(IY)		;Nachfolger von Block B als
		LD	(IX),A		;Nachfolger von Block A eintragen
		LD	A,(IY+01)
		LD	(IX+01),A
		LD	L,(IY+02)	;Laenge von Block B
		LD	H,(IY+03)
		ADD	HL,BC
		LD	(IX+02),L	;auf Laenge von Block A drauf
		LD	(IX+03),H
		XOR	A		;Zero setzen
		RET

JoinBl1: ;IX = Zeiger auf Block A
		PUSH	IX
		POP	HL
		LD	(HeapPtr),HL	;Anfang von Block A ist neues Heap-Ende
		LD	B,4		;Ende markieren
JoinBl2:	LD	(HL),0
		INC	HL
		DJNZ	JoinBl2		;Zero
		RET

;Memavail
;E: FreeRoot, RecurPtr, HeapPtr
;V: AF, BC, DE, HL, IX, MemVar3, MemVar4
;R: verfuegbarer Heap-Speicher in HL
MemAvail:	CALL	MAvail
		LD	HL,(MemVar3)
		RET

;Maxavail
;E:V: wie oben
;R: groesster zusammenhaengender Heap-Block in HL
MaxAvail:	CALL	MAvail
		LD	HL,(MemVar4)
		RET

;E: FreeRoot, RecurPtr, HeapPtr
;V: AF, BC, DE, HL, IX, MemVar3, MemVar4
;R: MemAvail in MemVar3, MaxAvail in MemVar4
MAvail:		LD	HL,0		;MemAvail und MaxAvail
		LD	(MemVar3),HL	;initialisieren
		LD	(MemVar4),HL
		LD	IX,(FreeRoot)	;Freispeicherliste
MAvail1:	LD	C,(IX+02)	;Groesse des freien Blocks
		LD	B,(IX+03)
		LD	A,C		;Ende der Liste?
		OR	B
		JR	Z,MAvail3	;ja -> nichtzugeord.Speicher dazutun
		LD	HL,(MemVar3)	;nein -> zaehle Block zu MemAvail
		ADD	HL,BC
		LD	(MemVar3),HL
		LD	HL,(MemVar4)	;vergleiche Groesse mit
		OR	A		;bisherigem MaxAvail
		SBC	HL,BC		;groesser?
		JR	NC,MAvail2	;nein -> weiter
		LD	(MemVar4),BC	;ja -> merke neues MaxAvail
MAvail2:	LD	L,(IX)		;Nachfolger wird akt. Block
		LD	H,(IX+01)
		PUSH	HL
		POP	IX
		JR	MAvail1

MAvail3: ;Freispeicherliste ist abgearbeitet. Jetzt nichtzugeordneten
	 ;Speicher zwischen Heap und Rekursionsstack beruecksichtigen.
		LD	HL,(RecurPtr)
		LD	BC,-5
		ADD	HL,BC
		LD	DE,(HeapPtr)
		OR	A		;noch genug Platz, um
		SBC	HL,DE		;einen Block einzurichten?
		RET	C		;nein -> fertig
		EX	DE,HL		;Platz dazwischen
		LD	HL,(MemVar3)	;zu MemAvail dazuzaehlen
		ADD	HL,DE
		LD	(MemVar3),HL
		LD	HL,(MemVar4)	;mit MaxAvail vergleichen
		OR	A
		SBC	HL,DE		;groesser?
		RET	NC		;nein -> fertig
		LD	(MemVar4),DE	;ja -> merke neues MaxAvail
		RET

;Mark
;E: Adresse einer Zeigervariablen in HL, HeapPtr
;V: DE, HL / R:-
;Bei Mark und Release wurde bei V2.0x einiges herumgepatcht, da Mark/Release
;und New/Dispose inkompatibel waren und somit nicht gemischt verwendet werden
;durften. V3.00 macht es jetzt richtig, und so aehnlich, wie es jetzt dort ist,
;sahen auch einige Patchvorschlaege aus. Siehe Leserbrief in c't 1 oder 2/86.
Mark:		LD	DE,(HeapPtr)
		LD	(HL),E
		INC	HL
		LD	(HL),D
		RET

;Release
;E: Adresse einer Zeigervariablen in HL
;V: F, B, DE, HL
;R: HeapPtr, FreeRoot
Release:	LD	E,(HL)
		INC	HL
		LD	D,(HL)
 IF TPVers2
		LD	(HeapPtr),DE
		RET
 ELSE	;TPVers3
		EX	DE,HL
;<fall through>

;E: neuer Wert fuer HeapPtr in HL
;V: F, B, HL
;R: HeapPtr, FreeRoot
;Neuen Wert fuer HeapPtr eintragen und leere Freiliste erzeugen
InitHeap:	LD	(HeapPtr),HL
		LD	(FreeRoot),HL
		LD	B,4		;Listenende erzeugen:
InitHeap1:	LD	(HL),0		;Nachfolger = NIL, Null Laenge
		INC	HL
		DJNZ	InitHeap1
		RET
;spart 8 Byte:
;InitHeap:	LD	(FreeRoot),HL
;		JP	JoinBl1+3
 ENDIF
ENDIF

;ENDE SPEICHERVERWALTUNG
;BEGINN DIVERSES

;STR-Prozedur (Umwandlung Zahl -> String)
;E: max. Stringlaenge in B, Zeiger auf String in HL
;   auf Stack: Anzahl Nachkomastellen, Feldbreite, REAL-Zahl
;V: AF, BC, DE, HL, IX, IY, Stack, StrPointer, StrLength, IORes,
;   OldFilePtr, FIOPC
;R:-
StrReal:	DEFB	3Eh		;LD A,0AFh

;E: max. Stringlaenge in B, Zeiger auf String in HL
;   auf Stack: Feldbreite, Integer-Zahl
;V: AF, BC, DE, HL, IX, Stack, StrPointer, StrLength, IORes,
;   OldFilePtr, FIOPC
;R:-
StrInt:		XOR	A		;0= Integer, <>0= Real
		LD	C,A		;Flag merken
		LD	(StrPointer),HL	;Zeiger auf String merken
		XOR	A
		LD	(HL),A		;ist leer
		LD	(IORes),A
		LD	A,B
		LD	(StrLength),A	;max. Laenge
IF TPVers3
		LD	HL,(FilePointer)
		LD	(OldFilePtr),HL	;FilePointer merken
ENDIF
		LD	HL,PseudoFIB
		LD	(FilePointer),HL
		POP	HL
		LD	(FIOPC),HL	;Returnadresse fuer Fehlerfall merken
		POP	HL		;Feldbreite (Int), Anz.Nachkommast.(Real)
		INC	C
		DEC	C		;Integer?
		JR	NZ,StrIntReal	;nein -> REAL
		CALL	WriteInt
		JR	StrValIR

StrIntReal:	CALL	WriteReal
StrValIR:
IF TPVers3
		LD	HL,(OldFilePtr)	;FilePointer wiederherstellen
		LD	(FilePointer),HL
ENDIF
		LD	HL,(FIOPC)	;gemerkte Returnadresse
		JP	(HL)

;val(s:STRING; VAR v:INT/REAL; VAR c:INT)
;E: Zeiger auf c in HL, Zeiger auf v sowie s auf Stack
;V: AF, BC, DE, HL, IX, Stack, ValFlag, ValResult, ValPointer,
;   OldFilePtr, FIOPC
;R:-
ValReal:	DEFB	3Eh		;LD A,0AFh

;E:V:R: wie ValReal
ValInt:		XOR	A		;0= Integer, <>0= Real
		LD	(ValFlag),A	;Flag merken
		LD	(ValResult),HL	;Zeiger auf c merken
IF TPVers3
		LD	HL,(FilePointer) ;FilePointer merken
		LD	(OldFilePtr),HL
ENDIF
		LD	HL,PseudoFIB
		LD	(FilePointer),HL
		POP	HL
		LD	(FIOPC),HL	;Returnadresse fuer Fehlerfall merken
		POP	HL
		LD	(ValPointer),HL	;Zeiger auf v merken
		LD	HL,ConvBuf-1	;so tun, als sei der String
		LD	B,30		;in den ConvBuf eingelesen worden
		CALL	StoreString
		XOR	A		;String terminieren
		LD	(DE),A
		LD	HL,(ValPointer)	;Zeiger auf v
		LD	A,(ValFlag)
		OR	A		;Integer?
		JR	NZ,ValIntReal1	;nein -> REAL
		CALL	ReadInt
		JR	ValIntReal2

ValIntReal1:	CALL	ReadReal
ValIntReal2:	LD	HL,IORes	;schauen, obs geklappt hat
		LD	A,(HL)
		LD	(HL),0		;und Fehler loeschen
		OR	A
		LD	H,A		;wenn ja, dann HL := 0
		LD	L,A
		JR	Z,ValIntReal3	;und Ergebnis melden
		PUSH	IX
		POP	HL		;Zeiger auf erstes fehlerhaftes
		LD	DE,ConvBuf-1	;Zeichen holen
		SBC	HL,DE		;und Abstand zum Stringanfang berechnen
ValIntReal3: ;HL nach c schreiben
		EX	DE,HL
		LD	HL,(ValResult)	;gemerkter Zeiger auf c
		LD	(HL),E
		INC	HL
		LD	(HL),D
		JR	StrValIR

IF (TPVers1 OR TPVers2)
PseudoFIB:	DEFB	03h,0FFh,0	;FIB fuer Pseudogeraet -1 (STR/VAL)
ELSE	;TPVers3
PseudoFIB:	DEFB	0C6h,0		;FIB fuer Pseudogeraet 6 (STR/VAL)
ENDIF

;E:- / V: A / R:-
Randomize:	LD	A,R
		LD	(Seed+3),A
		RET

;fillchar(var x:irgendeine Variable; n:INT; w:CHAR)
;E: w in (H)L, n und Adresse von x auf Stack
;V: AF, BC, DE, HL, IX / R:-
FillChar:	EX	DE,HL		;w nach (D)E
		POP	IX		;Returnadresse
		POP	BC		;n
		POP	HL		;Adresse von x
		LD	A,B
		OR	C		;n=0?
		JR	Z,FillMove2	;ja -> fertig
		LD	(HL),E		;ein Zeichen schreiben
		DEC	BC		;eines ist schon
		LD	A,B		;wars das?
		OR	C
		JR	Z,FillMove2	;ja -> fertig
		LD	D,H		;nein -> kopiere
		LD	E,L		;dieses Zeichen n-1 mal (das ist
		INC	DE		;nicht gerade die schnellste Methode!)
FillMove1:	LDIR
FillMove2:	JP	(IX)

;move(var v1,v2:irgendeine Variable; n:INT)
;E: n in HL, Adressen von v1 und v2 auf Stack
;V: AF, BC, DE, HL, IX / R:-
Move:		LD	B,H		;n nach BC
		LD	C,L
		POP	IX		;Returndresse
		POP	DE		;Adresse von v2
		POP	HL		;Adresse von v1
IF (TPVers1 OR TPVers2)
		OR	A
ELSE	;TPVers3
		LD	A,B
		OR	C		;n=0?
		JR	Z,FillMove2	;ja -> fertig
ENDIF
		SBC	HL,DE		;NCarry wegen OR C
		ADD	HL,DE		;Zieladresse kleiner gleich Quelladresse?
		JR	NC,FillMove1	;ja -> LDIR geht problemlos
	;Zieladresse groesser als Quelladresse. Hier muss von
	;hinten her kopiert werden, sonst geht es in die Hose
	;(wir koennten etwas ueberschreiben, was wir noch nicht kopiert haben)
		DEC	BC
		ADD	HL,BC		;auf letztes Byte richten (Ziel)
		EX	DE,HL
		ADD	HL,BC		;dito (Quelle)
		EX	DE,HL
		INC	BC
		LDDR			;kopieren
		JP	(IX)

IF TPVers3
;Paramstr(i : INT) : STRING[64];
;E: Nummer des gewuenschten Parameters in (H)L
;V: AF, BC, DE, HL, IX / R:-
.COMMENT %----------------------------------------------------------------
STRING[64] ist Kaese! Erstens ist die Kommandozeile bei V3.0x eh nur max.
31 Zeichen lang und zweitens ist es ParamCnt1 egal, wie lang die Parameter
sind. Wenn die Kommandozeile durch Patchen verlaengert wird, kann durchaus
ein laengerer String zurueckgegeben werden.

Thema nichtspezifierter Fall, dass i=0 ist:
Was soll das denn werden?
Also, hier wird auf i=0 geprueft, und wenn dem so ist, der Aufruf von
ParamCnt1 uebersprungen. Soso. Bloss, was steht denn dann in A? Hoechstens
zufaellig eine 0! Und wenn nicht? Dann wird ein String der Laenge A von DE
geholt und zurueckgeliefert. Moment mal - D ist ja 0, aber was steht denn
in E? Das ist gequirlte Kacke! Hier wird ein x-beliebiger String geliefert!
Wenn die Abfrage auf 0 ganz weggelassen worden waere, dann wuerde von
ParamCnt1 der letzte Parameter geliefert werden (oder Leerstring, wenn gar
kein Parameter da). Das waere immer noch sinnvoller als das, was jetzt ist!
Genauso lang, aber meiner Meinung nach wesentlich besser, ist:
ParamStr:	LD	A,L
		OR	A
		JR	Z,ParamStr1
		LD	D,A
Hier wird im Falle i=0 definitiv ein Leerstring zurueckgegeben.
----------------------------------------------------------------% ;COMMENT
ParamStr:	LD	D,L
		INC	D
		DEC	D		;ParamStr(0)?
		JR	Z,ParamStr1	;ja -> ??
		CALL	ParamCnt1	;sonst Position ermitteln
ParamStr1:	POP	IX		;Returnadresse
		LD	C,A		;Laenge des Parameters
		LD	B,0		;fuer LDIR (s.u.)
		CPL			;Platz auf Stack machen
		LD	L,A		;(ein Byte mehr als Laenge)
		LD	H,0FFh
		ADD	HL,SP
		LD	SP,HL
		LD	(HL),C		;Laenge eintragen
		INC	HL
		EX	DE,HL
		INC	C
		DEC	C		;Leerer String?
		JR	Z,ParamStr2	;dann nichts kopieren
		LDIR
ParamStr2:	JP	(IX)		;zurueck

;Paramcount : INT;
;E:-
;V: AF, BC, DE, HL
;R: Anzahl Parameter in HL
ParamCount:	LD	D,0
;<fall through>

;E: Anzahl zu scannender Parameter in D (0 entspricht 256, also alle)
;V: AF, BC, DE, HL
;R: Anzahl gescannter Parameter in HL
;   wenn es mind. D Parameter gab: Zeiger auf Anfang des zuletzt gescannten
;	Parameters in DE, Laenge in A
;   sonst: 0 in A
ParamCnt1:	LD	HL,CmdLine
	;PATCH>> lange Kommandozeile siehe Info 31-13f
	;PATCH>> LD HL,(0040h)
		LD	A,31
	;PATCH>> LD A,7Fh
		LD	B,(HL)		;Laenge der Kommandozeile holen
		CP	B		;groesser als 31? (was darueber hinaus
		JR	NC,ParamCnt2	;geht, ist bereits von den Turbo Pascal
		LD	B,31		;Variablen ueberschrieben). Also kuerzen
	;PATCH>> LD B,7Fh		;LD B,A waere besser
ParamCnt2:	INC	HL		;auf erstes Zeichen
		LD	C,0		;Anzahl gefundener Parameter init.
ParamCnt3: ;scanne fuehrende Spaces und Tabs
		INC	B
		DEC	B		;noch was da?
		JR	Z,ParamCnt5	;nein -> weiter
		LD	A,(HL)
		CP	' '
		JR	Z,ParamCnt4
		CP	TAB
		JR	NZ,ParamCnt5
ParamCnt4:	INC	HL
		DEC	B
		JR	ParamCnt3

ParamCnt5:	LD	E,L		;Stelle merken, wo Parameter anfaengt
ParamCnt6: ;scanne Parameter
		INC	B
		DEC	B		;noch was da?
		JR	Z,ParamCnt7	;nein -> weiter
		LD	A,(HL)
		CP	' '
		JR	Z,ParamCnt7
		CP	TAB
		JR	Z,ParamCnt7
		INC	HL
		DEC	B
		JR	ParamCnt6

ParamCnt7:	LD	A,L		;haben wir einen Parameter
		SUB	E		;ueberlesen?
		JR	Z,ParamCnt8	;nein -> war keiner (mehr) da
		INC	C		;ja, Zaehler erhoehen
		DEC	D		;sollen wir aufhoeren?
		JR	NZ,ParamCnt3	;nein -> weiterscannen
	;D ist jetzt =0, bildet mit E Zeiger auf Anfang des zuletzt
	;gescannten Parameters (sofern es einen gibt)
ParamCnt8:	LD	L,C		;liefere Anzahl Parameter in HL
		LD	H,0		;fuer ParamCount,
		LD	D,H		;gemerkte Stelle in E fuer ParamStr
	;PATCH>> LD D,H
	;PATCH>> LD H,0
		RET
.COMMENT %----------------------------------------------------------------
Dieser Patch ist gefaehrlich! Die Kommandozeile ist irgendwohin kopiert
worden und kann daher ueber einer Pagegrenze liegen. Wenn nun der zuletzt
gescannte Parameter dummerweise ueber einer Pagegrenze liegt, dann
ist H um eins zu gross, denn HL zeigt hinter das Ende des Parameters,
und damit in die naechste Page, waerend in E das LowByte der Anfangs-
adresse des Parameters ist!
----------------------------------------------------------------% ;COMMENT
ENDIF

;E: X auf Stack (unter Returnadresse), Y in HL
;V: F, BC, DE, HL / R:-
GotoXY:		POP	DE		;Returnadresse runter
		POP	BC		;X holen
		PUSH	DE		;Ret.Adr. wieder drauf
		DEC	L
		LD	H,C		;H = X, L = Y
		DEC	H		;Korrigieren (linke obere
		JP	CsrXY		;Ecke ist 1,1 bei GotoXY)

;E: Zeichen in HL
;V: AF, L
;R: UpCase(Zeichen) in HL
UpCase:		LD	A,L
		CALL	ToUpper
		LD	L,A
		RET

;Bios, BiosHL
;E: BIOS-Funktion in DE, Parameter in BC
;V: HL
;R: Ergebnis in A/HL
Bios:		LD	HL,(WBoot+1)
		ADD	HL,DE		;mal 3
		ADD	HL,DE
		ADD	HL,DE
		JP	(HL)

;E:- / V: AF, HL / R: IORes in HL
IOResult:	LD	HL,IORes
		LD	A,(HL)		;Wert holen und
		LD	(HL),0		;loeschen
		LD	L,A		;vorzeichenlos erweitern
		LD	H,0
		RET

;ENDE DIVERSES
;BEGINN ERRORHANDLER

IF (TPVers1 OR TPVers2)

BreakHandler:	CALL	ConSta		;Taste gedrueckt?
		LD	A,H
		OR	L
		RET	Z		;nein -> weiter im Programm
		CALL	ConInp		;gedrueckte Taste holen
		LD	A,L
		CP	CtlC		;war es Control-C?
		RET	NZ		;nein -> ignoriere es
		POP	IX		;Returnadresse (=PC) nach IX
UserBreak:	CALL	Print
		DEFB	'^C',CR,LF,'User break',0
		JR	Error2

;Checke IORes
ChkIORes:	LD	A,(IORes)
		OR	A		;=0?
		RET	Z		;ja -> ok
		POP	IX		;nein -> Abbruch
		PUSH	AF
		CALL	Print
		DEFB	CR,LF,'I/O',0
		JR	Error1

RunTimErrX:	POP	IX
RunTimErr:	CALL	Print
		DEFB	CR,LF,'Run-time',0
Error1:		CALL	Print
		DEFB	' error ',0
		CALL	HexB		;Fehlernummer
Error2:		CALL	Print
		DEFB	', PC=',0
		PUSH	IX		;selbst einen Fehler? *)
		POP	HL		;absolute Fehlerposition (=PC) nach HL
		LD	DE,(ProgStart)
		OR	A
		SBC	HL,DE
		LD	DE,21		;Laenge des Programm-Initialisierungsteils
		ADD	HL,DE
		LD	(RelErrPos),HL
		CALL	HexW
		CALL	Print
		DEFB	CR,LF,'Program aborted',0
HaltProgram:	LD	HL,(ContAdr)
		JP	(HL)

ELSE	;TPVers3

BreakHandler:	CALL	@ConSta		;Taste gedrueckt?
		LD	A,H
		OR	L
		RET	Z		;nein -> weiter im Programm
		LD	A,(CBreak)
		PUSH	AF
		XOR	A		;schalte CBreak ab (verhindere
		LD	(CBreak),A	;unendlichen rekursiven Aufruf)
		CALL	@ConInp		;gedrueckte Taste holen
		POP	AF
		LD	(CBreak),A	;CBreak auf urspruenglichen Wert
		LD	A,L
		CP	CtlC		;war es Control-C?
		RET	NZ		;nein -> ignoriere es
		POP	IX		;Returnadresse (=PC) nach IX
UserBreak:	LD	DE,1		;D=0 ^C User break
		JR	ERROR

;Checke IORes
ChkIORes:	LD	A,(IORes)
		OR	A		;=0?
		RET	Z		;ja -> ok
		POP	IX		;nein -> Abbruch
		LD	E,A
		LD	D,1		;D=1 I/O Error
		JR	ERROR

RunTimErrX:	POP	IX
RunTimErr:	LD	E,A
		LD	D,2		;D=2 RunTime Error
;<fall through>

ERROR:		PUSH	DE
		CALL	DefaultIO
		POP	DE
		XOR	A		;schalte CBreak ab (verhindere
		LD	(CBreak),A	;unendlichen rekursiven Aufruf)
		LD	HL,(RelErrPos)
		LD	A,H		;Fehlerposition schon gesetzt?
		OR	L		;d.h. verursachte der ErrorHandler
		PUSH	IX		;selbst einen Fehler? *)
		POP	HL		;absolute Fehlerposition (=PC) nach HL
		LD	BC,(ProgStart)
		SBC	HL,BC
		LD	BC,21		;Laenge des Programm-Initialisierungsteils
		ADD	HL,BC
		LD	(RelErrPos),HL
		OR	A		;*) wenn ja -> nicht mehr den ErrorHandler
		JR	NZ,Error1	;aktivieren, da sonst Endlosschleife!
		PUSH	DE
		PUSH	DE
		PUSH	HL
		CALL	ErrEntry
		POP	DE
Error1:		LD	A,D		;Fehlertyp
		OR	A		;=0 (User break)?
		JR	NZ,Error2	;nein -> anderer Fehler
		CALL	Print
		DEFB	'^C',CR,LF,'User break',0
		JR	Error5

Error2:		DEC	A		;=1 (I/O Error)?
		JR	NZ,Error3	;nein -> muss RunTime Error sein
		CALL	Print
		DEFB	CR,LF,'I/O',0
		JR	Error4

Error3:		CALL	Print
		DEFB	CR,LF,'Run-time',0
Error4:		CALL	Print
		DEFB	' error ',0
		LD	A,E		;Fehlernummer
		CALL	HexB
Error5:		CALL	Print
		DEFB	', PC=',0
		LD	HL,(RelErrPos)
		CALL	HexW
		JR	Error6

OutOfMem:	CALL	Print
		DEFB	'Not enough memory',0
Error6:		CALL	Print
		DEFB	CR,LF,'Program aborted',CR,LF,0

HaltProgram:	LD	A,(StandAlone)
	;manche Memotech MTX User patchen hier CALL 010Dh hin und
	;dort LD C,CtlX / CALL 0F400h / LD A,(StandAlone) / RET
	;0F400h ist beim MTX die Bildschirmausgabe, ^X bewirkt ein
	;Ruecksetzen der Attribute auf Defaultwerte
		OR	A
		JP	Z,TPCompiler
		JP	WBoot		;siehe CHIP SPECIAL 4, S.67

ErrHandler:	POP	HL		;Dummy, entfernt
		POP	DE		;nur die beiden
		POP	DE		;Uebergabeparameter
		JP	(HL)

ENDIF

PascalProgram:

;ENDE TP-RTL8.INC
;----------------
